package mocks

// Code generated by http://github.com/gojuno/minimock (dev). DO NOT EDIT.

//go:generate minimock -i git.dmitriygnatenko.ru/dima/homethings/internal/interfaces.IFileRepository -o ./mocks/i_file_repository_minimock.go -n IFileRepositoryMock

import (
	"mime/multipart"
	"sync"
	mm_atomic "sync/atomic"
	mm_time "time"

	"github.com/gofiber/fiber/v2"
	"github.com/gojuno/minimock/v3"
)

// IFileRepositoryMock implements interfaces.IFileRepository
type IFileRepositoryMock struct {
	t minimock.Tester

	funcDelete          func(path string) (err error)
	inspectFuncDelete   func(path string)
	afterDeleteCounter  uint64
	beforeDeleteCounter uint64
	DeleteMock          mIFileRepositoryMockDelete

	funcSave          func(fctx *fiber.Ctx, header *multipart.FileHeader, path string) (err error)
	inspectFuncSave   func(fctx *fiber.Ctx, header *multipart.FileHeader, path string)
	afterSaveCounter  uint64
	beforeSaveCounter uint64
	SaveMock          mIFileRepositoryMockSave
}

// NewIFileRepositoryMock returns a mock for interfaces.IFileRepository
func NewIFileRepositoryMock(t minimock.Tester) *IFileRepositoryMock {
	m := &IFileRepositoryMock{t: t}
	if controller, ok := t.(minimock.MockController); ok {
		controller.RegisterMocker(m)
	}

	m.DeleteMock = mIFileRepositoryMockDelete{mock: m}
	m.DeleteMock.callArgs = []*IFileRepositoryMockDeleteParams{}

	m.SaveMock = mIFileRepositoryMockSave{mock: m}
	m.SaveMock.callArgs = []*IFileRepositoryMockSaveParams{}

	return m
}

type mIFileRepositoryMockDelete struct {
	mock               *IFileRepositoryMock
	defaultExpectation *IFileRepositoryMockDeleteExpectation
	expectations       []*IFileRepositoryMockDeleteExpectation

	callArgs []*IFileRepositoryMockDeleteParams
	mutex    sync.RWMutex
}

// IFileRepositoryMockDeleteExpectation specifies expectation struct of the IFileRepository.Delete
type IFileRepositoryMockDeleteExpectation struct {
	mock    *IFileRepositoryMock
	params  *IFileRepositoryMockDeleteParams
	results *IFileRepositoryMockDeleteResults
	Counter uint64
}

// IFileRepositoryMockDeleteParams contains parameters of the IFileRepository.Delete
type IFileRepositoryMockDeleteParams struct {
	path string
}

// IFileRepositoryMockDeleteResults contains results of the IFileRepository.Delete
type IFileRepositoryMockDeleteResults struct {
	err error
}

// Expect sets up expected params for IFileRepository.Delete
func (mmDelete *mIFileRepositoryMockDelete) Expect(path string) *mIFileRepositoryMockDelete {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("IFileRepositoryMock.Delete mock is already set by Set")
	}

	if mmDelete.defaultExpectation == nil {
		mmDelete.defaultExpectation = &IFileRepositoryMockDeleteExpectation{}
	}

	mmDelete.defaultExpectation.params = &IFileRepositoryMockDeleteParams{path}
	for _, e := range mmDelete.expectations {
		if minimock.Equal(e.params, mmDelete.defaultExpectation.params) {
			mmDelete.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmDelete.defaultExpectation.params)
		}
	}

	return mmDelete
}

// Inspect accepts an inspector function that has same arguments as the IFileRepository.Delete
func (mmDelete *mIFileRepositoryMockDelete) Inspect(f func(path string)) *mIFileRepositoryMockDelete {
	if mmDelete.mock.inspectFuncDelete != nil {
		mmDelete.mock.t.Fatalf("Inspect function is already set for IFileRepositoryMock.Delete")
	}

	mmDelete.mock.inspectFuncDelete = f

	return mmDelete
}

// Return sets up results that will be returned by IFileRepository.Delete
func (mmDelete *mIFileRepositoryMockDelete) Return(err error) *IFileRepositoryMock {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("IFileRepositoryMock.Delete mock is already set by Set")
	}

	if mmDelete.defaultExpectation == nil {
		mmDelete.defaultExpectation = &IFileRepositoryMockDeleteExpectation{mock: mmDelete.mock}
	}
	mmDelete.defaultExpectation.results = &IFileRepositoryMockDeleteResults{err}
	return mmDelete.mock
}

// Set uses given function f to mock the IFileRepository.Delete method
func (mmDelete *mIFileRepositoryMockDelete) Set(f func(path string) (err error)) *IFileRepositoryMock {
	if mmDelete.defaultExpectation != nil {
		mmDelete.mock.t.Fatalf("Default expectation is already set for the IFileRepository.Delete method")
	}

	if len(mmDelete.expectations) > 0 {
		mmDelete.mock.t.Fatalf("Some expectations are already set for the IFileRepository.Delete method")
	}

	mmDelete.mock.funcDelete = f
	return mmDelete.mock
}

// When sets expectation for the IFileRepository.Delete which will trigger the result defined by the following
// Then helper
func (mmDelete *mIFileRepositoryMockDelete) When(path string) *IFileRepositoryMockDeleteExpectation {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("IFileRepositoryMock.Delete mock is already set by Set")
	}

	expectation := &IFileRepositoryMockDeleteExpectation{
		mock:   mmDelete.mock,
		params: &IFileRepositoryMockDeleteParams{path},
	}
	mmDelete.expectations = append(mmDelete.expectations, expectation)
	return expectation
}

// Then sets up IFileRepository.Delete return parameters for the expectation previously defined by the When method
func (e *IFileRepositoryMockDeleteExpectation) Then(err error) *IFileRepositoryMock {
	e.results = &IFileRepositoryMockDeleteResults{err}
	return e.mock
}

// Delete implements interfaces.IFileRepository
func (mmDelete *IFileRepositoryMock) Delete(path string) (err error) {
	mm_atomic.AddUint64(&mmDelete.beforeDeleteCounter, 1)
	defer mm_atomic.AddUint64(&mmDelete.afterDeleteCounter, 1)

	if mmDelete.inspectFuncDelete != nil {
		mmDelete.inspectFuncDelete(path)
	}

	mm_params := &IFileRepositoryMockDeleteParams{path}

	// Record call args
	mmDelete.DeleteMock.mutex.Lock()
	mmDelete.DeleteMock.callArgs = append(mmDelete.DeleteMock.callArgs, mm_params)
	mmDelete.DeleteMock.mutex.Unlock()

	for _, e := range mmDelete.DeleteMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmDelete.DeleteMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmDelete.DeleteMock.defaultExpectation.Counter, 1)
		mm_want := mmDelete.DeleteMock.defaultExpectation.params
		mm_got := IFileRepositoryMockDeleteParams{path}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmDelete.t.Errorf("IFileRepositoryMock.Delete got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmDelete.DeleteMock.defaultExpectation.results
		if mm_results == nil {
			mmDelete.t.Fatal("No results are set for the IFileRepositoryMock.Delete")
		}
		return (*mm_results).err
	}
	if mmDelete.funcDelete != nil {
		return mmDelete.funcDelete(path)
	}
	mmDelete.t.Fatalf("Unexpected call to IFileRepositoryMock.Delete. %v", path)
	return
}

// DeleteAfterCounter returns a count of finished IFileRepositoryMock.Delete invocations
func (mmDelete *IFileRepositoryMock) DeleteAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmDelete.afterDeleteCounter)
}

// DeleteBeforeCounter returns a count of IFileRepositoryMock.Delete invocations
func (mmDelete *IFileRepositoryMock) DeleteBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmDelete.beforeDeleteCounter)
}

// Calls returns a list of arguments used in each call to IFileRepositoryMock.Delete.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmDelete *mIFileRepositoryMockDelete) Calls() []*IFileRepositoryMockDeleteParams {
	mmDelete.mutex.RLock()

	argCopy := make([]*IFileRepositoryMockDeleteParams, len(mmDelete.callArgs))
	copy(argCopy, mmDelete.callArgs)

	mmDelete.mutex.RUnlock()

	return argCopy
}

// MinimockDeleteDone returns true if the count of the Delete invocations corresponds
// the number of defined expectations
func (m *IFileRepositoryMock) MinimockDeleteDone() bool {
	for _, e := range m.DeleteMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.DeleteMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcDelete != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		return false
	}
	return true
}

// MinimockDeleteInspect logs each unmet expectation
func (m *IFileRepositoryMock) MinimockDeleteInspect() {
	for _, e := range m.DeleteMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IFileRepositoryMock.Delete with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.DeleteMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		if m.DeleteMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IFileRepositoryMock.Delete")
		} else {
			m.t.Errorf("Expected call to IFileRepositoryMock.Delete with params: %#v", *m.DeleteMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcDelete != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		m.t.Error("Expected call to IFileRepositoryMock.Delete")
	}
}

type mIFileRepositoryMockSave struct {
	mock               *IFileRepositoryMock
	defaultExpectation *IFileRepositoryMockSaveExpectation
	expectations       []*IFileRepositoryMockSaveExpectation

	callArgs []*IFileRepositoryMockSaveParams
	mutex    sync.RWMutex
}

// IFileRepositoryMockSaveExpectation specifies expectation struct of the IFileRepository.Save
type IFileRepositoryMockSaveExpectation struct {
	mock    *IFileRepositoryMock
	params  *IFileRepositoryMockSaveParams
	results *IFileRepositoryMockSaveResults
	Counter uint64
}

// IFileRepositoryMockSaveParams contains parameters of the IFileRepository.Save
type IFileRepositoryMockSaveParams struct {
	fctx   *fiber.Ctx
	header *multipart.FileHeader
	path   string
}

// IFileRepositoryMockSaveResults contains results of the IFileRepository.Save
type IFileRepositoryMockSaveResults struct {
	err error
}

// Expect sets up expected params for IFileRepository.Save
func (mmSave *mIFileRepositoryMockSave) Expect(fctx *fiber.Ctx, header *multipart.FileHeader, path string) *mIFileRepositoryMockSave {
	if mmSave.mock.funcSave != nil {
		mmSave.mock.t.Fatalf("IFileRepositoryMock.Save mock is already set by Set")
	}

	if mmSave.defaultExpectation == nil {
		mmSave.defaultExpectation = &IFileRepositoryMockSaveExpectation{}
	}

	mmSave.defaultExpectation.params = &IFileRepositoryMockSaveParams{fctx, header, path}
	for _, e := range mmSave.expectations {
		if minimock.Equal(e.params, mmSave.defaultExpectation.params) {
			mmSave.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmSave.defaultExpectation.params)
		}
	}

	return mmSave
}

// Inspect accepts an inspector function that has same arguments as the IFileRepository.Save
func (mmSave *mIFileRepositoryMockSave) Inspect(f func(fctx *fiber.Ctx, header *multipart.FileHeader, path string)) *mIFileRepositoryMockSave {
	if mmSave.mock.inspectFuncSave != nil {
		mmSave.mock.t.Fatalf("Inspect function is already set for IFileRepositoryMock.Save")
	}

	mmSave.mock.inspectFuncSave = f

	return mmSave
}

// Return sets up results that will be returned by IFileRepository.Save
func (mmSave *mIFileRepositoryMockSave) Return(err error) *IFileRepositoryMock {
	if mmSave.mock.funcSave != nil {
		mmSave.mock.t.Fatalf("IFileRepositoryMock.Save mock is already set by Set")
	}

	if mmSave.defaultExpectation == nil {
		mmSave.defaultExpectation = &IFileRepositoryMockSaveExpectation{mock: mmSave.mock}
	}
	mmSave.defaultExpectation.results = &IFileRepositoryMockSaveResults{err}
	return mmSave.mock
}

// Set uses given function f to mock the IFileRepository.Save method
func (mmSave *mIFileRepositoryMockSave) Set(f func(fctx *fiber.Ctx, header *multipart.FileHeader, path string) (err error)) *IFileRepositoryMock {
	if mmSave.defaultExpectation != nil {
		mmSave.mock.t.Fatalf("Default expectation is already set for the IFileRepository.Save method")
	}

	if len(mmSave.expectations) > 0 {
		mmSave.mock.t.Fatalf("Some expectations are already set for the IFileRepository.Save method")
	}

	mmSave.mock.funcSave = f
	return mmSave.mock
}

// When sets expectation for the IFileRepository.Save which will trigger the result defined by the following
// Then helper
func (mmSave *mIFileRepositoryMockSave) When(fctx *fiber.Ctx, header *multipart.FileHeader, path string) *IFileRepositoryMockSaveExpectation {
	if mmSave.mock.funcSave != nil {
		mmSave.mock.t.Fatalf("IFileRepositoryMock.Save mock is already set by Set")
	}

	expectation := &IFileRepositoryMockSaveExpectation{
		mock:   mmSave.mock,
		params: &IFileRepositoryMockSaveParams{fctx, header, path},
	}
	mmSave.expectations = append(mmSave.expectations, expectation)
	return expectation
}

// Then sets up IFileRepository.Save return parameters for the expectation previously defined by the When method
func (e *IFileRepositoryMockSaveExpectation) Then(err error) *IFileRepositoryMock {
	e.results = &IFileRepositoryMockSaveResults{err}
	return e.mock
}

// Save implements interfaces.IFileRepository
func (mmSave *IFileRepositoryMock) Save(fctx *fiber.Ctx, header *multipart.FileHeader, path string) (err error) {
	mm_atomic.AddUint64(&mmSave.beforeSaveCounter, 1)
	defer mm_atomic.AddUint64(&mmSave.afterSaveCounter, 1)

	if mmSave.inspectFuncSave != nil {
		mmSave.inspectFuncSave(fctx, header, path)
	}

	mm_params := &IFileRepositoryMockSaveParams{fctx, header, path}

	// Record call args
	mmSave.SaveMock.mutex.Lock()
	mmSave.SaveMock.callArgs = append(mmSave.SaveMock.callArgs, mm_params)
	mmSave.SaveMock.mutex.Unlock()

	for _, e := range mmSave.SaveMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmSave.SaveMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmSave.SaveMock.defaultExpectation.Counter, 1)
		mm_want := mmSave.SaveMock.defaultExpectation.params
		mm_got := IFileRepositoryMockSaveParams{fctx, header, path}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmSave.t.Errorf("IFileRepositoryMock.Save got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmSave.SaveMock.defaultExpectation.results
		if mm_results == nil {
			mmSave.t.Fatal("No results are set for the IFileRepositoryMock.Save")
		}
		return (*mm_results).err
	}
	if mmSave.funcSave != nil {
		return mmSave.funcSave(fctx, header, path)
	}
	mmSave.t.Fatalf("Unexpected call to IFileRepositoryMock.Save. %v %v %v", fctx, header, path)
	return
}

// SaveAfterCounter returns a count of finished IFileRepositoryMock.Save invocations
func (mmSave *IFileRepositoryMock) SaveAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmSave.afterSaveCounter)
}

// SaveBeforeCounter returns a count of IFileRepositoryMock.Save invocations
func (mmSave *IFileRepositoryMock) SaveBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmSave.beforeSaveCounter)
}

// Calls returns a list of arguments used in each call to IFileRepositoryMock.Save.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmSave *mIFileRepositoryMockSave) Calls() []*IFileRepositoryMockSaveParams {
	mmSave.mutex.RLock()

	argCopy := make([]*IFileRepositoryMockSaveParams, len(mmSave.callArgs))
	copy(argCopy, mmSave.callArgs)

	mmSave.mutex.RUnlock()

	return argCopy
}

// MinimockSaveDone returns true if the count of the Save invocations corresponds
// the number of defined expectations
func (m *IFileRepositoryMock) MinimockSaveDone() bool {
	for _, e := range m.SaveMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.SaveMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterSaveCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcSave != nil && mm_atomic.LoadUint64(&m.afterSaveCounter) < 1 {
		return false
	}
	return true
}

// MinimockSaveInspect logs each unmet expectation
func (m *IFileRepositoryMock) MinimockSaveInspect() {
	for _, e := range m.SaveMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IFileRepositoryMock.Save with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.SaveMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterSaveCounter) < 1 {
		if m.SaveMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IFileRepositoryMock.Save")
		} else {
			m.t.Errorf("Expected call to IFileRepositoryMock.Save with params: %#v", *m.SaveMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcSave != nil && mm_atomic.LoadUint64(&m.afterSaveCounter) < 1 {
		m.t.Error("Expected call to IFileRepositoryMock.Save")
	}
}

// MinimockFinish checks that all mocked methods have been called the expected number of times
func (m *IFileRepositoryMock) MinimockFinish() {
	if !m.minimockDone() {
		m.MinimockDeleteInspect()

		m.MinimockSaveInspect()
		m.t.FailNow()
	}
}

// MinimockWait waits for all mocked methods to be called the expected number of times
func (m *IFileRepositoryMock) MinimockWait(timeout mm_time.Duration) {
	timeoutCh := mm_time.After(timeout)
	for {
		if m.minimockDone() {
			return
		}
		select {
		case <-timeoutCh:
			m.MinimockFinish()
			return
		case <-mm_time.After(10 * mm_time.Millisecond):
		}
	}
}

func (m *IFileRepositoryMock) minimockDone() bool {
	done := true
	return done &&
		m.MinimockDeleteDone() &&
		m.MinimockSaveDone()
}
