package mocks

// Code generated by http://github.com/gojuno/minimock (dev). DO NOT EDIT.

//go:generate minimock -i git.dmitriygnatenko.ru/dima/homethings/internal/interfaces.IPlaceImageRepository -o ./mocks/i_place_image_repository_minimock.go -n IPlaceImageRepositoryMock

import (
	"context"
	"database/sql"
	"sync"
	mm_atomic "sync/atomic"
	mm_time "time"

	"git.dmitriygnatenko.ru/dima/homethings/internal/models"
	"github.com/gojuno/minimock/v3"
)

// IPlaceImageRepositoryMock implements interfaces.IPlaceImageRepository
type IPlaceImageRepositoryMock struct {
	t minimock.Tester

	funcAdd          func(ctx context.Context, req models.AddPlaceImageRequest, tx *sql.Tx) (err error)
	inspectFuncAdd   func(ctx context.Context, req models.AddPlaceImageRequest, tx *sql.Tx)
	afterAddCounter  uint64
	beforeAddCounter uint64
	AddMock          mIPlaceImageRepositoryMockAdd

	funcBeginTx          func(ctx context.Context, level sql.IsolationLevel) (tp1 *sql.Tx, err error)
	inspectFuncBeginTx   func(ctx context.Context, level sql.IsolationLevel)
	afterBeginTxCounter  uint64
	beforeBeginTxCounter uint64
	BeginTxMock          mIPlaceImageRepositoryMockBeginTx

	funcCommitTx          func(tx *sql.Tx) (err error)
	inspectFuncCommitTx   func(tx *sql.Tx)
	afterCommitTxCounter  uint64
	beforeCommitTxCounter uint64
	CommitTxMock          mIPlaceImageRepositoryMockCommitTx

	funcDelete          func(ctx context.Context, imageID int, tx *sql.Tx) (err error)
	inspectFuncDelete   func(ctx context.Context, imageID int, tx *sql.Tx)
	afterDeleteCounter  uint64
	beforeDeleteCounter uint64
	DeleteMock          mIPlaceImageRepositoryMockDelete

	funcGet          func(ctx context.Context, imageID int) (ip1 *models.Image, err error)
	inspectFuncGet   func(ctx context.Context, imageID int)
	afterGetCounter  uint64
	beforeGetCounter uint64
	GetMock          mIPlaceImageRepositoryMockGet

	funcGetByPlaceID          func(ctx context.Context, placeID int) (ia1 []models.Image, err error)
	inspectFuncGetByPlaceID   func(ctx context.Context, placeID int)
	afterGetByPlaceIDCounter  uint64
	beforeGetByPlaceIDCounter uint64
	GetByPlaceIDMock          mIPlaceImageRepositoryMockGetByPlaceID
}

// NewIPlaceImageRepositoryMock returns a mock for interfaces.IPlaceImageRepository
func NewIPlaceImageRepositoryMock(t minimock.Tester) *IPlaceImageRepositoryMock {
	m := &IPlaceImageRepositoryMock{t: t}
	if controller, ok := t.(minimock.MockController); ok {
		controller.RegisterMocker(m)
	}

	m.AddMock = mIPlaceImageRepositoryMockAdd{mock: m}
	m.AddMock.callArgs = []*IPlaceImageRepositoryMockAddParams{}

	m.BeginTxMock = mIPlaceImageRepositoryMockBeginTx{mock: m}
	m.BeginTxMock.callArgs = []*IPlaceImageRepositoryMockBeginTxParams{}

	m.CommitTxMock = mIPlaceImageRepositoryMockCommitTx{mock: m}
	m.CommitTxMock.callArgs = []*IPlaceImageRepositoryMockCommitTxParams{}

	m.DeleteMock = mIPlaceImageRepositoryMockDelete{mock: m}
	m.DeleteMock.callArgs = []*IPlaceImageRepositoryMockDeleteParams{}

	m.GetMock = mIPlaceImageRepositoryMockGet{mock: m}
	m.GetMock.callArgs = []*IPlaceImageRepositoryMockGetParams{}

	m.GetByPlaceIDMock = mIPlaceImageRepositoryMockGetByPlaceID{mock: m}
	m.GetByPlaceIDMock.callArgs = []*IPlaceImageRepositoryMockGetByPlaceIDParams{}

	return m
}

type mIPlaceImageRepositoryMockAdd struct {
	mock               *IPlaceImageRepositoryMock
	defaultExpectation *IPlaceImageRepositoryMockAddExpectation
	expectations       []*IPlaceImageRepositoryMockAddExpectation

	callArgs []*IPlaceImageRepositoryMockAddParams
	mutex    sync.RWMutex
}

// IPlaceImageRepositoryMockAddExpectation specifies expectation struct of the IPlaceImageRepository.Add
type IPlaceImageRepositoryMockAddExpectation struct {
	mock    *IPlaceImageRepositoryMock
	params  *IPlaceImageRepositoryMockAddParams
	results *IPlaceImageRepositoryMockAddResults
	Counter uint64
}

// IPlaceImageRepositoryMockAddParams contains parameters of the IPlaceImageRepository.Add
type IPlaceImageRepositoryMockAddParams struct {
	ctx context.Context
	req models.AddPlaceImageRequest
	tx  *sql.Tx
}

// IPlaceImageRepositoryMockAddResults contains results of the IPlaceImageRepository.Add
type IPlaceImageRepositoryMockAddResults struct {
	err error
}

// Expect sets up expected params for IPlaceImageRepository.Add
func (mmAdd *mIPlaceImageRepositoryMockAdd) Expect(ctx context.Context, req models.AddPlaceImageRequest, tx *sql.Tx) *mIPlaceImageRepositoryMockAdd {
	if mmAdd.mock.funcAdd != nil {
		mmAdd.mock.t.Fatalf("IPlaceImageRepositoryMock.Add mock is already set by Set")
	}

	if mmAdd.defaultExpectation == nil {
		mmAdd.defaultExpectation = &IPlaceImageRepositoryMockAddExpectation{}
	}

	mmAdd.defaultExpectation.params = &IPlaceImageRepositoryMockAddParams{ctx, req, tx}
	for _, e := range mmAdd.expectations {
		if minimock.Equal(e.params, mmAdd.defaultExpectation.params) {
			mmAdd.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmAdd.defaultExpectation.params)
		}
	}

	return mmAdd
}

// Inspect accepts an inspector function that has same arguments as the IPlaceImageRepository.Add
func (mmAdd *mIPlaceImageRepositoryMockAdd) Inspect(f func(ctx context.Context, req models.AddPlaceImageRequest, tx *sql.Tx)) *mIPlaceImageRepositoryMockAdd {
	if mmAdd.mock.inspectFuncAdd != nil {
		mmAdd.mock.t.Fatalf("Inspect function is already set for IPlaceImageRepositoryMock.Add")
	}

	mmAdd.mock.inspectFuncAdd = f

	return mmAdd
}

// Return sets up results that will be returned by IPlaceImageRepository.Add
func (mmAdd *mIPlaceImageRepositoryMockAdd) Return(err error) *IPlaceImageRepositoryMock {
	if mmAdd.mock.funcAdd != nil {
		mmAdd.mock.t.Fatalf("IPlaceImageRepositoryMock.Add mock is already set by Set")
	}

	if mmAdd.defaultExpectation == nil {
		mmAdd.defaultExpectation = &IPlaceImageRepositoryMockAddExpectation{mock: mmAdd.mock}
	}
	mmAdd.defaultExpectation.results = &IPlaceImageRepositoryMockAddResults{err}
	return mmAdd.mock
}

// Set uses given function f to mock the IPlaceImageRepository.Add method
func (mmAdd *mIPlaceImageRepositoryMockAdd) Set(f func(ctx context.Context, req models.AddPlaceImageRequest, tx *sql.Tx) (err error)) *IPlaceImageRepositoryMock {
	if mmAdd.defaultExpectation != nil {
		mmAdd.mock.t.Fatalf("Default expectation is already set for the IPlaceImageRepository.Add method")
	}

	if len(mmAdd.expectations) > 0 {
		mmAdd.mock.t.Fatalf("Some expectations are already set for the IPlaceImageRepository.Add method")
	}

	mmAdd.mock.funcAdd = f
	return mmAdd.mock
}

// When sets expectation for the IPlaceImageRepository.Add which will trigger the result defined by the following
// Then helper
func (mmAdd *mIPlaceImageRepositoryMockAdd) When(ctx context.Context, req models.AddPlaceImageRequest, tx *sql.Tx) *IPlaceImageRepositoryMockAddExpectation {
	if mmAdd.mock.funcAdd != nil {
		mmAdd.mock.t.Fatalf("IPlaceImageRepositoryMock.Add mock is already set by Set")
	}

	expectation := &IPlaceImageRepositoryMockAddExpectation{
		mock:   mmAdd.mock,
		params: &IPlaceImageRepositoryMockAddParams{ctx, req, tx},
	}
	mmAdd.expectations = append(mmAdd.expectations, expectation)
	return expectation
}

// Then sets up IPlaceImageRepository.Add return parameters for the expectation previously defined by the When method
func (e *IPlaceImageRepositoryMockAddExpectation) Then(err error) *IPlaceImageRepositoryMock {
	e.results = &IPlaceImageRepositoryMockAddResults{err}
	return e.mock
}

// Add implements interfaces.IPlaceImageRepository
func (mmAdd *IPlaceImageRepositoryMock) Add(ctx context.Context, req models.AddPlaceImageRequest, tx *sql.Tx) (err error) {
	mm_atomic.AddUint64(&mmAdd.beforeAddCounter, 1)
	defer mm_atomic.AddUint64(&mmAdd.afterAddCounter, 1)

	if mmAdd.inspectFuncAdd != nil {
		mmAdd.inspectFuncAdd(ctx, req, tx)
	}

	mm_params := &IPlaceImageRepositoryMockAddParams{ctx, req, tx}

	// Record call args
	mmAdd.AddMock.mutex.Lock()
	mmAdd.AddMock.callArgs = append(mmAdd.AddMock.callArgs, mm_params)
	mmAdd.AddMock.mutex.Unlock()

	for _, e := range mmAdd.AddMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmAdd.AddMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmAdd.AddMock.defaultExpectation.Counter, 1)
		mm_want := mmAdd.AddMock.defaultExpectation.params
		mm_got := IPlaceImageRepositoryMockAddParams{ctx, req, tx}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmAdd.t.Errorf("IPlaceImageRepositoryMock.Add got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmAdd.AddMock.defaultExpectation.results
		if mm_results == nil {
			mmAdd.t.Fatal("No results are set for the IPlaceImageRepositoryMock.Add")
		}
		return (*mm_results).err
	}
	if mmAdd.funcAdd != nil {
		return mmAdd.funcAdd(ctx, req, tx)
	}
	mmAdd.t.Fatalf("Unexpected call to IPlaceImageRepositoryMock.Add. %v %v %v", ctx, req, tx)
	return
}

// AddAfterCounter returns a count of finished IPlaceImageRepositoryMock.Add invocations
func (mmAdd *IPlaceImageRepositoryMock) AddAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmAdd.afterAddCounter)
}

// AddBeforeCounter returns a count of IPlaceImageRepositoryMock.Add invocations
func (mmAdd *IPlaceImageRepositoryMock) AddBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmAdd.beforeAddCounter)
}

// Calls returns a list of arguments used in each call to IPlaceImageRepositoryMock.Add.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmAdd *mIPlaceImageRepositoryMockAdd) Calls() []*IPlaceImageRepositoryMockAddParams {
	mmAdd.mutex.RLock()

	argCopy := make([]*IPlaceImageRepositoryMockAddParams, len(mmAdd.callArgs))
	copy(argCopy, mmAdd.callArgs)

	mmAdd.mutex.RUnlock()

	return argCopy
}

// MinimockAddDone returns true if the count of the Add invocations corresponds
// the number of defined expectations
func (m *IPlaceImageRepositoryMock) MinimockAddDone() bool {
	for _, e := range m.AddMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.AddMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcAdd != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		return false
	}
	return true
}

// MinimockAddInspect logs each unmet expectation
func (m *IPlaceImageRepositoryMock) MinimockAddInspect() {
	for _, e := range m.AddMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IPlaceImageRepositoryMock.Add with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.AddMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		if m.AddMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IPlaceImageRepositoryMock.Add")
		} else {
			m.t.Errorf("Expected call to IPlaceImageRepositoryMock.Add with params: %#v", *m.AddMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcAdd != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		m.t.Error("Expected call to IPlaceImageRepositoryMock.Add")
	}
}

type mIPlaceImageRepositoryMockBeginTx struct {
	mock               *IPlaceImageRepositoryMock
	defaultExpectation *IPlaceImageRepositoryMockBeginTxExpectation
	expectations       []*IPlaceImageRepositoryMockBeginTxExpectation

	callArgs []*IPlaceImageRepositoryMockBeginTxParams
	mutex    sync.RWMutex
}

// IPlaceImageRepositoryMockBeginTxExpectation specifies expectation struct of the IPlaceImageRepository.BeginTx
type IPlaceImageRepositoryMockBeginTxExpectation struct {
	mock    *IPlaceImageRepositoryMock
	params  *IPlaceImageRepositoryMockBeginTxParams
	results *IPlaceImageRepositoryMockBeginTxResults
	Counter uint64
}

// IPlaceImageRepositoryMockBeginTxParams contains parameters of the IPlaceImageRepository.BeginTx
type IPlaceImageRepositoryMockBeginTxParams struct {
	ctx   context.Context
	level sql.IsolationLevel
}

// IPlaceImageRepositoryMockBeginTxResults contains results of the IPlaceImageRepository.BeginTx
type IPlaceImageRepositoryMockBeginTxResults struct {
	tp1 *sql.Tx
	err error
}

// Expect sets up expected params for IPlaceImageRepository.BeginTx
func (mmBeginTx *mIPlaceImageRepositoryMockBeginTx) Expect(ctx context.Context, level sql.IsolationLevel) *mIPlaceImageRepositoryMockBeginTx {
	if mmBeginTx.mock.funcBeginTx != nil {
		mmBeginTx.mock.t.Fatalf("IPlaceImageRepositoryMock.BeginTx mock is already set by Set")
	}

	if mmBeginTx.defaultExpectation == nil {
		mmBeginTx.defaultExpectation = &IPlaceImageRepositoryMockBeginTxExpectation{}
	}

	mmBeginTx.defaultExpectation.params = &IPlaceImageRepositoryMockBeginTxParams{ctx, level}
	for _, e := range mmBeginTx.expectations {
		if minimock.Equal(e.params, mmBeginTx.defaultExpectation.params) {
			mmBeginTx.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmBeginTx.defaultExpectation.params)
		}
	}

	return mmBeginTx
}

// Inspect accepts an inspector function that has same arguments as the IPlaceImageRepository.BeginTx
func (mmBeginTx *mIPlaceImageRepositoryMockBeginTx) Inspect(f func(ctx context.Context, level sql.IsolationLevel)) *mIPlaceImageRepositoryMockBeginTx {
	if mmBeginTx.mock.inspectFuncBeginTx != nil {
		mmBeginTx.mock.t.Fatalf("Inspect function is already set for IPlaceImageRepositoryMock.BeginTx")
	}

	mmBeginTx.mock.inspectFuncBeginTx = f

	return mmBeginTx
}

// Return sets up results that will be returned by IPlaceImageRepository.BeginTx
func (mmBeginTx *mIPlaceImageRepositoryMockBeginTx) Return(tp1 *sql.Tx, err error) *IPlaceImageRepositoryMock {
	if mmBeginTx.mock.funcBeginTx != nil {
		mmBeginTx.mock.t.Fatalf("IPlaceImageRepositoryMock.BeginTx mock is already set by Set")
	}

	if mmBeginTx.defaultExpectation == nil {
		mmBeginTx.defaultExpectation = &IPlaceImageRepositoryMockBeginTxExpectation{mock: mmBeginTx.mock}
	}
	mmBeginTx.defaultExpectation.results = &IPlaceImageRepositoryMockBeginTxResults{tp1, err}
	return mmBeginTx.mock
}

// Set uses given function f to mock the IPlaceImageRepository.BeginTx method
func (mmBeginTx *mIPlaceImageRepositoryMockBeginTx) Set(f func(ctx context.Context, level sql.IsolationLevel) (tp1 *sql.Tx, err error)) *IPlaceImageRepositoryMock {
	if mmBeginTx.defaultExpectation != nil {
		mmBeginTx.mock.t.Fatalf("Default expectation is already set for the IPlaceImageRepository.BeginTx method")
	}

	if len(mmBeginTx.expectations) > 0 {
		mmBeginTx.mock.t.Fatalf("Some expectations are already set for the IPlaceImageRepository.BeginTx method")
	}

	mmBeginTx.mock.funcBeginTx = f
	return mmBeginTx.mock
}

// When sets expectation for the IPlaceImageRepository.BeginTx which will trigger the result defined by the following
// Then helper
func (mmBeginTx *mIPlaceImageRepositoryMockBeginTx) When(ctx context.Context, level sql.IsolationLevel) *IPlaceImageRepositoryMockBeginTxExpectation {
	if mmBeginTx.mock.funcBeginTx != nil {
		mmBeginTx.mock.t.Fatalf("IPlaceImageRepositoryMock.BeginTx mock is already set by Set")
	}

	expectation := &IPlaceImageRepositoryMockBeginTxExpectation{
		mock:   mmBeginTx.mock,
		params: &IPlaceImageRepositoryMockBeginTxParams{ctx, level},
	}
	mmBeginTx.expectations = append(mmBeginTx.expectations, expectation)
	return expectation
}

// Then sets up IPlaceImageRepository.BeginTx return parameters for the expectation previously defined by the When method
func (e *IPlaceImageRepositoryMockBeginTxExpectation) Then(tp1 *sql.Tx, err error) *IPlaceImageRepositoryMock {
	e.results = &IPlaceImageRepositoryMockBeginTxResults{tp1, err}
	return e.mock
}

// BeginTx implements interfaces.IPlaceImageRepository
func (mmBeginTx *IPlaceImageRepositoryMock) BeginTx(ctx context.Context, level sql.IsolationLevel) (tp1 *sql.Tx, err error) {
	mm_atomic.AddUint64(&mmBeginTx.beforeBeginTxCounter, 1)
	defer mm_atomic.AddUint64(&mmBeginTx.afterBeginTxCounter, 1)

	if mmBeginTx.inspectFuncBeginTx != nil {
		mmBeginTx.inspectFuncBeginTx(ctx, level)
	}

	mm_params := &IPlaceImageRepositoryMockBeginTxParams{ctx, level}

	// Record call args
	mmBeginTx.BeginTxMock.mutex.Lock()
	mmBeginTx.BeginTxMock.callArgs = append(mmBeginTx.BeginTxMock.callArgs, mm_params)
	mmBeginTx.BeginTxMock.mutex.Unlock()

	for _, e := range mmBeginTx.BeginTxMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.tp1, e.results.err
		}
	}

	if mmBeginTx.BeginTxMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmBeginTx.BeginTxMock.defaultExpectation.Counter, 1)
		mm_want := mmBeginTx.BeginTxMock.defaultExpectation.params
		mm_got := IPlaceImageRepositoryMockBeginTxParams{ctx, level}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmBeginTx.t.Errorf("IPlaceImageRepositoryMock.BeginTx got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmBeginTx.BeginTxMock.defaultExpectation.results
		if mm_results == nil {
			mmBeginTx.t.Fatal("No results are set for the IPlaceImageRepositoryMock.BeginTx")
		}
		return (*mm_results).tp1, (*mm_results).err
	}
	if mmBeginTx.funcBeginTx != nil {
		return mmBeginTx.funcBeginTx(ctx, level)
	}
	mmBeginTx.t.Fatalf("Unexpected call to IPlaceImageRepositoryMock.BeginTx. %v %v", ctx, level)
	return
}

// BeginTxAfterCounter returns a count of finished IPlaceImageRepositoryMock.BeginTx invocations
func (mmBeginTx *IPlaceImageRepositoryMock) BeginTxAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmBeginTx.afterBeginTxCounter)
}

// BeginTxBeforeCounter returns a count of IPlaceImageRepositoryMock.BeginTx invocations
func (mmBeginTx *IPlaceImageRepositoryMock) BeginTxBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmBeginTx.beforeBeginTxCounter)
}

// Calls returns a list of arguments used in each call to IPlaceImageRepositoryMock.BeginTx.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmBeginTx *mIPlaceImageRepositoryMockBeginTx) Calls() []*IPlaceImageRepositoryMockBeginTxParams {
	mmBeginTx.mutex.RLock()

	argCopy := make([]*IPlaceImageRepositoryMockBeginTxParams, len(mmBeginTx.callArgs))
	copy(argCopy, mmBeginTx.callArgs)

	mmBeginTx.mutex.RUnlock()

	return argCopy
}

// MinimockBeginTxDone returns true if the count of the BeginTx invocations corresponds
// the number of defined expectations
func (m *IPlaceImageRepositoryMock) MinimockBeginTxDone() bool {
	for _, e := range m.BeginTxMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.BeginTxMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterBeginTxCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcBeginTx != nil && mm_atomic.LoadUint64(&m.afterBeginTxCounter) < 1 {
		return false
	}
	return true
}

// MinimockBeginTxInspect logs each unmet expectation
func (m *IPlaceImageRepositoryMock) MinimockBeginTxInspect() {
	for _, e := range m.BeginTxMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IPlaceImageRepositoryMock.BeginTx with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.BeginTxMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterBeginTxCounter) < 1 {
		if m.BeginTxMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IPlaceImageRepositoryMock.BeginTx")
		} else {
			m.t.Errorf("Expected call to IPlaceImageRepositoryMock.BeginTx with params: %#v", *m.BeginTxMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcBeginTx != nil && mm_atomic.LoadUint64(&m.afterBeginTxCounter) < 1 {
		m.t.Error("Expected call to IPlaceImageRepositoryMock.BeginTx")
	}
}

type mIPlaceImageRepositoryMockCommitTx struct {
	mock               *IPlaceImageRepositoryMock
	defaultExpectation *IPlaceImageRepositoryMockCommitTxExpectation
	expectations       []*IPlaceImageRepositoryMockCommitTxExpectation

	callArgs []*IPlaceImageRepositoryMockCommitTxParams
	mutex    sync.RWMutex
}

// IPlaceImageRepositoryMockCommitTxExpectation specifies expectation struct of the IPlaceImageRepository.CommitTx
type IPlaceImageRepositoryMockCommitTxExpectation struct {
	mock    *IPlaceImageRepositoryMock
	params  *IPlaceImageRepositoryMockCommitTxParams
	results *IPlaceImageRepositoryMockCommitTxResults
	Counter uint64
}

// IPlaceImageRepositoryMockCommitTxParams contains parameters of the IPlaceImageRepository.CommitTx
type IPlaceImageRepositoryMockCommitTxParams struct {
	tx *sql.Tx
}

// IPlaceImageRepositoryMockCommitTxResults contains results of the IPlaceImageRepository.CommitTx
type IPlaceImageRepositoryMockCommitTxResults struct {
	err error
}

// Expect sets up expected params for IPlaceImageRepository.CommitTx
func (mmCommitTx *mIPlaceImageRepositoryMockCommitTx) Expect(tx *sql.Tx) *mIPlaceImageRepositoryMockCommitTx {
	if mmCommitTx.mock.funcCommitTx != nil {
		mmCommitTx.mock.t.Fatalf("IPlaceImageRepositoryMock.CommitTx mock is already set by Set")
	}

	if mmCommitTx.defaultExpectation == nil {
		mmCommitTx.defaultExpectation = &IPlaceImageRepositoryMockCommitTxExpectation{}
	}

	mmCommitTx.defaultExpectation.params = &IPlaceImageRepositoryMockCommitTxParams{tx}
	for _, e := range mmCommitTx.expectations {
		if minimock.Equal(e.params, mmCommitTx.defaultExpectation.params) {
			mmCommitTx.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmCommitTx.defaultExpectation.params)
		}
	}

	return mmCommitTx
}

// Inspect accepts an inspector function that has same arguments as the IPlaceImageRepository.CommitTx
func (mmCommitTx *mIPlaceImageRepositoryMockCommitTx) Inspect(f func(tx *sql.Tx)) *mIPlaceImageRepositoryMockCommitTx {
	if mmCommitTx.mock.inspectFuncCommitTx != nil {
		mmCommitTx.mock.t.Fatalf("Inspect function is already set for IPlaceImageRepositoryMock.CommitTx")
	}

	mmCommitTx.mock.inspectFuncCommitTx = f

	return mmCommitTx
}

// Return sets up results that will be returned by IPlaceImageRepository.CommitTx
func (mmCommitTx *mIPlaceImageRepositoryMockCommitTx) Return(err error) *IPlaceImageRepositoryMock {
	if mmCommitTx.mock.funcCommitTx != nil {
		mmCommitTx.mock.t.Fatalf("IPlaceImageRepositoryMock.CommitTx mock is already set by Set")
	}

	if mmCommitTx.defaultExpectation == nil {
		mmCommitTx.defaultExpectation = &IPlaceImageRepositoryMockCommitTxExpectation{mock: mmCommitTx.mock}
	}
	mmCommitTx.defaultExpectation.results = &IPlaceImageRepositoryMockCommitTxResults{err}
	return mmCommitTx.mock
}

// Set uses given function f to mock the IPlaceImageRepository.CommitTx method
func (mmCommitTx *mIPlaceImageRepositoryMockCommitTx) Set(f func(tx *sql.Tx) (err error)) *IPlaceImageRepositoryMock {
	if mmCommitTx.defaultExpectation != nil {
		mmCommitTx.mock.t.Fatalf("Default expectation is already set for the IPlaceImageRepository.CommitTx method")
	}

	if len(mmCommitTx.expectations) > 0 {
		mmCommitTx.mock.t.Fatalf("Some expectations are already set for the IPlaceImageRepository.CommitTx method")
	}

	mmCommitTx.mock.funcCommitTx = f
	return mmCommitTx.mock
}

// When sets expectation for the IPlaceImageRepository.CommitTx which will trigger the result defined by the following
// Then helper
func (mmCommitTx *mIPlaceImageRepositoryMockCommitTx) When(tx *sql.Tx) *IPlaceImageRepositoryMockCommitTxExpectation {
	if mmCommitTx.mock.funcCommitTx != nil {
		mmCommitTx.mock.t.Fatalf("IPlaceImageRepositoryMock.CommitTx mock is already set by Set")
	}

	expectation := &IPlaceImageRepositoryMockCommitTxExpectation{
		mock:   mmCommitTx.mock,
		params: &IPlaceImageRepositoryMockCommitTxParams{tx},
	}
	mmCommitTx.expectations = append(mmCommitTx.expectations, expectation)
	return expectation
}

// Then sets up IPlaceImageRepository.CommitTx return parameters for the expectation previously defined by the When method
func (e *IPlaceImageRepositoryMockCommitTxExpectation) Then(err error) *IPlaceImageRepositoryMock {
	e.results = &IPlaceImageRepositoryMockCommitTxResults{err}
	return e.mock
}

// CommitTx implements interfaces.IPlaceImageRepository
func (mmCommitTx *IPlaceImageRepositoryMock) CommitTx(tx *sql.Tx) (err error) {
	mm_atomic.AddUint64(&mmCommitTx.beforeCommitTxCounter, 1)
	defer mm_atomic.AddUint64(&mmCommitTx.afterCommitTxCounter, 1)

	if mmCommitTx.inspectFuncCommitTx != nil {
		mmCommitTx.inspectFuncCommitTx(tx)
	}

	mm_params := &IPlaceImageRepositoryMockCommitTxParams{tx}

	// Record call args
	mmCommitTx.CommitTxMock.mutex.Lock()
	mmCommitTx.CommitTxMock.callArgs = append(mmCommitTx.CommitTxMock.callArgs, mm_params)
	mmCommitTx.CommitTxMock.mutex.Unlock()

	for _, e := range mmCommitTx.CommitTxMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmCommitTx.CommitTxMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmCommitTx.CommitTxMock.defaultExpectation.Counter, 1)
		mm_want := mmCommitTx.CommitTxMock.defaultExpectation.params
		mm_got := IPlaceImageRepositoryMockCommitTxParams{tx}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmCommitTx.t.Errorf("IPlaceImageRepositoryMock.CommitTx got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmCommitTx.CommitTxMock.defaultExpectation.results
		if mm_results == nil {
			mmCommitTx.t.Fatal("No results are set for the IPlaceImageRepositoryMock.CommitTx")
		}
		return (*mm_results).err
	}
	if mmCommitTx.funcCommitTx != nil {
		return mmCommitTx.funcCommitTx(tx)
	}
	mmCommitTx.t.Fatalf("Unexpected call to IPlaceImageRepositoryMock.CommitTx. %v", tx)
	return
}

// CommitTxAfterCounter returns a count of finished IPlaceImageRepositoryMock.CommitTx invocations
func (mmCommitTx *IPlaceImageRepositoryMock) CommitTxAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmCommitTx.afterCommitTxCounter)
}

// CommitTxBeforeCounter returns a count of IPlaceImageRepositoryMock.CommitTx invocations
func (mmCommitTx *IPlaceImageRepositoryMock) CommitTxBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmCommitTx.beforeCommitTxCounter)
}

// Calls returns a list of arguments used in each call to IPlaceImageRepositoryMock.CommitTx.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmCommitTx *mIPlaceImageRepositoryMockCommitTx) Calls() []*IPlaceImageRepositoryMockCommitTxParams {
	mmCommitTx.mutex.RLock()

	argCopy := make([]*IPlaceImageRepositoryMockCommitTxParams, len(mmCommitTx.callArgs))
	copy(argCopy, mmCommitTx.callArgs)

	mmCommitTx.mutex.RUnlock()

	return argCopy
}

// MinimockCommitTxDone returns true if the count of the CommitTx invocations corresponds
// the number of defined expectations
func (m *IPlaceImageRepositoryMock) MinimockCommitTxDone() bool {
	for _, e := range m.CommitTxMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.CommitTxMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterCommitTxCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcCommitTx != nil && mm_atomic.LoadUint64(&m.afterCommitTxCounter) < 1 {
		return false
	}
	return true
}

// MinimockCommitTxInspect logs each unmet expectation
func (m *IPlaceImageRepositoryMock) MinimockCommitTxInspect() {
	for _, e := range m.CommitTxMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IPlaceImageRepositoryMock.CommitTx with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.CommitTxMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterCommitTxCounter) < 1 {
		if m.CommitTxMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IPlaceImageRepositoryMock.CommitTx")
		} else {
			m.t.Errorf("Expected call to IPlaceImageRepositoryMock.CommitTx with params: %#v", *m.CommitTxMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcCommitTx != nil && mm_atomic.LoadUint64(&m.afterCommitTxCounter) < 1 {
		m.t.Error("Expected call to IPlaceImageRepositoryMock.CommitTx")
	}
}

type mIPlaceImageRepositoryMockDelete struct {
	mock               *IPlaceImageRepositoryMock
	defaultExpectation *IPlaceImageRepositoryMockDeleteExpectation
	expectations       []*IPlaceImageRepositoryMockDeleteExpectation

	callArgs []*IPlaceImageRepositoryMockDeleteParams
	mutex    sync.RWMutex
}

// IPlaceImageRepositoryMockDeleteExpectation specifies expectation struct of the IPlaceImageRepository.Delete
type IPlaceImageRepositoryMockDeleteExpectation struct {
	mock    *IPlaceImageRepositoryMock
	params  *IPlaceImageRepositoryMockDeleteParams
	results *IPlaceImageRepositoryMockDeleteResults
	Counter uint64
}

// IPlaceImageRepositoryMockDeleteParams contains parameters of the IPlaceImageRepository.Delete
type IPlaceImageRepositoryMockDeleteParams struct {
	ctx     context.Context
	imageID int
	tx      *sql.Tx
}

// IPlaceImageRepositoryMockDeleteResults contains results of the IPlaceImageRepository.Delete
type IPlaceImageRepositoryMockDeleteResults struct {
	err error
}

// Expect sets up expected params for IPlaceImageRepository.Delete
func (mmDelete *mIPlaceImageRepositoryMockDelete) Expect(ctx context.Context, imageID int, tx *sql.Tx) *mIPlaceImageRepositoryMockDelete {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("IPlaceImageRepositoryMock.Delete mock is already set by Set")
	}

	if mmDelete.defaultExpectation == nil {
		mmDelete.defaultExpectation = &IPlaceImageRepositoryMockDeleteExpectation{}
	}

	mmDelete.defaultExpectation.params = &IPlaceImageRepositoryMockDeleteParams{ctx, imageID, tx}
	for _, e := range mmDelete.expectations {
		if minimock.Equal(e.params, mmDelete.defaultExpectation.params) {
			mmDelete.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmDelete.defaultExpectation.params)
		}
	}

	return mmDelete
}

// Inspect accepts an inspector function that has same arguments as the IPlaceImageRepository.Delete
func (mmDelete *mIPlaceImageRepositoryMockDelete) Inspect(f func(ctx context.Context, imageID int, tx *sql.Tx)) *mIPlaceImageRepositoryMockDelete {
	if mmDelete.mock.inspectFuncDelete != nil {
		mmDelete.mock.t.Fatalf("Inspect function is already set for IPlaceImageRepositoryMock.Delete")
	}

	mmDelete.mock.inspectFuncDelete = f

	return mmDelete
}

// Return sets up results that will be returned by IPlaceImageRepository.Delete
func (mmDelete *mIPlaceImageRepositoryMockDelete) Return(err error) *IPlaceImageRepositoryMock {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("IPlaceImageRepositoryMock.Delete mock is already set by Set")
	}

	if mmDelete.defaultExpectation == nil {
		mmDelete.defaultExpectation = &IPlaceImageRepositoryMockDeleteExpectation{mock: mmDelete.mock}
	}
	mmDelete.defaultExpectation.results = &IPlaceImageRepositoryMockDeleteResults{err}
	return mmDelete.mock
}

// Set uses given function f to mock the IPlaceImageRepository.Delete method
func (mmDelete *mIPlaceImageRepositoryMockDelete) Set(f func(ctx context.Context, imageID int, tx *sql.Tx) (err error)) *IPlaceImageRepositoryMock {
	if mmDelete.defaultExpectation != nil {
		mmDelete.mock.t.Fatalf("Default expectation is already set for the IPlaceImageRepository.Delete method")
	}

	if len(mmDelete.expectations) > 0 {
		mmDelete.mock.t.Fatalf("Some expectations are already set for the IPlaceImageRepository.Delete method")
	}

	mmDelete.mock.funcDelete = f
	return mmDelete.mock
}

// When sets expectation for the IPlaceImageRepository.Delete which will trigger the result defined by the following
// Then helper
func (mmDelete *mIPlaceImageRepositoryMockDelete) When(ctx context.Context, imageID int, tx *sql.Tx) *IPlaceImageRepositoryMockDeleteExpectation {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("IPlaceImageRepositoryMock.Delete mock is already set by Set")
	}

	expectation := &IPlaceImageRepositoryMockDeleteExpectation{
		mock:   mmDelete.mock,
		params: &IPlaceImageRepositoryMockDeleteParams{ctx, imageID, tx},
	}
	mmDelete.expectations = append(mmDelete.expectations, expectation)
	return expectation
}

// Then sets up IPlaceImageRepository.Delete return parameters for the expectation previously defined by the When method
func (e *IPlaceImageRepositoryMockDeleteExpectation) Then(err error) *IPlaceImageRepositoryMock {
	e.results = &IPlaceImageRepositoryMockDeleteResults{err}
	return e.mock
}

// Delete implements interfaces.IPlaceImageRepository
func (mmDelete *IPlaceImageRepositoryMock) Delete(ctx context.Context, imageID int, tx *sql.Tx) (err error) {
	mm_atomic.AddUint64(&mmDelete.beforeDeleteCounter, 1)
	defer mm_atomic.AddUint64(&mmDelete.afterDeleteCounter, 1)

	if mmDelete.inspectFuncDelete != nil {
		mmDelete.inspectFuncDelete(ctx, imageID, tx)
	}

	mm_params := &IPlaceImageRepositoryMockDeleteParams{ctx, imageID, tx}

	// Record call args
	mmDelete.DeleteMock.mutex.Lock()
	mmDelete.DeleteMock.callArgs = append(mmDelete.DeleteMock.callArgs, mm_params)
	mmDelete.DeleteMock.mutex.Unlock()

	for _, e := range mmDelete.DeleteMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmDelete.DeleteMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmDelete.DeleteMock.defaultExpectation.Counter, 1)
		mm_want := mmDelete.DeleteMock.defaultExpectation.params
		mm_got := IPlaceImageRepositoryMockDeleteParams{ctx, imageID, tx}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmDelete.t.Errorf("IPlaceImageRepositoryMock.Delete got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmDelete.DeleteMock.defaultExpectation.results
		if mm_results == nil {
			mmDelete.t.Fatal("No results are set for the IPlaceImageRepositoryMock.Delete")
		}
		return (*mm_results).err
	}
	if mmDelete.funcDelete != nil {
		return mmDelete.funcDelete(ctx, imageID, tx)
	}
	mmDelete.t.Fatalf("Unexpected call to IPlaceImageRepositoryMock.Delete. %v %v %v", ctx, imageID, tx)
	return
}

// DeleteAfterCounter returns a count of finished IPlaceImageRepositoryMock.Delete invocations
func (mmDelete *IPlaceImageRepositoryMock) DeleteAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmDelete.afterDeleteCounter)
}

// DeleteBeforeCounter returns a count of IPlaceImageRepositoryMock.Delete invocations
func (mmDelete *IPlaceImageRepositoryMock) DeleteBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmDelete.beforeDeleteCounter)
}

// Calls returns a list of arguments used in each call to IPlaceImageRepositoryMock.Delete.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmDelete *mIPlaceImageRepositoryMockDelete) Calls() []*IPlaceImageRepositoryMockDeleteParams {
	mmDelete.mutex.RLock()

	argCopy := make([]*IPlaceImageRepositoryMockDeleteParams, len(mmDelete.callArgs))
	copy(argCopy, mmDelete.callArgs)

	mmDelete.mutex.RUnlock()

	return argCopy
}

// MinimockDeleteDone returns true if the count of the Delete invocations corresponds
// the number of defined expectations
func (m *IPlaceImageRepositoryMock) MinimockDeleteDone() bool {
	for _, e := range m.DeleteMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.DeleteMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcDelete != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		return false
	}
	return true
}

// MinimockDeleteInspect logs each unmet expectation
func (m *IPlaceImageRepositoryMock) MinimockDeleteInspect() {
	for _, e := range m.DeleteMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IPlaceImageRepositoryMock.Delete with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.DeleteMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		if m.DeleteMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IPlaceImageRepositoryMock.Delete")
		} else {
			m.t.Errorf("Expected call to IPlaceImageRepositoryMock.Delete with params: %#v", *m.DeleteMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcDelete != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		m.t.Error("Expected call to IPlaceImageRepositoryMock.Delete")
	}
}

type mIPlaceImageRepositoryMockGet struct {
	mock               *IPlaceImageRepositoryMock
	defaultExpectation *IPlaceImageRepositoryMockGetExpectation
	expectations       []*IPlaceImageRepositoryMockGetExpectation

	callArgs []*IPlaceImageRepositoryMockGetParams
	mutex    sync.RWMutex
}

// IPlaceImageRepositoryMockGetExpectation specifies expectation struct of the IPlaceImageRepository.Get
type IPlaceImageRepositoryMockGetExpectation struct {
	mock    *IPlaceImageRepositoryMock
	params  *IPlaceImageRepositoryMockGetParams
	results *IPlaceImageRepositoryMockGetResults
	Counter uint64
}

// IPlaceImageRepositoryMockGetParams contains parameters of the IPlaceImageRepository.Get
type IPlaceImageRepositoryMockGetParams struct {
	ctx     context.Context
	imageID int
}

// IPlaceImageRepositoryMockGetResults contains results of the IPlaceImageRepository.Get
type IPlaceImageRepositoryMockGetResults struct {
	ip1 *models.Image
	err error
}

// Expect sets up expected params for IPlaceImageRepository.Get
func (mmGet *mIPlaceImageRepositoryMockGet) Expect(ctx context.Context, imageID int) *mIPlaceImageRepositoryMockGet {
	if mmGet.mock.funcGet != nil {
		mmGet.mock.t.Fatalf("IPlaceImageRepositoryMock.Get mock is already set by Set")
	}

	if mmGet.defaultExpectation == nil {
		mmGet.defaultExpectation = &IPlaceImageRepositoryMockGetExpectation{}
	}

	mmGet.defaultExpectation.params = &IPlaceImageRepositoryMockGetParams{ctx, imageID}
	for _, e := range mmGet.expectations {
		if minimock.Equal(e.params, mmGet.defaultExpectation.params) {
			mmGet.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmGet.defaultExpectation.params)
		}
	}

	return mmGet
}

// Inspect accepts an inspector function that has same arguments as the IPlaceImageRepository.Get
func (mmGet *mIPlaceImageRepositoryMockGet) Inspect(f func(ctx context.Context, imageID int)) *mIPlaceImageRepositoryMockGet {
	if mmGet.mock.inspectFuncGet != nil {
		mmGet.mock.t.Fatalf("Inspect function is already set for IPlaceImageRepositoryMock.Get")
	}

	mmGet.mock.inspectFuncGet = f

	return mmGet
}

// Return sets up results that will be returned by IPlaceImageRepository.Get
func (mmGet *mIPlaceImageRepositoryMockGet) Return(ip1 *models.Image, err error) *IPlaceImageRepositoryMock {
	if mmGet.mock.funcGet != nil {
		mmGet.mock.t.Fatalf("IPlaceImageRepositoryMock.Get mock is already set by Set")
	}

	if mmGet.defaultExpectation == nil {
		mmGet.defaultExpectation = &IPlaceImageRepositoryMockGetExpectation{mock: mmGet.mock}
	}
	mmGet.defaultExpectation.results = &IPlaceImageRepositoryMockGetResults{ip1, err}
	return mmGet.mock
}

// Set uses given function f to mock the IPlaceImageRepository.Get method
func (mmGet *mIPlaceImageRepositoryMockGet) Set(f func(ctx context.Context, imageID int) (ip1 *models.Image, err error)) *IPlaceImageRepositoryMock {
	if mmGet.defaultExpectation != nil {
		mmGet.mock.t.Fatalf("Default expectation is already set for the IPlaceImageRepository.Get method")
	}

	if len(mmGet.expectations) > 0 {
		mmGet.mock.t.Fatalf("Some expectations are already set for the IPlaceImageRepository.Get method")
	}

	mmGet.mock.funcGet = f
	return mmGet.mock
}

// When sets expectation for the IPlaceImageRepository.Get which will trigger the result defined by the following
// Then helper
func (mmGet *mIPlaceImageRepositoryMockGet) When(ctx context.Context, imageID int) *IPlaceImageRepositoryMockGetExpectation {
	if mmGet.mock.funcGet != nil {
		mmGet.mock.t.Fatalf("IPlaceImageRepositoryMock.Get mock is already set by Set")
	}

	expectation := &IPlaceImageRepositoryMockGetExpectation{
		mock:   mmGet.mock,
		params: &IPlaceImageRepositoryMockGetParams{ctx, imageID},
	}
	mmGet.expectations = append(mmGet.expectations, expectation)
	return expectation
}

// Then sets up IPlaceImageRepository.Get return parameters for the expectation previously defined by the When method
func (e *IPlaceImageRepositoryMockGetExpectation) Then(ip1 *models.Image, err error) *IPlaceImageRepositoryMock {
	e.results = &IPlaceImageRepositoryMockGetResults{ip1, err}
	return e.mock
}

// Get implements interfaces.IPlaceImageRepository
func (mmGet *IPlaceImageRepositoryMock) Get(ctx context.Context, imageID int) (ip1 *models.Image, err error) {
	mm_atomic.AddUint64(&mmGet.beforeGetCounter, 1)
	defer mm_atomic.AddUint64(&mmGet.afterGetCounter, 1)

	if mmGet.inspectFuncGet != nil {
		mmGet.inspectFuncGet(ctx, imageID)
	}

	mm_params := &IPlaceImageRepositoryMockGetParams{ctx, imageID}

	// Record call args
	mmGet.GetMock.mutex.Lock()
	mmGet.GetMock.callArgs = append(mmGet.GetMock.callArgs, mm_params)
	mmGet.GetMock.mutex.Unlock()

	for _, e := range mmGet.GetMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.ip1, e.results.err
		}
	}

	if mmGet.GetMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmGet.GetMock.defaultExpectation.Counter, 1)
		mm_want := mmGet.GetMock.defaultExpectation.params
		mm_got := IPlaceImageRepositoryMockGetParams{ctx, imageID}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmGet.t.Errorf("IPlaceImageRepositoryMock.Get got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmGet.GetMock.defaultExpectation.results
		if mm_results == nil {
			mmGet.t.Fatal("No results are set for the IPlaceImageRepositoryMock.Get")
		}
		return (*mm_results).ip1, (*mm_results).err
	}
	if mmGet.funcGet != nil {
		return mmGet.funcGet(ctx, imageID)
	}
	mmGet.t.Fatalf("Unexpected call to IPlaceImageRepositoryMock.Get. %v %v", ctx, imageID)
	return
}

// GetAfterCounter returns a count of finished IPlaceImageRepositoryMock.Get invocations
func (mmGet *IPlaceImageRepositoryMock) GetAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGet.afterGetCounter)
}

// GetBeforeCounter returns a count of IPlaceImageRepositoryMock.Get invocations
func (mmGet *IPlaceImageRepositoryMock) GetBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGet.beforeGetCounter)
}

// Calls returns a list of arguments used in each call to IPlaceImageRepositoryMock.Get.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmGet *mIPlaceImageRepositoryMockGet) Calls() []*IPlaceImageRepositoryMockGetParams {
	mmGet.mutex.RLock()

	argCopy := make([]*IPlaceImageRepositoryMockGetParams, len(mmGet.callArgs))
	copy(argCopy, mmGet.callArgs)

	mmGet.mutex.RUnlock()

	return argCopy
}

// MinimockGetDone returns true if the count of the Get invocations corresponds
// the number of defined expectations
func (m *IPlaceImageRepositoryMock) MinimockGetDone() bool {
	for _, e := range m.GetMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGet != nil && mm_atomic.LoadUint64(&m.afterGetCounter) < 1 {
		return false
	}
	return true
}

// MinimockGetInspect logs each unmet expectation
func (m *IPlaceImageRepositoryMock) MinimockGetInspect() {
	for _, e := range m.GetMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IPlaceImageRepositoryMock.Get with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetCounter) < 1 {
		if m.GetMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IPlaceImageRepositoryMock.Get")
		} else {
			m.t.Errorf("Expected call to IPlaceImageRepositoryMock.Get with params: %#v", *m.GetMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGet != nil && mm_atomic.LoadUint64(&m.afterGetCounter) < 1 {
		m.t.Error("Expected call to IPlaceImageRepositoryMock.Get")
	}
}

type mIPlaceImageRepositoryMockGetByPlaceID struct {
	mock               *IPlaceImageRepositoryMock
	defaultExpectation *IPlaceImageRepositoryMockGetByPlaceIDExpectation
	expectations       []*IPlaceImageRepositoryMockGetByPlaceIDExpectation

	callArgs []*IPlaceImageRepositoryMockGetByPlaceIDParams
	mutex    sync.RWMutex
}

// IPlaceImageRepositoryMockGetByPlaceIDExpectation specifies expectation struct of the IPlaceImageRepository.GetByPlaceID
type IPlaceImageRepositoryMockGetByPlaceIDExpectation struct {
	mock    *IPlaceImageRepositoryMock
	params  *IPlaceImageRepositoryMockGetByPlaceIDParams
	results *IPlaceImageRepositoryMockGetByPlaceIDResults
	Counter uint64
}

// IPlaceImageRepositoryMockGetByPlaceIDParams contains parameters of the IPlaceImageRepository.GetByPlaceID
type IPlaceImageRepositoryMockGetByPlaceIDParams struct {
	ctx     context.Context
	placeID int
}

// IPlaceImageRepositoryMockGetByPlaceIDResults contains results of the IPlaceImageRepository.GetByPlaceID
type IPlaceImageRepositoryMockGetByPlaceIDResults struct {
	ia1 []models.Image
	err error
}

// Expect sets up expected params for IPlaceImageRepository.GetByPlaceID
func (mmGetByPlaceID *mIPlaceImageRepositoryMockGetByPlaceID) Expect(ctx context.Context, placeID int) *mIPlaceImageRepositoryMockGetByPlaceID {
	if mmGetByPlaceID.mock.funcGetByPlaceID != nil {
		mmGetByPlaceID.mock.t.Fatalf("IPlaceImageRepositoryMock.GetByPlaceID mock is already set by Set")
	}

	if mmGetByPlaceID.defaultExpectation == nil {
		mmGetByPlaceID.defaultExpectation = &IPlaceImageRepositoryMockGetByPlaceIDExpectation{}
	}

	mmGetByPlaceID.defaultExpectation.params = &IPlaceImageRepositoryMockGetByPlaceIDParams{ctx, placeID}
	for _, e := range mmGetByPlaceID.expectations {
		if minimock.Equal(e.params, mmGetByPlaceID.defaultExpectation.params) {
			mmGetByPlaceID.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmGetByPlaceID.defaultExpectation.params)
		}
	}

	return mmGetByPlaceID
}

// Inspect accepts an inspector function that has same arguments as the IPlaceImageRepository.GetByPlaceID
func (mmGetByPlaceID *mIPlaceImageRepositoryMockGetByPlaceID) Inspect(f func(ctx context.Context, placeID int)) *mIPlaceImageRepositoryMockGetByPlaceID {
	if mmGetByPlaceID.mock.inspectFuncGetByPlaceID != nil {
		mmGetByPlaceID.mock.t.Fatalf("Inspect function is already set for IPlaceImageRepositoryMock.GetByPlaceID")
	}

	mmGetByPlaceID.mock.inspectFuncGetByPlaceID = f

	return mmGetByPlaceID
}

// Return sets up results that will be returned by IPlaceImageRepository.GetByPlaceID
func (mmGetByPlaceID *mIPlaceImageRepositoryMockGetByPlaceID) Return(ia1 []models.Image, err error) *IPlaceImageRepositoryMock {
	if mmGetByPlaceID.mock.funcGetByPlaceID != nil {
		mmGetByPlaceID.mock.t.Fatalf("IPlaceImageRepositoryMock.GetByPlaceID mock is already set by Set")
	}

	if mmGetByPlaceID.defaultExpectation == nil {
		mmGetByPlaceID.defaultExpectation = &IPlaceImageRepositoryMockGetByPlaceIDExpectation{mock: mmGetByPlaceID.mock}
	}
	mmGetByPlaceID.defaultExpectation.results = &IPlaceImageRepositoryMockGetByPlaceIDResults{ia1, err}
	return mmGetByPlaceID.mock
}

// Set uses given function f to mock the IPlaceImageRepository.GetByPlaceID method
func (mmGetByPlaceID *mIPlaceImageRepositoryMockGetByPlaceID) Set(f func(ctx context.Context, placeID int) (ia1 []models.Image, err error)) *IPlaceImageRepositoryMock {
	if mmGetByPlaceID.defaultExpectation != nil {
		mmGetByPlaceID.mock.t.Fatalf("Default expectation is already set for the IPlaceImageRepository.GetByPlaceID method")
	}

	if len(mmGetByPlaceID.expectations) > 0 {
		mmGetByPlaceID.mock.t.Fatalf("Some expectations are already set for the IPlaceImageRepository.GetByPlaceID method")
	}

	mmGetByPlaceID.mock.funcGetByPlaceID = f
	return mmGetByPlaceID.mock
}

// When sets expectation for the IPlaceImageRepository.GetByPlaceID which will trigger the result defined by the following
// Then helper
func (mmGetByPlaceID *mIPlaceImageRepositoryMockGetByPlaceID) When(ctx context.Context, placeID int) *IPlaceImageRepositoryMockGetByPlaceIDExpectation {
	if mmGetByPlaceID.mock.funcGetByPlaceID != nil {
		mmGetByPlaceID.mock.t.Fatalf("IPlaceImageRepositoryMock.GetByPlaceID mock is already set by Set")
	}

	expectation := &IPlaceImageRepositoryMockGetByPlaceIDExpectation{
		mock:   mmGetByPlaceID.mock,
		params: &IPlaceImageRepositoryMockGetByPlaceIDParams{ctx, placeID},
	}
	mmGetByPlaceID.expectations = append(mmGetByPlaceID.expectations, expectation)
	return expectation
}

// Then sets up IPlaceImageRepository.GetByPlaceID return parameters for the expectation previously defined by the When method
func (e *IPlaceImageRepositoryMockGetByPlaceIDExpectation) Then(ia1 []models.Image, err error) *IPlaceImageRepositoryMock {
	e.results = &IPlaceImageRepositoryMockGetByPlaceIDResults{ia1, err}
	return e.mock
}

// GetByPlaceID implements interfaces.IPlaceImageRepository
func (mmGetByPlaceID *IPlaceImageRepositoryMock) GetByPlaceID(ctx context.Context, placeID int) (ia1 []models.Image, err error) {
	mm_atomic.AddUint64(&mmGetByPlaceID.beforeGetByPlaceIDCounter, 1)
	defer mm_atomic.AddUint64(&mmGetByPlaceID.afterGetByPlaceIDCounter, 1)

	if mmGetByPlaceID.inspectFuncGetByPlaceID != nil {
		mmGetByPlaceID.inspectFuncGetByPlaceID(ctx, placeID)
	}

	mm_params := &IPlaceImageRepositoryMockGetByPlaceIDParams{ctx, placeID}

	// Record call args
	mmGetByPlaceID.GetByPlaceIDMock.mutex.Lock()
	mmGetByPlaceID.GetByPlaceIDMock.callArgs = append(mmGetByPlaceID.GetByPlaceIDMock.callArgs, mm_params)
	mmGetByPlaceID.GetByPlaceIDMock.mutex.Unlock()

	for _, e := range mmGetByPlaceID.GetByPlaceIDMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.ia1, e.results.err
		}
	}

	if mmGetByPlaceID.GetByPlaceIDMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmGetByPlaceID.GetByPlaceIDMock.defaultExpectation.Counter, 1)
		mm_want := mmGetByPlaceID.GetByPlaceIDMock.defaultExpectation.params
		mm_got := IPlaceImageRepositoryMockGetByPlaceIDParams{ctx, placeID}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmGetByPlaceID.t.Errorf("IPlaceImageRepositoryMock.GetByPlaceID got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmGetByPlaceID.GetByPlaceIDMock.defaultExpectation.results
		if mm_results == nil {
			mmGetByPlaceID.t.Fatal("No results are set for the IPlaceImageRepositoryMock.GetByPlaceID")
		}
		return (*mm_results).ia1, (*mm_results).err
	}
	if mmGetByPlaceID.funcGetByPlaceID != nil {
		return mmGetByPlaceID.funcGetByPlaceID(ctx, placeID)
	}
	mmGetByPlaceID.t.Fatalf("Unexpected call to IPlaceImageRepositoryMock.GetByPlaceID. %v %v", ctx, placeID)
	return
}

// GetByPlaceIDAfterCounter returns a count of finished IPlaceImageRepositoryMock.GetByPlaceID invocations
func (mmGetByPlaceID *IPlaceImageRepositoryMock) GetByPlaceIDAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGetByPlaceID.afterGetByPlaceIDCounter)
}

// GetByPlaceIDBeforeCounter returns a count of IPlaceImageRepositoryMock.GetByPlaceID invocations
func (mmGetByPlaceID *IPlaceImageRepositoryMock) GetByPlaceIDBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGetByPlaceID.beforeGetByPlaceIDCounter)
}

// Calls returns a list of arguments used in each call to IPlaceImageRepositoryMock.GetByPlaceID.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmGetByPlaceID *mIPlaceImageRepositoryMockGetByPlaceID) Calls() []*IPlaceImageRepositoryMockGetByPlaceIDParams {
	mmGetByPlaceID.mutex.RLock()

	argCopy := make([]*IPlaceImageRepositoryMockGetByPlaceIDParams, len(mmGetByPlaceID.callArgs))
	copy(argCopy, mmGetByPlaceID.callArgs)

	mmGetByPlaceID.mutex.RUnlock()

	return argCopy
}

// MinimockGetByPlaceIDDone returns true if the count of the GetByPlaceID invocations corresponds
// the number of defined expectations
func (m *IPlaceImageRepositoryMock) MinimockGetByPlaceIDDone() bool {
	for _, e := range m.GetByPlaceIDMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetByPlaceIDMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetByPlaceIDCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGetByPlaceID != nil && mm_atomic.LoadUint64(&m.afterGetByPlaceIDCounter) < 1 {
		return false
	}
	return true
}

// MinimockGetByPlaceIDInspect logs each unmet expectation
func (m *IPlaceImageRepositoryMock) MinimockGetByPlaceIDInspect() {
	for _, e := range m.GetByPlaceIDMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IPlaceImageRepositoryMock.GetByPlaceID with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetByPlaceIDMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetByPlaceIDCounter) < 1 {
		if m.GetByPlaceIDMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IPlaceImageRepositoryMock.GetByPlaceID")
		} else {
			m.t.Errorf("Expected call to IPlaceImageRepositoryMock.GetByPlaceID with params: %#v", *m.GetByPlaceIDMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGetByPlaceID != nil && mm_atomic.LoadUint64(&m.afterGetByPlaceIDCounter) < 1 {
		m.t.Error("Expected call to IPlaceImageRepositoryMock.GetByPlaceID")
	}
}

// MinimockFinish checks that all mocked methods have been called the expected number of times
func (m *IPlaceImageRepositoryMock) MinimockFinish() {
	if !m.minimockDone() {
		m.MinimockAddInspect()

		m.MinimockBeginTxInspect()

		m.MinimockCommitTxInspect()

		m.MinimockDeleteInspect()

		m.MinimockGetInspect()

		m.MinimockGetByPlaceIDInspect()
		m.t.FailNow()
	}
}

// MinimockWait waits for all mocked methods to be called the expected number of times
func (m *IPlaceImageRepositoryMock) MinimockWait(timeout mm_time.Duration) {
	timeoutCh := mm_time.After(timeout)
	for {
		if m.minimockDone() {
			return
		}
		select {
		case <-timeoutCh:
			m.MinimockFinish()
			return
		case <-mm_time.After(10 * mm_time.Millisecond):
		}
	}
}

func (m *IPlaceImageRepositoryMock) minimockDone() bool {
	done := true
	return done &&
		m.MinimockAddDone() &&
		m.MinimockBeginTxDone() &&
		m.MinimockCommitTxDone() &&
		m.MinimockDeleteDone() &&
		m.MinimockGetDone() &&
		m.MinimockGetByPlaceIDDone()
}
