package mocks

// Code generated by http://github.com/gojuno/minimock (dev). DO NOT EDIT.

//go:generate minimock -i git.dmitriygnatenko.ru/dima/homethings/internal/interfaces.IPlaceRepository -o ./mocks/i_place_repository_minimock.go -n IPlaceRepositoryMock

import (
	"context"
	"database/sql"
	"sync"
	mm_atomic "sync/atomic"
	mm_time "time"

	"git.dmitriygnatenko.ru/dima/homethings/internal/models"
	"github.com/gojuno/minimock/v3"
)

// IPlaceRepositoryMock implements interfaces.IPlaceRepository
type IPlaceRepositoryMock struct {
	t minimock.Tester

	funcAdd          func(ctx context.Context, req models.AddPlaceRequest, tx *sql.Tx) (i1 int, err error)
	inspectFuncAdd   func(ctx context.Context, req models.AddPlaceRequest, tx *sql.Tx)
	afterAddCounter  uint64
	beforeAddCounter uint64
	AddMock          mIPlaceRepositoryMockAdd

	funcBeginTx          func(ctx context.Context, level sql.IsolationLevel) (tp1 *sql.Tx, err error)
	inspectFuncBeginTx   func(ctx context.Context, level sql.IsolationLevel)
	afterBeginTxCounter  uint64
	beforeBeginTxCounter uint64
	BeginTxMock          mIPlaceRepositoryMockBeginTx

	funcCommitTx          func(tx *sql.Tx) (err error)
	inspectFuncCommitTx   func(tx *sql.Tx)
	afterCommitTxCounter  uint64
	beforeCommitTxCounter uint64
	CommitTxMock          mIPlaceRepositoryMockCommitTx

	funcDelete          func(ctx context.Context, placeID int, tx *sql.Tx) (err error)
	inspectFuncDelete   func(ctx context.Context, placeID int, tx *sql.Tx)
	afterDeleteCounter  uint64
	beforeDeleteCounter uint64
	DeleteMock          mIPlaceRepositoryMockDelete

	funcGet          func(ctx context.Context, placeID int) (pp1 *models.Place, err error)
	inspectFuncGet   func(ctx context.Context, placeID int)
	afterGetCounter  uint64
	beforeGetCounter uint64
	GetMock          mIPlaceRepositoryMockGet

	funcGetAll          func(ctx context.Context) (pa1 []models.Place, err error)
	inspectFuncGetAll   func(ctx context.Context)
	afterGetAllCounter  uint64
	beforeGetAllCounter uint64
	GetAllMock          mIPlaceRepositoryMockGetAll

	funcGetNestedPlaces          func(ctx context.Context, placeID int) (pa1 []models.Place, err error)
	inspectFuncGetNestedPlaces   func(ctx context.Context, placeID int)
	afterGetNestedPlacesCounter  uint64
	beforeGetNestedPlacesCounter uint64
	GetNestedPlacesMock          mIPlaceRepositoryMockGetNestedPlaces

	funcUpdate          func(ctx context.Context, req models.UpdatePlaceRequest, tx *sql.Tx) (err error)
	inspectFuncUpdate   func(ctx context.Context, req models.UpdatePlaceRequest, tx *sql.Tx)
	afterUpdateCounter  uint64
	beforeUpdateCounter uint64
	UpdateMock          mIPlaceRepositoryMockUpdate
}

// NewIPlaceRepositoryMock returns a mock for interfaces.IPlaceRepository
func NewIPlaceRepositoryMock(t minimock.Tester) *IPlaceRepositoryMock {
	m := &IPlaceRepositoryMock{t: t}
	if controller, ok := t.(minimock.MockController); ok {
		controller.RegisterMocker(m)
	}

	m.AddMock = mIPlaceRepositoryMockAdd{mock: m}
	m.AddMock.callArgs = []*IPlaceRepositoryMockAddParams{}

	m.BeginTxMock = mIPlaceRepositoryMockBeginTx{mock: m}
	m.BeginTxMock.callArgs = []*IPlaceRepositoryMockBeginTxParams{}

	m.CommitTxMock = mIPlaceRepositoryMockCommitTx{mock: m}
	m.CommitTxMock.callArgs = []*IPlaceRepositoryMockCommitTxParams{}

	m.DeleteMock = mIPlaceRepositoryMockDelete{mock: m}
	m.DeleteMock.callArgs = []*IPlaceRepositoryMockDeleteParams{}

	m.GetMock = mIPlaceRepositoryMockGet{mock: m}
	m.GetMock.callArgs = []*IPlaceRepositoryMockGetParams{}

	m.GetAllMock = mIPlaceRepositoryMockGetAll{mock: m}
	m.GetAllMock.callArgs = []*IPlaceRepositoryMockGetAllParams{}

	m.GetNestedPlacesMock = mIPlaceRepositoryMockGetNestedPlaces{mock: m}
	m.GetNestedPlacesMock.callArgs = []*IPlaceRepositoryMockGetNestedPlacesParams{}

	m.UpdateMock = mIPlaceRepositoryMockUpdate{mock: m}
	m.UpdateMock.callArgs = []*IPlaceRepositoryMockUpdateParams{}

	return m
}

type mIPlaceRepositoryMockAdd struct {
	mock               *IPlaceRepositoryMock
	defaultExpectation *IPlaceRepositoryMockAddExpectation
	expectations       []*IPlaceRepositoryMockAddExpectation

	callArgs []*IPlaceRepositoryMockAddParams
	mutex    sync.RWMutex
}

// IPlaceRepositoryMockAddExpectation specifies expectation struct of the IPlaceRepository.Add
type IPlaceRepositoryMockAddExpectation struct {
	mock    *IPlaceRepositoryMock
	params  *IPlaceRepositoryMockAddParams
	results *IPlaceRepositoryMockAddResults
	Counter uint64
}

// IPlaceRepositoryMockAddParams contains parameters of the IPlaceRepository.Add
type IPlaceRepositoryMockAddParams struct {
	ctx context.Context
	req models.AddPlaceRequest
	tx  *sql.Tx
}

// IPlaceRepositoryMockAddResults contains results of the IPlaceRepository.Add
type IPlaceRepositoryMockAddResults struct {
	i1  int
	err error
}

// Expect sets up expected params for IPlaceRepository.Add
func (mmAdd *mIPlaceRepositoryMockAdd) Expect(ctx context.Context, req models.AddPlaceRequest, tx *sql.Tx) *mIPlaceRepositoryMockAdd {
	if mmAdd.mock.funcAdd != nil {
		mmAdd.mock.t.Fatalf("IPlaceRepositoryMock.Add mock is already set by Set")
	}

	if mmAdd.defaultExpectation == nil {
		mmAdd.defaultExpectation = &IPlaceRepositoryMockAddExpectation{}
	}

	mmAdd.defaultExpectation.params = &IPlaceRepositoryMockAddParams{ctx, req, tx}
	for _, e := range mmAdd.expectations {
		if minimock.Equal(e.params, mmAdd.defaultExpectation.params) {
			mmAdd.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmAdd.defaultExpectation.params)
		}
	}

	return mmAdd
}

// Inspect accepts an inspector function that has same arguments as the IPlaceRepository.Add
func (mmAdd *mIPlaceRepositoryMockAdd) Inspect(f func(ctx context.Context, req models.AddPlaceRequest, tx *sql.Tx)) *mIPlaceRepositoryMockAdd {
	if mmAdd.mock.inspectFuncAdd != nil {
		mmAdd.mock.t.Fatalf("Inspect function is already set for IPlaceRepositoryMock.Add")
	}

	mmAdd.mock.inspectFuncAdd = f

	return mmAdd
}

// Return sets up results that will be returned by IPlaceRepository.Add
func (mmAdd *mIPlaceRepositoryMockAdd) Return(i1 int, err error) *IPlaceRepositoryMock {
	if mmAdd.mock.funcAdd != nil {
		mmAdd.mock.t.Fatalf("IPlaceRepositoryMock.Add mock is already set by Set")
	}

	if mmAdd.defaultExpectation == nil {
		mmAdd.defaultExpectation = &IPlaceRepositoryMockAddExpectation{mock: mmAdd.mock}
	}
	mmAdd.defaultExpectation.results = &IPlaceRepositoryMockAddResults{i1, err}
	return mmAdd.mock
}

// Set uses given function f to mock the IPlaceRepository.Add method
func (mmAdd *mIPlaceRepositoryMockAdd) Set(f func(ctx context.Context, req models.AddPlaceRequest, tx *sql.Tx) (i1 int, err error)) *IPlaceRepositoryMock {
	if mmAdd.defaultExpectation != nil {
		mmAdd.mock.t.Fatalf("Default expectation is already set for the IPlaceRepository.Add method")
	}

	if len(mmAdd.expectations) > 0 {
		mmAdd.mock.t.Fatalf("Some expectations are already set for the IPlaceRepository.Add method")
	}

	mmAdd.mock.funcAdd = f
	return mmAdd.mock
}

// When sets expectation for the IPlaceRepository.Add which will trigger the result defined by the following
// Then helper
func (mmAdd *mIPlaceRepositoryMockAdd) When(ctx context.Context, req models.AddPlaceRequest, tx *sql.Tx) *IPlaceRepositoryMockAddExpectation {
	if mmAdd.mock.funcAdd != nil {
		mmAdd.mock.t.Fatalf("IPlaceRepositoryMock.Add mock is already set by Set")
	}

	expectation := &IPlaceRepositoryMockAddExpectation{
		mock:   mmAdd.mock,
		params: &IPlaceRepositoryMockAddParams{ctx, req, tx},
	}
	mmAdd.expectations = append(mmAdd.expectations, expectation)
	return expectation
}

// Then sets up IPlaceRepository.Add return parameters for the expectation previously defined by the When method
func (e *IPlaceRepositoryMockAddExpectation) Then(i1 int, err error) *IPlaceRepositoryMock {
	e.results = &IPlaceRepositoryMockAddResults{i1, err}
	return e.mock
}

// Add implements interfaces.IPlaceRepository
func (mmAdd *IPlaceRepositoryMock) Add(ctx context.Context, req models.AddPlaceRequest, tx *sql.Tx) (i1 int, err error) {
	mm_atomic.AddUint64(&mmAdd.beforeAddCounter, 1)
	defer mm_atomic.AddUint64(&mmAdd.afterAddCounter, 1)

	if mmAdd.inspectFuncAdd != nil {
		mmAdd.inspectFuncAdd(ctx, req, tx)
	}

	mm_params := &IPlaceRepositoryMockAddParams{ctx, req, tx}

	// Record call args
	mmAdd.AddMock.mutex.Lock()
	mmAdd.AddMock.callArgs = append(mmAdd.AddMock.callArgs, mm_params)
	mmAdd.AddMock.mutex.Unlock()

	for _, e := range mmAdd.AddMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.i1, e.results.err
		}
	}

	if mmAdd.AddMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmAdd.AddMock.defaultExpectation.Counter, 1)
		mm_want := mmAdd.AddMock.defaultExpectation.params
		mm_got := IPlaceRepositoryMockAddParams{ctx, req, tx}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmAdd.t.Errorf("IPlaceRepositoryMock.Add got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmAdd.AddMock.defaultExpectation.results
		if mm_results == nil {
			mmAdd.t.Fatal("No results are set for the IPlaceRepositoryMock.Add")
		}
		return (*mm_results).i1, (*mm_results).err
	}
	if mmAdd.funcAdd != nil {
		return mmAdd.funcAdd(ctx, req, tx)
	}
	mmAdd.t.Fatalf("Unexpected call to IPlaceRepositoryMock.Add. %v %v %v", ctx, req, tx)
	return
}

// AddAfterCounter returns a count of finished IPlaceRepositoryMock.Add invocations
func (mmAdd *IPlaceRepositoryMock) AddAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmAdd.afterAddCounter)
}

// AddBeforeCounter returns a count of IPlaceRepositoryMock.Add invocations
func (mmAdd *IPlaceRepositoryMock) AddBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmAdd.beforeAddCounter)
}

// Calls returns a list of arguments used in each call to IPlaceRepositoryMock.Add.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmAdd *mIPlaceRepositoryMockAdd) Calls() []*IPlaceRepositoryMockAddParams {
	mmAdd.mutex.RLock()

	argCopy := make([]*IPlaceRepositoryMockAddParams, len(mmAdd.callArgs))
	copy(argCopy, mmAdd.callArgs)

	mmAdd.mutex.RUnlock()

	return argCopy
}

// MinimockAddDone returns true if the count of the Add invocations corresponds
// the number of defined expectations
func (m *IPlaceRepositoryMock) MinimockAddDone() bool {
	for _, e := range m.AddMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.AddMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcAdd != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		return false
	}
	return true
}

// MinimockAddInspect logs each unmet expectation
func (m *IPlaceRepositoryMock) MinimockAddInspect() {
	for _, e := range m.AddMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IPlaceRepositoryMock.Add with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.AddMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		if m.AddMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IPlaceRepositoryMock.Add")
		} else {
			m.t.Errorf("Expected call to IPlaceRepositoryMock.Add with params: %#v", *m.AddMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcAdd != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		m.t.Error("Expected call to IPlaceRepositoryMock.Add")
	}
}

type mIPlaceRepositoryMockBeginTx struct {
	mock               *IPlaceRepositoryMock
	defaultExpectation *IPlaceRepositoryMockBeginTxExpectation
	expectations       []*IPlaceRepositoryMockBeginTxExpectation

	callArgs []*IPlaceRepositoryMockBeginTxParams
	mutex    sync.RWMutex
}

// IPlaceRepositoryMockBeginTxExpectation specifies expectation struct of the IPlaceRepository.BeginTx
type IPlaceRepositoryMockBeginTxExpectation struct {
	mock    *IPlaceRepositoryMock
	params  *IPlaceRepositoryMockBeginTxParams
	results *IPlaceRepositoryMockBeginTxResults
	Counter uint64
}

// IPlaceRepositoryMockBeginTxParams contains parameters of the IPlaceRepository.BeginTx
type IPlaceRepositoryMockBeginTxParams struct {
	ctx   context.Context
	level sql.IsolationLevel
}

// IPlaceRepositoryMockBeginTxResults contains results of the IPlaceRepository.BeginTx
type IPlaceRepositoryMockBeginTxResults struct {
	tp1 *sql.Tx
	err error
}

// Expect sets up expected params for IPlaceRepository.BeginTx
func (mmBeginTx *mIPlaceRepositoryMockBeginTx) Expect(ctx context.Context, level sql.IsolationLevel) *mIPlaceRepositoryMockBeginTx {
	if mmBeginTx.mock.funcBeginTx != nil {
		mmBeginTx.mock.t.Fatalf("IPlaceRepositoryMock.BeginTx mock is already set by Set")
	}

	if mmBeginTx.defaultExpectation == nil {
		mmBeginTx.defaultExpectation = &IPlaceRepositoryMockBeginTxExpectation{}
	}

	mmBeginTx.defaultExpectation.params = &IPlaceRepositoryMockBeginTxParams{ctx, level}
	for _, e := range mmBeginTx.expectations {
		if minimock.Equal(e.params, mmBeginTx.defaultExpectation.params) {
			mmBeginTx.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmBeginTx.defaultExpectation.params)
		}
	}

	return mmBeginTx
}

// Inspect accepts an inspector function that has same arguments as the IPlaceRepository.BeginTx
func (mmBeginTx *mIPlaceRepositoryMockBeginTx) Inspect(f func(ctx context.Context, level sql.IsolationLevel)) *mIPlaceRepositoryMockBeginTx {
	if mmBeginTx.mock.inspectFuncBeginTx != nil {
		mmBeginTx.mock.t.Fatalf("Inspect function is already set for IPlaceRepositoryMock.BeginTx")
	}

	mmBeginTx.mock.inspectFuncBeginTx = f

	return mmBeginTx
}

// Return sets up results that will be returned by IPlaceRepository.BeginTx
func (mmBeginTx *mIPlaceRepositoryMockBeginTx) Return(tp1 *sql.Tx, err error) *IPlaceRepositoryMock {
	if mmBeginTx.mock.funcBeginTx != nil {
		mmBeginTx.mock.t.Fatalf("IPlaceRepositoryMock.BeginTx mock is already set by Set")
	}

	if mmBeginTx.defaultExpectation == nil {
		mmBeginTx.defaultExpectation = &IPlaceRepositoryMockBeginTxExpectation{mock: mmBeginTx.mock}
	}
	mmBeginTx.defaultExpectation.results = &IPlaceRepositoryMockBeginTxResults{tp1, err}
	return mmBeginTx.mock
}

// Set uses given function f to mock the IPlaceRepository.BeginTx method
func (mmBeginTx *mIPlaceRepositoryMockBeginTx) Set(f func(ctx context.Context, level sql.IsolationLevel) (tp1 *sql.Tx, err error)) *IPlaceRepositoryMock {
	if mmBeginTx.defaultExpectation != nil {
		mmBeginTx.mock.t.Fatalf("Default expectation is already set for the IPlaceRepository.BeginTx method")
	}

	if len(mmBeginTx.expectations) > 0 {
		mmBeginTx.mock.t.Fatalf("Some expectations are already set for the IPlaceRepository.BeginTx method")
	}

	mmBeginTx.mock.funcBeginTx = f
	return mmBeginTx.mock
}

// When sets expectation for the IPlaceRepository.BeginTx which will trigger the result defined by the following
// Then helper
func (mmBeginTx *mIPlaceRepositoryMockBeginTx) When(ctx context.Context, level sql.IsolationLevel) *IPlaceRepositoryMockBeginTxExpectation {
	if mmBeginTx.mock.funcBeginTx != nil {
		mmBeginTx.mock.t.Fatalf("IPlaceRepositoryMock.BeginTx mock is already set by Set")
	}

	expectation := &IPlaceRepositoryMockBeginTxExpectation{
		mock:   mmBeginTx.mock,
		params: &IPlaceRepositoryMockBeginTxParams{ctx, level},
	}
	mmBeginTx.expectations = append(mmBeginTx.expectations, expectation)
	return expectation
}

// Then sets up IPlaceRepository.BeginTx return parameters for the expectation previously defined by the When method
func (e *IPlaceRepositoryMockBeginTxExpectation) Then(tp1 *sql.Tx, err error) *IPlaceRepositoryMock {
	e.results = &IPlaceRepositoryMockBeginTxResults{tp1, err}
	return e.mock
}

// BeginTx implements interfaces.IPlaceRepository
func (mmBeginTx *IPlaceRepositoryMock) BeginTx(ctx context.Context, level sql.IsolationLevel) (tp1 *sql.Tx, err error) {
	mm_atomic.AddUint64(&mmBeginTx.beforeBeginTxCounter, 1)
	defer mm_atomic.AddUint64(&mmBeginTx.afterBeginTxCounter, 1)

	if mmBeginTx.inspectFuncBeginTx != nil {
		mmBeginTx.inspectFuncBeginTx(ctx, level)
	}

	mm_params := &IPlaceRepositoryMockBeginTxParams{ctx, level}

	// Record call args
	mmBeginTx.BeginTxMock.mutex.Lock()
	mmBeginTx.BeginTxMock.callArgs = append(mmBeginTx.BeginTxMock.callArgs, mm_params)
	mmBeginTx.BeginTxMock.mutex.Unlock()

	for _, e := range mmBeginTx.BeginTxMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.tp1, e.results.err
		}
	}

	if mmBeginTx.BeginTxMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmBeginTx.BeginTxMock.defaultExpectation.Counter, 1)
		mm_want := mmBeginTx.BeginTxMock.defaultExpectation.params
		mm_got := IPlaceRepositoryMockBeginTxParams{ctx, level}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmBeginTx.t.Errorf("IPlaceRepositoryMock.BeginTx got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmBeginTx.BeginTxMock.defaultExpectation.results
		if mm_results == nil {
			mmBeginTx.t.Fatal("No results are set for the IPlaceRepositoryMock.BeginTx")
		}
		return (*mm_results).tp1, (*mm_results).err
	}
	if mmBeginTx.funcBeginTx != nil {
		return mmBeginTx.funcBeginTx(ctx, level)
	}
	mmBeginTx.t.Fatalf("Unexpected call to IPlaceRepositoryMock.BeginTx. %v %v", ctx, level)
	return
}

// BeginTxAfterCounter returns a count of finished IPlaceRepositoryMock.BeginTx invocations
func (mmBeginTx *IPlaceRepositoryMock) BeginTxAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmBeginTx.afterBeginTxCounter)
}

// BeginTxBeforeCounter returns a count of IPlaceRepositoryMock.BeginTx invocations
func (mmBeginTx *IPlaceRepositoryMock) BeginTxBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmBeginTx.beforeBeginTxCounter)
}

// Calls returns a list of arguments used in each call to IPlaceRepositoryMock.BeginTx.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmBeginTx *mIPlaceRepositoryMockBeginTx) Calls() []*IPlaceRepositoryMockBeginTxParams {
	mmBeginTx.mutex.RLock()

	argCopy := make([]*IPlaceRepositoryMockBeginTxParams, len(mmBeginTx.callArgs))
	copy(argCopy, mmBeginTx.callArgs)

	mmBeginTx.mutex.RUnlock()

	return argCopy
}

// MinimockBeginTxDone returns true if the count of the BeginTx invocations corresponds
// the number of defined expectations
func (m *IPlaceRepositoryMock) MinimockBeginTxDone() bool {
	for _, e := range m.BeginTxMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.BeginTxMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterBeginTxCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcBeginTx != nil && mm_atomic.LoadUint64(&m.afterBeginTxCounter) < 1 {
		return false
	}
	return true
}

// MinimockBeginTxInspect logs each unmet expectation
func (m *IPlaceRepositoryMock) MinimockBeginTxInspect() {
	for _, e := range m.BeginTxMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IPlaceRepositoryMock.BeginTx with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.BeginTxMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterBeginTxCounter) < 1 {
		if m.BeginTxMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IPlaceRepositoryMock.BeginTx")
		} else {
			m.t.Errorf("Expected call to IPlaceRepositoryMock.BeginTx with params: %#v", *m.BeginTxMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcBeginTx != nil && mm_atomic.LoadUint64(&m.afterBeginTxCounter) < 1 {
		m.t.Error("Expected call to IPlaceRepositoryMock.BeginTx")
	}
}

type mIPlaceRepositoryMockCommitTx struct {
	mock               *IPlaceRepositoryMock
	defaultExpectation *IPlaceRepositoryMockCommitTxExpectation
	expectations       []*IPlaceRepositoryMockCommitTxExpectation

	callArgs []*IPlaceRepositoryMockCommitTxParams
	mutex    sync.RWMutex
}

// IPlaceRepositoryMockCommitTxExpectation specifies expectation struct of the IPlaceRepository.CommitTx
type IPlaceRepositoryMockCommitTxExpectation struct {
	mock    *IPlaceRepositoryMock
	params  *IPlaceRepositoryMockCommitTxParams
	results *IPlaceRepositoryMockCommitTxResults
	Counter uint64
}

// IPlaceRepositoryMockCommitTxParams contains parameters of the IPlaceRepository.CommitTx
type IPlaceRepositoryMockCommitTxParams struct {
	tx *sql.Tx
}

// IPlaceRepositoryMockCommitTxResults contains results of the IPlaceRepository.CommitTx
type IPlaceRepositoryMockCommitTxResults struct {
	err error
}

// Expect sets up expected params for IPlaceRepository.CommitTx
func (mmCommitTx *mIPlaceRepositoryMockCommitTx) Expect(tx *sql.Tx) *mIPlaceRepositoryMockCommitTx {
	if mmCommitTx.mock.funcCommitTx != nil {
		mmCommitTx.mock.t.Fatalf("IPlaceRepositoryMock.CommitTx mock is already set by Set")
	}

	if mmCommitTx.defaultExpectation == nil {
		mmCommitTx.defaultExpectation = &IPlaceRepositoryMockCommitTxExpectation{}
	}

	mmCommitTx.defaultExpectation.params = &IPlaceRepositoryMockCommitTxParams{tx}
	for _, e := range mmCommitTx.expectations {
		if minimock.Equal(e.params, mmCommitTx.defaultExpectation.params) {
			mmCommitTx.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmCommitTx.defaultExpectation.params)
		}
	}

	return mmCommitTx
}

// Inspect accepts an inspector function that has same arguments as the IPlaceRepository.CommitTx
func (mmCommitTx *mIPlaceRepositoryMockCommitTx) Inspect(f func(tx *sql.Tx)) *mIPlaceRepositoryMockCommitTx {
	if mmCommitTx.mock.inspectFuncCommitTx != nil {
		mmCommitTx.mock.t.Fatalf("Inspect function is already set for IPlaceRepositoryMock.CommitTx")
	}

	mmCommitTx.mock.inspectFuncCommitTx = f

	return mmCommitTx
}

// Return sets up results that will be returned by IPlaceRepository.CommitTx
func (mmCommitTx *mIPlaceRepositoryMockCommitTx) Return(err error) *IPlaceRepositoryMock {
	if mmCommitTx.mock.funcCommitTx != nil {
		mmCommitTx.mock.t.Fatalf("IPlaceRepositoryMock.CommitTx mock is already set by Set")
	}

	if mmCommitTx.defaultExpectation == nil {
		mmCommitTx.defaultExpectation = &IPlaceRepositoryMockCommitTxExpectation{mock: mmCommitTx.mock}
	}
	mmCommitTx.defaultExpectation.results = &IPlaceRepositoryMockCommitTxResults{err}
	return mmCommitTx.mock
}

// Set uses given function f to mock the IPlaceRepository.CommitTx method
func (mmCommitTx *mIPlaceRepositoryMockCommitTx) Set(f func(tx *sql.Tx) (err error)) *IPlaceRepositoryMock {
	if mmCommitTx.defaultExpectation != nil {
		mmCommitTx.mock.t.Fatalf("Default expectation is already set for the IPlaceRepository.CommitTx method")
	}

	if len(mmCommitTx.expectations) > 0 {
		mmCommitTx.mock.t.Fatalf("Some expectations are already set for the IPlaceRepository.CommitTx method")
	}

	mmCommitTx.mock.funcCommitTx = f
	return mmCommitTx.mock
}

// When sets expectation for the IPlaceRepository.CommitTx which will trigger the result defined by the following
// Then helper
func (mmCommitTx *mIPlaceRepositoryMockCommitTx) When(tx *sql.Tx) *IPlaceRepositoryMockCommitTxExpectation {
	if mmCommitTx.mock.funcCommitTx != nil {
		mmCommitTx.mock.t.Fatalf("IPlaceRepositoryMock.CommitTx mock is already set by Set")
	}

	expectation := &IPlaceRepositoryMockCommitTxExpectation{
		mock:   mmCommitTx.mock,
		params: &IPlaceRepositoryMockCommitTxParams{tx},
	}
	mmCommitTx.expectations = append(mmCommitTx.expectations, expectation)
	return expectation
}

// Then sets up IPlaceRepository.CommitTx return parameters for the expectation previously defined by the When method
func (e *IPlaceRepositoryMockCommitTxExpectation) Then(err error) *IPlaceRepositoryMock {
	e.results = &IPlaceRepositoryMockCommitTxResults{err}
	return e.mock
}

// CommitTx implements interfaces.IPlaceRepository
func (mmCommitTx *IPlaceRepositoryMock) CommitTx(tx *sql.Tx) (err error) {
	mm_atomic.AddUint64(&mmCommitTx.beforeCommitTxCounter, 1)
	defer mm_atomic.AddUint64(&mmCommitTx.afterCommitTxCounter, 1)

	if mmCommitTx.inspectFuncCommitTx != nil {
		mmCommitTx.inspectFuncCommitTx(tx)
	}

	mm_params := &IPlaceRepositoryMockCommitTxParams{tx}

	// Record call args
	mmCommitTx.CommitTxMock.mutex.Lock()
	mmCommitTx.CommitTxMock.callArgs = append(mmCommitTx.CommitTxMock.callArgs, mm_params)
	mmCommitTx.CommitTxMock.mutex.Unlock()

	for _, e := range mmCommitTx.CommitTxMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmCommitTx.CommitTxMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmCommitTx.CommitTxMock.defaultExpectation.Counter, 1)
		mm_want := mmCommitTx.CommitTxMock.defaultExpectation.params
		mm_got := IPlaceRepositoryMockCommitTxParams{tx}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmCommitTx.t.Errorf("IPlaceRepositoryMock.CommitTx got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmCommitTx.CommitTxMock.defaultExpectation.results
		if mm_results == nil {
			mmCommitTx.t.Fatal("No results are set for the IPlaceRepositoryMock.CommitTx")
		}
		return (*mm_results).err
	}
	if mmCommitTx.funcCommitTx != nil {
		return mmCommitTx.funcCommitTx(tx)
	}
	mmCommitTx.t.Fatalf("Unexpected call to IPlaceRepositoryMock.CommitTx. %v", tx)
	return
}

// CommitTxAfterCounter returns a count of finished IPlaceRepositoryMock.CommitTx invocations
func (mmCommitTx *IPlaceRepositoryMock) CommitTxAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmCommitTx.afterCommitTxCounter)
}

// CommitTxBeforeCounter returns a count of IPlaceRepositoryMock.CommitTx invocations
func (mmCommitTx *IPlaceRepositoryMock) CommitTxBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmCommitTx.beforeCommitTxCounter)
}

// Calls returns a list of arguments used in each call to IPlaceRepositoryMock.CommitTx.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmCommitTx *mIPlaceRepositoryMockCommitTx) Calls() []*IPlaceRepositoryMockCommitTxParams {
	mmCommitTx.mutex.RLock()

	argCopy := make([]*IPlaceRepositoryMockCommitTxParams, len(mmCommitTx.callArgs))
	copy(argCopy, mmCommitTx.callArgs)

	mmCommitTx.mutex.RUnlock()

	return argCopy
}

// MinimockCommitTxDone returns true if the count of the CommitTx invocations corresponds
// the number of defined expectations
func (m *IPlaceRepositoryMock) MinimockCommitTxDone() bool {
	for _, e := range m.CommitTxMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.CommitTxMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterCommitTxCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcCommitTx != nil && mm_atomic.LoadUint64(&m.afterCommitTxCounter) < 1 {
		return false
	}
	return true
}

// MinimockCommitTxInspect logs each unmet expectation
func (m *IPlaceRepositoryMock) MinimockCommitTxInspect() {
	for _, e := range m.CommitTxMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IPlaceRepositoryMock.CommitTx with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.CommitTxMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterCommitTxCounter) < 1 {
		if m.CommitTxMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IPlaceRepositoryMock.CommitTx")
		} else {
			m.t.Errorf("Expected call to IPlaceRepositoryMock.CommitTx with params: %#v", *m.CommitTxMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcCommitTx != nil && mm_atomic.LoadUint64(&m.afterCommitTxCounter) < 1 {
		m.t.Error("Expected call to IPlaceRepositoryMock.CommitTx")
	}
}

type mIPlaceRepositoryMockDelete struct {
	mock               *IPlaceRepositoryMock
	defaultExpectation *IPlaceRepositoryMockDeleteExpectation
	expectations       []*IPlaceRepositoryMockDeleteExpectation

	callArgs []*IPlaceRepositoryMockDeleteParams
	mutex    sync.RWMutex
}

// IPlaceRepositoryMockDeleteExpectation specifies expectation struct of the IPlaceRepository.Delete
type IPlaceRepositoryMockDeleteExpectation struct {
	mock    *IPlaceRepositoryMock
	params  *IPlaceRepositoryMockDeleteParams
	results *IPlaceRepositoryMockDeleteResults
	Counter uint64
}

// IPlaceRepositoryMockDeleteParams contains parameters of the IPlaceRepository.Delete
type IPlaceRepositoryMockDeleteParams struct {
	ctx     context.Context
	placeID int
	tx      *sql.Tx
}

// IPlaceRepositoryMockDeleteResults contains results of the IPlaceRepository.Delete
type IPlaceRepositoryMockDeleteResults struct {
	err error
}

// Expect sets up expected params for IPlaceRepository.Delete
func (mmDelete *mIPlaceRepositoryMockDelete) Expect(ctx context.Context, placeID int, tx *sql.Tx) *mIPlaceRepositoryMockDelete {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("IPlaceRepositoryMock.Delete mock is already set by Set")
	}

	if mmDelete.defaultExpectation == nil {
		mmDelete.defaultExpectation = &IPlaceRepositoryMockDeleteExpectation{}
	}

	mmDelete.defaultExpectation.params = &IPlaceRepositoryMockDeleteParams{ctx, placeID, tx}
	for _, e := range mmDelete.expectations {
		if minimock.Equal(e.params, mmDelete.defaultExpectation.params) {
			mmDelete.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmDelete.defaultExpectation.params)
		}
	}

	return mmDelete
}

// Inspect accepts an inspector function that has same arguments as the IPlaceRepository.Delete
func (mmDelete *mIPlaceRepositoryMockDelete) Inspect(f func(ctx context.Context, placeID int, tx *sql.Tx)) *mIPlaceRepositoryMockDelete {
	if mmDelete.mock.inspectFuncDelete != nil {
		mmDelete.mock.t.Fatalf("Inspect function is already set for IPlaceRepositoryMock.Delete")
	}

	mmDelete.mock.inspectFuncDelete = f

	return mmDelete
}

// Return sets up results that will be returned by IPlaceRepository.Delete
func (mmDelete *mIPlaceRepositoryMockDelete) Return(err error) *IPlaceRepositoryMock {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("IPlaceRepositoryMock.Delete mock is already set by Set")
	}

	if mmDelete.defaultExpectation == nil {
		mmDelete.defaultExpectation = &IPlaceRepositoryMockDeleteExpectation{mock: mmDelete.mock}
	}
	mmDelete.defaultExpectation.results = &IPlaceRepositoryMockDeleteResults{err}
	return mmDelete.mock
}

// Set uses given function f to mock the IPlaceRepository.Delete method
func (mmDelete *mIPlaceRepositoryMockDelete) Set(f func(ctx context.Context, placeID int, tx *sql.Tx) (err error)) *IPlaceRepositoryMock {
	if mmDelete.defaultExpectation != nil {
		mmDelete.mock.t.Fatalf("Default expectation is already set for the IPlaceRepository.Delete method")
	}

	if len(mmDelete.expectations) > 0 {
		mmDelete.mock.t.Fatalf("Some expectations are already set for the IPlaceRepository.Delete method")
	}

	mmDelete.mock.funcDelete = f
	return mmDelete.mock
}

// When sets expectation for the IPlaceRepository.Delete which will trigger the result defined by the following
// Then helper
func (mmDelete *mIPlaceRepositoryMockDelete) When(ctx context.Context, placeID int, tx *sql.Tx) *IPlaceRepositoryMockDeleteExpectation {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("IPlaceRepositoryMock.Delete mock is already set by Set")
	}

	expectation := &IPlaceRepositoryMockDeleteExpectation{
		mock:   mmDelete.mock,
		params: &IPlaceRepositoryMockDeleteParams{ctx, placeID, tx},
	}
	mmDelete.expectations = append(mmDelete.expectations, expectation)
	return expectation
}

// Then sets up IPlaceRepository.Delete return parameters for the expectation previously defined by the When method
func (e *IPlaceRepositoryMockDeleteExpectation) Then(err error) *IPlaceRepositoryMock {
	e.results = &IPlaceRepositoryMockDeleteResults{err}
	return e.mock
}

// Delete implements interfaces.IPlaceRepository
func (mmDelete *IPlaceRepositoryMock) Delete(ctx context.Context, placeID int, tx *sql.Tx) (err error) {
	mm_atomic.AddUint64(&mmDelete.beforeDeleteCounter, 1)
	defer mm_atomic.AddUint64(&mmDelete.afterDeleteCounter, 1)

	if mmDelete.inspectFuncDelete != nil {
		mmDelete.inspectFuncDelete(ctx, placeID, tx)
	}

	mm_params := &IPlaceRepositoryMockDeleteParams{ctx, placeID, tx}

	// Record call args
	mmDelete.DeleteMock.mutex.Lock()
	mmDelete.DeleteMock.callArgs = append(mmDelete.DeleteMock.callArgs, mm_params)
	mmDelete.DeleteMock.mutex.Unlock()

	for _, e := range mmDelete.DeleteMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmDelete.DeleteMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmDelete.DeleteMock.defaultExpectation.Counter, 1)
		mm_want := mmDelete.DeleteMock.defaultExpectation.params
		mm_got := IPlaceRepositoryMockDeleteParams{ctx, placeID, tx}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmDelete.t.Errorf("IPlaceRepositoryMock.Delete got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmDelete.DeleteMock.defaultExpectation.results
		if mm_results == nil {
			mmDelete.t.Fatal("No results are set for the IPlaceRepositoryMock.Delete")
		}
		return (*mm_results).err
	}
	if mmDelete.funcDelete != nil {
		return mmDelete.funcDelete(ctx, placeID, tx)
	}
	mmDelete.t.Fatalf("Unexpected call to IPlaceRepositoryMock.Delete. %v %v %v", ctx, placeID, tx)
	return
}

// DeleteAfterCounter returns a count of finished IPlaceRepositoryMock.Delete invocations
func (mmDelete *IPlaceRepositoryMock) DeleteAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmDelete.afterDeleteCounter)
}

// DeleteBeforeCounter returns a count of IPlaceRepositoryMock.Delete invocations
func (mmDelete *IPlaceRepositoryMock) DeleteBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmDelete.beforeDeleteCounter)
}

// Calls returns a list of arguments used in each call to IPlaceRepositoryMock.Delete.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmDelete *mIPlaceRepositoryMockDelete) Calls() []*IPlaceRepositoryMockDeleteParams {
	mmDelete.mutex.RLock()

	argCopy := make([]*IPlaceRepositoryMockDeleteParams, len(mmDelete.callArgs))
	copy(argCopy, mmDelete.callArgs)

	mmDelete.mutex.RUnlock()

	return argCopy
}

// MinimockDeleteDone returns true if the count of the Delete invocations corresponds
// the number of defined expectations
func (m *IPlaceRepositoryMock) MinimockDeleteDone() bool {
	for _, e := range m.DeleteMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.DeleteMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcDelete != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		return false
	}
	return true
}

// MinimockDeleteInspect logs each unmet expectation
func (m *IPlaceRepositoryMock) MinimockDeleteInspect() {
	for _, e := range m.DeleteMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IPlaceRepositoryMock.Delete with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.DeleteMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		if m.DeleteMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IPlaceRepositoryMock.Delete")
		} else {
			m.t.Errorf("Expected call to IPlaceRepositoryMock.Delete with params: %#v", *m.DeleteMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcDelete != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		m.t.Error("Expected call to IPlaceRepositoryMock.Delete")
	}
}

type mIPlaceRepositoryMockGet struct {
	mock               *IPlaceRepositoryMock
	defaultExpectation *IPlaceRepositoryMockGetExpectation
	expectations       []*IPlaceRepositoryMockGetExpectation

	callArgs []*IPlaceRepositoryMockGetParams
	mutex    sync.RWMutex
}

// IPlaceRepositoryMockGetExpectation specifies expectation struct of the IPlaceRepository.Get
type IPlaceRepositoryMockGetExpectation struct {
	mock    *IPlaceRepositoryMock
	params  *IPlaceRepositoryMockGetParams
	results *IPlaceRepositoryMockGetResults
	Counter uint64
}

// IPlaceRepositoryMockGetParams contains parameters of the IPlaceRepository.Get
type IPlaceRepositoryMockGetParams struct {
	ctx     context.Context
	placeID int
}

// IPlaceRepositoryMockGetResults contains results of the IPlaceRepository.Get
type IPlaceRepositoryMockGetResults struct {
	pp1 *models.Place
	err error
}

// Expect sets up expected params for IPlaceRepository.Get
func (mmGet *mIPlaceRepositoryMockGet) Expect(ctx context.Context, placeID int) *mIPlaceRepositoryMockGet {
	if mmGet.mock.funcGet != nil {
		mmGet.mock.t.Fatalf("IPlaceRepositoryMock.Get mock is already set by Set")
	}

	if mmGet.defaultExpectation == nil {
		mmGet.defaultExpectation = &IPlaceRepositoryMockGetExpectation{}
	}

	mmGet.defaultExpectation.params = &IPlaceRepositoryMockGetParams{ctx, placeID}
	for _, e := range mmGet.expectations {
		if minimock.Equal(e.params, mmGet.defaultExpectation.params) {
			mmGet.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmGet.defaultExpectation.params)
		}
	}

	return mmGet
}

// Inspect accepts an inspector function that has same arguments as the IPlaceRepository.Get
func (mmGet *mIPlaceRepositoryMockGet) Inspect(f func(ctx context.Context, placeID int)) *mIPlaceRepositoryMockGet {
	if mmGet.mock.inspectFuncGet != nil {
		mmGet.mock.t.Fatalf("Inspect function is already set for IPlaceRepositoryMock.Get")
	}

	mmGet.mock.inspectFuncGet = f

	return mmGet
}

// Return sets up results that will be returned by IPlaceRepository.Get
func (mmGet *mIPlaceRepositoryMockGet) Return(pp1 *models.Place, err error) *IPlaceRepositoryMock {
	if mmGet.mock.funcGet != nil {
		mmGet.mock.t.Fatalf("IPlaceRepositoryMock.Get mock is already set by Set")
	}

	if mmGet.defaultExpectation == nil {
		mmGet.defaultExpectation = &IPlaceRepositoryMockGetExpectation{mock: mmGet.mock}
	}
	mmGet.defaultExpectation.results = &IPlaceRepositoryMockGetResults{pp1, err}
	return mmGet.mock
}

// Set uses given function f to mock the IPlaceRepository.Get method
func (mmGet *mIPlaceRepositoryMockGet) Set(f func(ctx context.Context, placeID int) (pp1 *models.Place, err error)) *IPlaceRepositoryMock {
	if mmGet.defaultExpectation != nil {
		mmGet.mock.t.Fatalf("Default expectation is already set for the IPlaceRepository.Get method")
	}

	if len(mmGet.expectations) > 0 {
		mmGet.mock.t.Fatalf("Some expectations are already set for the IPlaceRepository.Get method")
	}

	mmGet.mock.funcGet = f
	return mmGet.mock
}

// When sets expectation for the IPlaceRepository.Get which will trigger the result defined by the following
// Then helper
func (mmGet *mIPlaceRepositoryMockGet) When(ctx context.Context, placeID int) *IPlaceRepositoryMockGetExpectation {
	if mmGet.mock.funcGet != nil {
		mmGet.mock.t.Fatalf("IPlaceRepositoryMock.Get mock is already set by Set")
	}

	expectation := &IPlaceRepositoryMockGetExpectation{
		mock:   mmGet.mock,
		params: &IPlaceRepositoryMockGetParams{ctx, placeID},
	}
	mmGet.expectations = append(mmGet.expectations, expectation)
	return expectation
}

// Then sets up IPlaceRepository.Get return parameters for the expectation previously defined by the When method
func (e *IPlaceRepositoryMockGetExpectation) Then(pp1 *models.Place, err error) *IPlaceRepositoryMock {
	e.results = &IPlaceRepositoryMockGetResults{pp1, err}
	return e.mock
}

// Get implements interfaces.IPlaceRepository
func (mmGet *IPlaceRepositoryMock) Get(ctx context.Context, placeID int) (pp1 *models.Place, err error) {
	mm_atomic.AddUint64(&mmGet.beforeGetCounter, 1)
	defer mm_atomic.AddUint64(&mmGet.afterGetCounter, 1)

	if mmGet.inspectFuncGet != nil {
		mmGet.inspectFuncGet(ctx, placeID)
	}

	mm_params := &IPlaceRepositoryMockGetParams{ctx, placeID}

	// Record call args
	mmGet.GetMock.mutex.Lock()
	mmGet.GetMock.callArgs = append(mmGet.GetMock.callArgs, mm_params)
	mmGet.GetMock.mutex.Unlock()

	for _, e := range mmGet.GetMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.pp1, e.results.err
		}
	}

	if mmGet.GetMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmGet.GetMock.defaultExpectation.Counter, 1)
		mm_want := mmGet.GetMock.defaultExpectation.params
		mm_got := IPlaceRepositoryMockGetParams{ctx, placeID}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmGet.t.Errorf("IPlaceRepositoryMock.Get got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmGet.GetMock.defaultExpectation.results
		if mm_results == nil {
			mmGet.t.Fatal("No results are set for the IPlaceRepositoryMock.Get")
		}
		return (*mm_results).pp1, (*mm_results).err
	}
	if mmGet.funcGet != nil {
		return mmGet.funcGet(ctx, placeID)
	}
	mmGet.t.Fatalf("Unexpected call to IPlaceRepositoryMock.Get. %v %v", ctx, placeID)
	return
}

// GetAfterCounter returns a count of finished IPlaceRepositoryMock.Get invocations
func (mmGet *IPlaceRepositoryMock) GetAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGet.afterGetCounter)
}

// GetBeforeCounter returns a count of IPlaceRepositoryMock.Get invocations
func (mmGet *IPlaceRepositoryMock) GetBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGet.beforeGetCounter)
}

// Calls returns a list of arguments used in each call to IPlaceRepositoryMock.Get.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmGet *mIPlaceRepositoryMockGet) Calls() []*IPlaceRepositoryMockGetParams {
	mmGet.mutex.RLock()

	argCopy := make([]*IPlaceRepositoryMockGetParams, len(mmGet.callArgs))
	copy(argCopy, mmGet.callArgs)

	mmGet.mutex.RUnlock()

	return argCopy
}

// MinimockGetDone returns true if the count of the Get invocations corresponds
// the number of defined expectations
func (m *IPlaceRepositoryMock) MinimockGetDone() bool {
	for _, e := range m.GetMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGet != nil && mm_atomic.LoadUint64(&m.afterGetCounter) < 1 {
		return false
	}
	return true
}

// MinimockGetInspect logs each unmet expectation
func (m *IPlaceRepositoryMock) MinimockGetInspect() {
	for _, e := range m.GetMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IPlaceRepositoryMock.Get with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetCounter) < 1 {
		if m.GetMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IPlaceRepositoryMock.Get")
		} else {
			m.t.Errorf("Expected call to IPlaceRepositoryMock.Get with params: %#v", *m.GetMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGet != nil && mm_atomic.LoadUint64(&m.afterGetCounter) < 1 {
		m.t.Error("Expected call to IPlaceRepositoryMock.Get")
	}
}

type mIPlaceRepositoryMockGetAll struct {
	mock               *IPlaceRepositoryMock
	defaultExpectation *IPlaceRepositoryMockGetAllExpectation
	expectations       []*IPlaceRepositoryMockGetAllExpectation

	callArgs []*IPlaceRepositoryMockGetAllParams
	mutex    sync.RWMutex
}

// IPlaceRepositoryMockGetAllExpectation specifies expectation struct of the IPlaceRepository.GetAll
type IPlaceRepositoryMockGetAllExpectation struct {
	mock    *IPlaceRepositoryMock
	params  *IPlaceRepositoryMockGetAllParams
	results *IPlaceRepositoryMockGetAllResults
	Counter uint64
}

// IPlaceRepositoryMockGetAllParams contains parameters of the IPlaceRepository.GetAll
type IPlaceRepositoryMockGetAllParams struct {
	ctx context.Context
}

// IPlaceRepositoryMockGetAllResults contains results of the IPlaceRepository.GetAll
type IPlaceRepositoryMockGetAllResults struct {
	pa1 []models.Place
	err error
}

// Expect sets up expected params for IPlaceRepository.GetAll
func (mmGetAll *mIPlaceRepositoryMockGetAll) Expect(ctx context.Context) *mIPlaceRepositoryMockGetAll {
	if mmGetAll.mock.funcGetAll != nil {
		mmGetAll.mock.t.Fatalf("IPlaceRepositoryMock.GetAll mock is already set by Set")
	}

	if mmGetAll.defaultExpectation == nil {
		mmGetAll.defaultExpectation = &IPlaceRepositoryMockGetAllExpectation{}
	}

	mmGetAll.defaultExpectation.params = &IPlaceRepositoryMockGetAllParams{ctx}
	for _, e := range mmGetAll.expectations {
		if minimock.Equal(e.params, mmGetAll.defaultExpectation.params) {
			mmGetAll.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmGetAll.defaultExpectation.params)
		}
	}

	return mmGetAll
}

// Inspect accepts an inspector function that has same arguments as the IPlaceRepository.GetAll
func (mmGetAll *mIPlaceRepositoryMockGetAll) Inspect(f func(ctx context.Context)) *mIPlaceRepositoryMockGetAll {
	if mmGetAll.mock.inspectFuncGetAll != nil {
		mmGetAll.mock.t.Fatalf("Inspect function is already set for IPlaceRepositoryMock.GetAll")
	}

	mmGetAll.mock.inspectFuncGetAll = f

	return mmGetAll
}

// Return sets up results that will be returned by IPlaceRepository.GetAll
func (mmGetAll *mIPlaceRepositoryMockGetAll) Return(pa1 []models.Place, err error) *IPlaceRepositoryMock {
	if mmGetAll.mock.funcGetAll != nil {
		mmGetAll.mock.t.Fatalf("IPlaceRepositoryMock.GetAll mock is already set by Set")
	}

	if mmGetAll.defaultExpectation == nil {
		mmGetAll.defaultExpectation = &IPlaceRepositoryMockGetAllExpectation{mock: mmGetAll.mock}
	}
	mmGetAll.defaultExpectation.results = &IPlaceRepositoryMockGetAllResults{pa1, err}
	return mmGetAll.mock
}

// Set uses given function f to mock the IPlaceRepository.GetAll method
func (mmGetAll *mIPlaceRepositoryMockGetAll) Set(f func(ctx context.Context) (pa1 []models.Place, err error)) *IPlaceRepositoryMock {
	if mmGetAll.defaultExpectation != nil {
		mmGetAll.mock.t.Fatalf("Default expectation is already set for the IPlaceRepository.GetAll method")
	}

	if len(mmGetAll.expectations) > 0 {
		mmGetAll.mock.t.Fatalf("Some expectations are already set for the IPlaceRepository.GetAll method")
	}

	mmGetAll.mock.funcGetAll = f
	return mmGetAll.mock
}

// When sets expectation for the IPlaceRepository.GetAll which will trigger the result defined by the following
// Then helper
func (mmGetAll *mIPlaceRepositoryMockGetAll) When(ctx context.Context) *IPlaceRepositoryMockGetAllExpectation {
	if mmGetAll.mock.funcGetAll != nil {
		mmGetAll.mock.t.Fatalf("IPlaceRepositoryMock.GetAll mock is already set by Set")
	}

	expectation := &IPlaceRepositoryMockGetAllExpectation{
		mock:   mmGetAll.mock,
		params: &IPlaceRepositoryMockGetAllParams{ctx},
	}
	mmGetAll.expectations = append(mmGetAll.expectations, expectation)
	return expectation
}

// Then sets up IPlaceRepository.GetAll return parameters for the expectation previously defined by the When method
func (e *IPlaceRepositoryMockGetAllExpectation) Then(pa1 []models.Place, err error) *IPlaceRepositoryMock {
	e.results = &IPlaceRepositoryMockGetAllResults{pa1, err}
	return e.mock
}

// GetAll implements interfaces.IPlaceRepository
func (mmGetAll *IPlaceRepositoryMock) GetAll(ctx context.Context) (pa1 []models.Place, err error) {
	mm_atomic.AddUint64(&mmGetAll.beforeGetAllCounter, 1)
	defer mm_atomic.AddUint64(&mmGetAll.afterGetAllCounter, 1)

	if mmGetAll.inspectFuncGetAll != nil {
		mmGetAll.inspectFuncGetAll(ctx)
	}

	mm_params := &IPlaceRepositoryMockGetAllParams{ctx}

	// Record call args
	mmGetAll.GetAllMock.mutex.Lock()
	mmGetAll.GetAllMock.callArgs = append(mmGetAll.GetAllMock.callArgs, mm_params)
	mmGetAll.GetAllMock.mutex.Unlock()

	for _, e := range mmGetAll.GetAllMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.pa1, e.results.err
		}
	}

	if mmGetAll.GetAllMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmGetAll.GetAllMock.defaultExpectation.Counter, 1)
		mm_want := mmGetAll.GetAllMock.defaultExpectation.params
		mm_got := IPlaceRepositoryMockGetAllParams{ctx}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmGetAll.t.Errorf("IPlaceRepositoryMock.GetAll got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmGetAll.GetAllMock.defaultExpectation.results
		if mm_results == nil {
			mmGetAll.t.Fatal("No results are set for the IPlaceRepositoryMock.GetAll")
		}
		return (*mm_results).pa1, (*mm_results).err
	}
	if mmGetAll.funcGetAll != nil {
		return mmGetAll.funcGetAll(ctx)
	}
	mmGetAll.t.Fatalf("Unexpected call to IPlaceRepositoryMock.GetAll. %v", ctx)
	return
}

// GetAllAfterCounter returns a count of finished IPlaceRepositoryMock.GetAll invocations
func (mmGetAll *IPlaceRepositoryMock) GetAllAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGetAll.afterGetAllCounter)
}

// GetAllBeforeCounter returns a count of IPlaceRepositoryMock.GetAll invocations
func (mmGetAll *IPlaceRepositoryMock) GetAllBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGetAll.beforeGetAllCounter)
}

// Calls returns a list of arguments used in each call to IPlaceRepositoryMock.GetAll.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmGetAll *mIPlaceRepositoryMockGetAll) Calls() []*IPlaceRepositoryMockGetAllParams {
	mmGetAll.mutex.RLock()

	argCopy := make([]*IPlaceRepositoryMockGetAllParams, len(mmGetAll.callArgs))
	copy(argCopy, mmGetAll.callArgs)

	mmGetAll.mutex.RUnlock()

	return argCopy
}

// MinimockGetAllDone returns true if the count of the GetAll invocations corresponds
// the number of defined expectations
func (m *IPlaceRepositoryMock) MinimockGetAllDone() bool {
	for _, e := range m.GetAllMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetAllMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetAllCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGetAll != nil && mm_atomic.LoadUint64(&m.afterGetAllCounter) < 1 {
		return false
	}
	return true
}

// MinimockGetAllInspect logs each unmet expectation
func (m *IPlaceRepositoryMock) MinimockGetAllInspect() {
	for _, e := range m.GetAllMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IPlaceRepositoryMock.GetAll with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetAllMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetAllCounter) < 1 {
		if m.GetAllMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IPlaceRepositoryMock.GetAll")
		} else {
			m.t.Errorf("Expected call to IPlaceRepositoryMock.GetAll with params: %#v", *m.GetAllMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGetAll != nil && mm_atomic.LoadUint64(&m.afterGetAllCounter) < 1 {
		m.t.Error("Expected call to IPlaceRepositoryMock.GetAll")
	}
}

type mIPlaceRepositoryMockGetNestedPlaces struct {
	mock               *IPlaceRepositoryMock
	defaultExpectation *IPlaceRepositoryMockGetNestedPlacesExpectation
	expectations       []*IPlaceRepositoryMockGetNestedPlacesExpectation

	callArgs []*IPlaceRepositoryMockGetNestedPlacesParams
	mutex    sync.RWMutex
}

// IPlaceRepositoryMockGetNestedPlacesExpectation specifies expectation struct of the IPlaceRepository.GetNestedPlaces
type IPlaceRepositoryMockGetNestedPlacesExpectation struct {
	mock    *IPlaceRepositoryMock
	params  *IPlaceRepositoryMockGetNestedPlacesParams
	results *IPlaceRepositoryMockGetNestedPlacesResults
	Counter uint64
}

// IPlaceRepositoryMockGetNestedPlacesParams contains parameters of the IPlaceRepository.GetNestedPlaces
type IPlaceRepositoryMockGetNestedPlacesParams struct {
	ctx     context.Context
	placeID int
}

// IPlaceRepositoryMockGetNestedPlacesResults contains results of the IPlaceRepository.GetNestedPlaces
type IPlaceRepositoryMockGetNestedPlacesResults struct {
	pa1 []models.Place
	err error
}

// Expect sets up expected params for IPlaceRepository.GetNestedPlaces
func (mmGetNestedPlaces *mIPlaceRepositoryMockGetNestedPlaces) Expect(ctx context.Context, placeID int) *mIPlaceRepositoryMockGetNestedPlaces {
	if mmGetNestedPlaces.mock.funcGetNestedPlaces != nil {
		mmGetNestedPlaces.mock.t.Fatalf("IPlaceRepositoryMock.GetNestedPlaces mock is already set by Set")
	}

	if mmGetNestedPlaces.defaultExpectation == nil {
		mmGetNestedPlaces.defaultExpectation = &IPlaceRepositoryMockGetNestedPlacesExpectation{}
	}

	mmGetNestedPlaces.defaultExpectation.params = &IPlaceRepositoryMockGetNestedPlacesParams{ctx, placeID}
	for _, e := range mmGetNestedPlaces.expectations {
		if minimock.Equal(e.params, mmGetNestedPlaces.defaultExpectation.params) {
			mmGetNestedPlaces.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmGetNestedPlaces.defaultExpectation.params)
		}
	}

	return mmGetNestedPlaces
}

// Inspect accepts an inspector function that has same arguments as the IPlaceRepository.GetNestedPlaces
func (mmGetNestedPlaces *mIPlaceRepositoryMockGetNestedPlaces) Inspect(f func(ctx context.Context, placeID int)) *mIPlaceRepositoryMockGetNestedPlaces {
	if mmGetNestedPlaces.mock.inspectFuncGetNestedPlaces != nil {
		mmGetNestedPlaces.mock.t.Fatalf("Inspect function is already set for IPlaceRepositoryMock.GetNestedPlaces")
	}

	mmGetNestedPlaces.mock.inspectFuncGetNestedPlaces = f

	return mmGetNestedPlaces
}

// Return sets up results that will be returned by IPlaceRepository.GetNestedPlaces
func (mmGetNestedPlaces *mIPlaceRepositoryMockGetNestedPlaces) Return(pa1 []models.Place, err error) *IPlaceRepositoryMock {
	if mmGetNestedPlaces.mock.funcGetNestedPlaces != nil {
		mmGetNestedPlaces.mock.t.Fatalf("IPlaceRepositoryMock.GetNestedPlaces mock is already set by Set")
	}

	if mmGetNestedPlaces.defaultExpectation == nil {
		mmGetNestedPlaces.defaultExpectation = &IPlaceRepositoryMockGetNestedPlacesExpectation{mock: mmGetNestedPlaces.mock}
	}
	mmGetNestedPlaces.defaultExpectation.results = &IPlaceRepositoryMockGetNestedPlacesResults{pa1, err}
	return mmGetNestedPlaces.mock
}

// Set uses given function f to mock the IPlaceRepository.GetNestedPlaces method
func (mmGetNestedPlaces *mIPlaceRepositoryMockGetNestedPlaces) Set(f func(ctx context.Context, placeID int) (pa1 []models.Place, err error)) *IPlaceRepositoryMock {
	if mmGetNestedPlaces.defaultExpectation != nil {
		mmGetNestedPlaces.mock.t.Fatalf("Default expectation is already set for the IPlaceRepository.GetNestedPlaces method")
	}

	if len(mmGetNestedPlaces.expectations) > 0 {
		mmGetNestedPlaces.mock.t.Fatalf("Some expectations are already set for the IPlaceRepository.GetNestedPlaces method")
	}

	mmGetNestedPlaces.mock.funcGetNestedPlaces = f
	return mmGetNestedPlaces.mock
}

// When sets expectation for the IPlaceRepository.GetNestedPlaces which will trigger the result defined by the following
// Then helper
func (mmGetNestedPlaces *mIPlaceRepositoryMockGetNestedPlaces) When(ctx context.Context, placeID int) *IPlaceRepositoryMockGetNestedPlacesExpectation {
	if mmGetNestedPlaces.mock.funcGetNestedPlaces != nil {
		mmGetNestedPlaces.mock.t.Fatalf("IPlaceRepositoryMock.GetNestedPlaces mock is already set by Set")
	}

	expectation := &IPlaceRepositoryMockGetNestedPlacesExpectation{
		mock:   mmGetNestedPlaces.mock,
		params: &IPlaceRepositoryMockGetNestedPlacesParams{ctx, placeID},
	}
	mmGetNestedPlaces.expectations = append(mmGetNestedPlaces.expectations, expectation)
	return expectation
}

// Then sets up IPlaceRepository.GetNestedPlaces return parameters for the expectation previously defined by the When method
func (e *IPlaceRepositoryMockGetNestedPlacesExpectation) Then(pa1 []models.Place, err error) *IPlaceRepositoryMock {
	e.results = &IPlaceRepositoryMockGetNestedPlacesResults{pa1, err}
	return e.mock
}

// GetNestedPlaces implements interfaces.IPlaceRepository
func (mmGetNestedPlaces *IPlaceRepositoryMock) GetNestedPlaces(ctx context.Context, placeID int) (pa1 []models.Place, err error) {
	mm_atomic.AddUint64(&mmGetNestedPlaces.beforeGetNestedPlacesCounter, 1)
	defer mm_atomic.AddUint64(&mmGetNestedPlaces.afterGetNestedPlacesCounter, 1)

	if mmGetNestedPlaces.inspectFuncGetNestedPlaces != nil {
		mmGetNestedPlaces.inspectFuncGetNestedPlaces(ctx, placeID)
	}

	mm_params := &IPlaceRepositoryMockGetNestedPlacesParams{ctx, placeID}

	// Record call args
	mmGetNestedPlaces.GetNestedPlacesMock.mutex.Lock()
	mmGetNestedPlaces.GetNestedPlacesMock.callArgs = append(mmGetNestedPlaces.GetNestedPlacesMock.callArgs, mm_params)
	mmGetNestedPlaces.GetNestedPlacesMock.mutex.Unlock()

	for _, e := range mmGetNestedPlaces.GetNestedPlacesMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.pa1, e.results.err
		}
	}

	if mmGetNestedPlaces.GetNestedPlacesMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmGetNestedPlaces.GetNestedPlacesMock.defaultExpectation.Counter, 1)
		mm_want := mmGetNestedPlaces.GetNestedPlacesMock.defaultExpectation.params
		mm_got := IPlaceRepositoryMockGetNestedPlacesParams{ctx, placeID}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmGetNestedPlaces.t.Errorf("IPlaceRepositoryMock.GetNestedPlaces got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmGetNestedPlaces.GetNestedPlacesMock.defaultExpectation.results
		if mm_results == nil {
			mmGetNestedPlaces.t.Fatal("No results are set for the IPlaceRepositoryMock.GetNestedPlaces")
		}
		return (*mm_results).pa1, (*mm_results).err
	}
	if mmGetNestedPlaces.funcGetNestedPlaces != nil {
		return mmGetNestedPlaces.funcGetNestedPlaces(ctx, placeID)
	}
	mmGetNestedPlaces.t.Fatalf("Unexpected call to IPlaceRepositoryMock.GetNestedPlaces. %v %v", ctx, placeID)
	return
}

// GetNestedPlacesAfterCounter returns a count of finished IPlaceRepositoryMock.GetNestedPlaces invocations
func (mmGetNestedPlaces *IPlaceRepositoryMock) GetNestedPlacesAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGetNestedPlaces.afterGetNestedPlacesCounter)
}

// GetNestedPlacesBeforeCounter returns a count of IPlaceRepositoryMock.GetNestedPlaces invocations
func (mmGetNestedPlaces *IPlaceRepositoryMock) GetNestedPlacesBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGetNestedPlaces.beforeGetNestedPlacesCounter)
}

// Calls returns a list of arguments used in each call to IPlaceRepositoryMock.GetNestedPlaces.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmGetNestedPlaces *mIPlaceRepositoryMockGetNestedPlaces) Calls() []*IPlaceRepositoryMockGetNestedPlacesParams {
	mmGetNestedPlaces.mutex.RLock()

	argCopy := make([]*IPlaceRepositoryMockGetNestedPlacesParams, len(mmGetNestedPlaces.callArgs))
	copy(argCopy, mmGetNestedPlaces.callArgs)

	mmGetNestedPlaces.mutex.RUnlock()

	return argCopy
}

// MinimockGetNestedPlacesDone returns true if the count of the GetNestedPlaces invocations corresponds
// the number of defined expectations
func (m *IPlaceRepositoryMock) MinimockGetNestedPlacesDone() bool {
	for _, e := range m.GetNestedPlacesMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetNestedPlacesMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetNestedPlacesCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGetNestedPlaces != nil && mm_atomic.LoadUint64(&m.afterGetNestedPlacesCounter) < 1 {
		return false
	}
	return true
}

// MinimockGetNestedPlacesInspect logs each unmet expectation
func (m *IPlaceRepositoryMock) MinimockGetNestedPlacesInspect() {
	for _, e := range m.GetNestedPlacesMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IPlaceRepositoryMock.GetNestedPlaces with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetNestedPlacesMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetNestedPlacesCounter) < 1 {
		if m.GetNestedPlacesMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IPlaceRepositoryMock.GetNestedPlaces")
		} else {
			m.t.Errorf("Expected call to IPlaceRepositoryMock.GetNestedPlaces with params: %#v", *m.GetNestedPlacesMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGetNestedPlaces != nil && mm_atomic.LoadUint64(&m.afterGetNestedPlacesCounter) < 1 {
		m.t.Error("Expected call to IPlaceRepositoryMock.GetNestedPlaces")
	}
}

type mIPlaceRepositoryMockUpdate struct {
	mock               *IPlaceRepositoryMock
	defaultExpectation *IPlaceRepositoryMockUpdateExpectation
	expectations       []*IPlaceRepositoryMockUpdateExpectation

	callArgs []*IPlaceRepositoryMockUpdateParams
	mutex    sync.RWMutex
}

// IPlaceRepositoryMockUpdateExpectation specifies expectation struct of the IPlaceRepository.Update
type IPlaceRepositoryMockUpdateExpectation struct {
	mock    *IPlaceRepositoryMock
	params  *IPlaceRepositoryMockUpdateParams
	results *IPlaceRepositoryMockUpdateResults
	Counter uint64
}

// IPlaceRepositoryMockUpdateParams contains parameters of the IPlaceRepository.Update
type IPlaceRepositoryMockUpdateParams struct {
	ctx context.Context
	req models.UpdatePlaceRequest
	tx  *sql.Tx
}

// IPlaceRepositoryMockUpdateResults contains results of the IPlaceRepository.Update
type IPlaceRepositoryMockUpdateResults struct {
	err error
}

// Expect sets up expected params for IPlaceRepository.Update
func (mmUpdate *mIPlaceRepositoryMockUpdate) Expect(ctx context.Context, req models.UpdatePlaceRequest, tx *sql.Tx) *mIPlaceRepositoryMockUpdate {
	if mmUpdate.mock.funcUpdate != nil {
		mmUpdate.mock.t.Fatalf("IPlaceRepositoryMock.Update mock is already set by Set")
	}

	if mmUpdate.defaultExpectation == nil {
		mmUpdate.defaultExpectation = &IPlaceRepositoryMockUpdateExpectation{}
	}

	mmUpdate.defaultExpectation.params = &IPlaceRepositoryMockUpdateParams{ctx, req, tx}
	for _, e := range mmUpdate.expectations {
		if minimock.Equal(e.params, mmUpdate.defaultExpectation.params) {
			mmUpdate.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmUpdate.defaultExpectation.params)
		}
	}

	return mmUpdate
}

// Inspect accepts an inspector function that has same arguments as the IPlaceRepository.Update
func (mmUpdate *mIPlaceRepositoryMockUpdate) Inspect(f func(ctx context.Context, req models.UpdatePlaceRequest, tx *sql.Tx)) *mIPlaceRepositoryMockUpdate {
	if mmUpdate.mock.inspectFuncUpdate != nil {
		mmUpdate.mock.t.Fatalf("Inspect function is already set for IPlaceRepositoryMock.Update")
	}

	mmUpdate.mock.inspectFuncUpdate = f

	return mmUpdate
}

// Return sets up results that will be returned by IPlaceRepository.Update
func (mmUpdate *mIPlaceRepositoryMockUpdate) Return(err error) *IPlaceRepositoryMock {
	if mmUpdate.mock.funcUpdate != nil {
		mmUpdate.mock.t.Fatalf("IPlaceRepositoryMock.Update mock is already set by Set")
	}

	if mmUpdate.defaultExpectation == nil {
		mmUpdate.defaultExpectation = &IPlaceRepositoryMockUpdateExpectation{mock: mmUpdate.mock}
	}
	mmUpdate.defaultExpectation.results = &IPlaceRepositoryMockUpdateResults{err}
	return mmUpdate.mock
}

// Set uses given function f to mock the IPlaceRepository.Update method
func (mmUpdate *mIPlaceRepositoryMockUpdate) Set(f func(ctx context.Context, req models.UpdatePlaceRequest, tx *sql.Tx) (err error)) *IPlaceRepositoryMock {
	if mmUpdate.defaultExpectation != nil {
		mmUpdate.mock.t.Fatalf("Default expectation is already set for the IPlaceRepository.Update method")
	}

	if len(mmUpdate.expectations) > 0 {
		mmUpdate.mock.t.Fatalf("Some expectations are already set for the IPlaceRepository.Update method")
	}

	mmUpdate.mock.funcUpdate = f
	return mmUpdate.mock
}

// When sets expectation for the IPlaceRepository.Update which will trigger the result defined by the following
// Then helper
func (mmUpdate *mIPlaceRepositoryMockUpdate) When(ctx context.Context, req models.UpdatePlaceRequest, tx *sql.Tx) *IPlaceRepositoryMockUpdateExpectation {
	if mmUpdate.mock.funcUpdate != nil {
		mmUpdate.mock.t.Fatalf("IPlaceRepositoryMock.Update mock is already set by Set")
	}

	expectation := &IPlaceRepositoryMockUpdateExpectation{
		mock:   mmUpdate.mock,
		params: &IPlaceRepositoryMockUpdateParams{ctx, req, tx},
	}
	mmUpdate.expectations = append(mmUpdate.expectations, expectation)
	return expectation
}

// Then sets up IPlaceRepository.Update return parameters for the expectation previously defined by the When method
func (e *IPlaceRepositoryMockUpdateExpectation) Then(err error) *IPlaceRepositoryMock {
	e.results = &IPlaceRepositoryMockUpdateResults{err}
	return e.mock
}

// Update implements interfaces.IPlaceRepository
func (mmUpdate *IPlaceRepositoryMock) Update(ctx context.Context, req models.UpdatePlaceRequest, tx *sql.Tx) (err error) {
	mm_atomic.AddUint64(&mmUpdate.beforeUpdateCounter, 1)
	defer mm_atomic.AddUint64(&mmUpdate.afterUpdateCounter, 1)

	if mmUpdate.inspectFuncUpdate != nil {
		mmUpdate.inspectFuncUpdate(ctx, req, tx)
	}

	mm_params := &IPlaceRepositoryMockUpdateParams{ctx, req, tx}

	// Record call args
	mmUpdate.UpdateMock.mutex.Lock()
	mmUpdate.UpdateMock.callArgs = append(mmUpdate.UpdateMock.callArgs, mm_params)
	mmUpdate.UpdateMock.mutex.Unlock()

	for _, e := range mmUpdate.UpdateMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmUpdate.UpdateMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmUpdate.UpdateMock.defaultExpectation.Counter, 1)
		mm_want := mmUpdate.UpdateMock.defaultExpectation.params
		mm_got := IPlaceRepositoryMockUpdateParams{ctx, req, tx}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmUpdate.t.Errorf("IPlaceRepositoryMock.Update got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmUpdate.UpdateMock.defaultExpectation.results
		if mm_results == nil {
			mmUpdate.t.Fatal("No results are set for the IPlaceRepositoryMock.Update")
		}
		return (*mm_results).err
	}
	if mmUpdate.funcUpdate != nil {
		return mmUpdate.funcUpdate(ctx, req, tx)
	}
	mmUpdate.t.Fatalf("Unexpected call to IPlaceRepositoryMock.Update. %v %v %v", ctx, req, tx)
	return
}

// UpdateAfterCounter returns a count of finished IPlaceRepositoryMock.Update invocations
func (mmUpdate *IPlaceRepositoryMock) UpdateAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmUpdate.afterUpdateCounter)
}

// UpdateBeforeCounter returns a count of IPlaceRepositoryMock.Update invocations
func (mmUpdate *IPlaceRepositoryMock) UpdateBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmUpdate.beforeUpdateCounter)
}

// Calls returns a list of arguments used in each call to IPlaceRepositoryMock.Update.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmUpdate *mIPlaceRepositoryMockUpdate) Calls() []*IPlaceRepositoryMockUpdateParams {
	mmUpdate.mutex.RLock()

	argCopy := make([]*IPlaceRepositoryMockUpdateParams, len(mmUpdate.callArgs))
	copy(argCopy, mmUpdate.callArgs)

	mmUpdate.mutex.RUnlock()

	return argCopy
}

// MinimockUpdateDone returns true if the count of the Update invocations corresponds
// the number of defined expectations
func (m *IPlaceRepositoryMock) MinimockUpdateDone() bool {
	for _, e := range m.UpdateMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.UpdateMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterUpdateCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcUpdate != nil && mm_atomic.LoadUint64(&m.afterUpdateCounter) < 1 {
		return false
	}
	return true
}

// MinimockUpdateInspect logs each unmet expectation
func (m *IPlaceRepositoryMock) MinimockUpdateInspect() {
	for _, e := range m.UpdateMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IPlaceRepositoryMock.Update with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.UpdateMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterUpdateCounter) < 1 {
		if m.UpdateMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IPlaceRepositoryMock.Update")
		} else {
			m.t.Errorf("Expected call to IPlaceRepositoryMock.Update with params: %#v", *m.UpdateMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcUpdate != nil && mm_atomic.LoadUint64(&m.afterUpdateCounter) < 1 {
		m.t.Error("Expected call to IPlaceRepositoryMock.Update")
	}
}

// MinimockFinish checks that all mocked methods have been called the expected number of times
func (m *IPlaceRepositoryMock) MinimockFinish() {
	if !m.minimockDone() {
		m.MinimockAddInspect()

		m.MinimockBeginTxInspect()

		m.MinimockCommitTxInspect()

		m.MinimockDeleteInspect()

		m.MinimockGetInspect()

		m.MinimockGetAllInspect()

		m.MinimockGetNestedPlacesInspect()

		m.MinimockUpdateInspect()
		m.t.FailNow()
	}
}

// MinimockWait waits for all mocked methods to be called the expected number of times
func (m *IPlaceRepositoryMock) MinimockWait(timeout mm_time.Duration) {
	timeoutCh := mm_time.After(timeout)
	for {
		if m.minimockDone() {
			return
		}
		select {
		case <-timeoutCh:
			m.MinimockFinish()
			return
		case <-mm_time.After(10 * mm_time.Millisecond):
		}
	}
}

func (m *IPlaceRepositoryMock) minimockDone() bool {
	done := true
	return done &&
		m.MinimockAddDone() &&
		m.MinimockBeginTxDone() &&
		m.MinimockCommitTxDone() &&
		m.MinimockDeleteDone() &&
		m.MinimockGetDone() &&
		m.MinimockGetAllDone() &&
		m.MinimockGetNestedPlacesDone() &&
		m.MinimockUpdateDone()
}
