package mocks

// Code generated by http://github.com/gojuno/minimock (dev). DO NOT EDIT.

//go:generate minimock -i git.dmitriygnatenko.ru/dima/homethings/internal/interfaces.IPlaceThingRepository -o ./mocks/i_place_thing_repository_minimock.go -n IPlaceThingRepositoryMock

import (
	"context"
	"database/sql"
	"sync"
	mm_atomic "sync/atomic"
	mm_time "time"

	"git.dmitriygnatenko.ru/dima/homethings/internal/models"
	"github.com/gojuno/minimock/v3"
)

// IPlaceThingRepositoryMock implements interfaces.IPlaceThingRepository
type IPlaceThingRepositoryMock struct {
	t minimock.Tester

	funcAdd          func(ctx context.Context, req models.AddPlaceThingRequest, tx *sql.Tx) (err error)
	inspectFuncAdd   func(ctx context.Context, req models.AddPlaceThingRequest, tx *sql.Tx)
	afterAddCounter  uint64
	beforeAddCounter uint64
	AddMock          mIPlaceThingRepositoryMockAdd

	funcDeleteThing          func(ctx context.Context, thingID int, tx *sql.Tx) (err error)
	inspectFuncDeleteThing   func(ctx context.Context, thingID int, tx *sql.Tx)
	afterDeleteThingCounter  uint64
	beforeDeleteThingCounter uint64
	DeleteThingMock          mIPlaceThingRepositoryMockDeleteThing

	funcGetByThingID          func(ctx context.Context, thingID int) (pp1 *models.PlaceThing, err error)
	inspectFuncGetByThingID   func(ctx context.Context, thingID int)
	afterGetByThingIDCounter  uint64
	beforeGetByThingIDCounter uint64
	GetByThingIDMock          mIPlaceThingRepositoryMockGetByThingID

	funcUpdatePlace          func(ctx context.Context, req models.UpdatePlaceThingRequest, tx *sql.Tx) (err error)
	inspectFuncUpdatePlace   func(ctx context.Context, req models.UpdatePlaceThingRequest, tx *sql.Tx)
	afterUpdatePlaceCounter  uint64
	beforeUpdatePlaceCounter uint64
	UpdatePlaceMock          mIPlaceThingRepositoryMockUpdatePlace
}

// NewIPlaceThingRepositoryMock returns a mock for interfaces.IPlaceThingRepository
func NewIPlaceThingRepositoryMock(t minimock.Tester) *IPlaceThingRepositoryMock {
	m := &IPlaceThingRepositoryMock{t: t}
	if controller, ok := t.(minimock.MockController); ok {
		controller.RegisterMocker(m)
	}

	m.AddMock = mIPlaceThingRepositoryMockAdd{mock: m}
	m.AddMock.callArgs = []*IPlaceThingRepositoryMockAddParams{}

	m.DeleteThingMock = mIPlaceThingRepositoryMockDeleteThing{mock: m}
	m.DeleteThingMock.callArgs = []*IPlaceThingRepositoryMockDeleteThingParams{}

	m.GetByThingIDMock = mIPlaceThingRepositoryMockGetByThingID{mock: m}
	m.GetByThingIDMock.callArgs = []*IPlaceThingRepositoryMockGetByThingIDParams{}

	m.UpdatePlaceMock = mIPlaceThingRepositoryMockUpdatePlace{mock: m}
	m.UpdatePlaceMock.callArgs = []*IPlaceThingRepositoryMockUpdatePlaceParams{}

	return m
}

type mIPlaceThingRepositoryMockAdd struct {
	mock               *IPlaceThingRepositoryMock
	defaultExpectation *IPlaceThingRepositoryMockAddExpectation
	expectations       []*IPlaceThingRepositoryMockAddExpectation

	callArgs []*IPlaceThingRepositoryMockAddParams
	mutex    sync.RWMutex
}

// IPlaceThingRepositoryMockAddExpectation specifies expectation struct of the IPlaceThingRepository.Add
type IPlaceThingRepositoryMockAddExpectation struct {
	mock    *IPlaceThingRepositoryMock
	params  *IPlaceThingRepositoryMockAddParams
	results *IPlaceThingRepositoryMockAddResults
	Counter uint64
}

// IPlaceThingRepositoryMockAddParams contains parameters of the IPlaceThingRepository.Add
type IPlaceThingRepositoryMockAddParams struct {
	ctx context.Context
	req models.AddPlaceThingRequest
	tx  *sql.Tx
}

// IPlaceThingRepositoryMockAddResults contains results of the IPlaceThingRepository.Add
type IPlaceThingRepositoryMockAddResults struct {
	err error
}

// Expect sets up expected params for IPlaceThingRepository.Add
func (mmAdd *mIPlaceThingRepositoryMockAdd) Expect(ctx context.Context, req models.AddPlaceThingRequest, tx *sql.Tx) *mIPlaceThingRepositoryMockAdd {
	if mmAdd.mock.funcAdd != nil {
		mmAdd.mock.t.Fatalf("IPlaceThingRepositoryMock.Add mock is already set by Set")
	}

	if mmAdd.defaultExpectation == nil {
		mmAdd.defaultExpectation = &IPlaceThingRepositoryMockAddExpectation{}
	}

	mmAdd.defaultExpectation.params = &IPlaceThingRepositoryMockAddParams{ctx, req, tx}
	for _, e := range mmAdd.expectations {
		if minimock.Equal(e.params, mmAdd.defaultExpectation.params) {
			mmAdd.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmAdd.defaultExpectation.params)
		}
	}

	return mmAdd
}

// Inspect accepts an inspector function that has same arguments as the IPlaceThingRepository.Add
func (mmAdd *mIPlaceThingRepositoryMockAdd) Inspect(f func(ctx context.Context, req models.AddPlaceThingRequest, tx *sql.Tx)) *mIPlaceThingRepositoryMockAdd {
	if mmAdd.mock.inspectFuncAdd != nil {
		mmAdd.mock.t.Fatalf("Inspect function is already set for IPlaceThingRepositoryMock.Add")
	}

	mmAdd.mock.inspectFuncAdd = f

	return mmAdd
}

// Return sets up results that will be returned by IPlaceThingRepository.Add
func (mmAdd *mIPlaceThingRepositoryMockAdd) Return(err error) *IPlaceThingRepositoryMock {
	if mmAdd.mock.funcAdd != nil {
		mmAdd.mock.t.Fatalf("IPlaceThingRepositoryMock.Add mock is already set by Set")
	}

	if mmAdd.defaultExpectation == nil {
		mmAdd.defaultExpectation = &IPlaceThingRepositoryMockAddExpectation{mock: mmAdd.mock}
	}
	mmAdd.defaultExpectation.results = &IPlaceThingRepositoryMockAddResults{err}
	return mmAdd.mock
}

// Set uses given function f to mock the IPlaceThingRepository.Add method
func (mmAdd *mIPlaceThingRepositoryMockAdd) Set(f func(ctx context.Context, req models.AddPlaceThingRequest, tx *sql.Tx) (err error)) *IPlaceThingRepositoryMock {
	if mmAdd.defaultExpectation != nil {
		mmAdd.mock.t.Fatalf("Default expectation is already set for the IPlaceThingRepository.Add method")
	}

	if len(mmAdd.expectations) > 0 {
		mmAdd.mock.t.Fatalf("Some expectations are already set for the IPlaceThingRepository.Add method")
	}

	mmAdd.mock.funcAdd = f
	return mmAdd.mock
}

// When sets expectation for the IPlaceThingRepository.Add which will trigger the result defined by the following
// Then helper
func (mmAdd *mIPlaceThingRepositoryMockAdd) When(ctx context.Context, req models.AddPlaceThingRequest, tx *sql.Tx) *IPlaceThingRepositoryMockAddExpectation {
	if mmAdd.mock.funcAdd != nil {
		mmAdd.mock.t.Fatalf("IPlaceThingRepositoryMock.Add mock is already set by Set")
	}

	expectation := &IPlaceThingRepositoryMockAddExpectation{
		mock:   mmAdd.mock,
		params: &IPlaceThingRepositoryMockAddParams{ctx, req, tx},
	}
	mmAdd.expectations = append(mmAdd.expectations, expectation)
	return expectation
}

// Then sets up IPlaceThingRepository.Add return parameters for the expectation previously defined by the When method
func (e *IPlaceThingRepositoryMockAddExpectation) Then(err error) *IPlaceThingRepositoryMock {
	e.results = &IPlaceThingRepositoryMockAddResults{err}
	return e.mock
}

// Add implements interfaces.IPlaceThingRepository
func (mmAdd *IPlaceThingRepositoryMock) Add(ctx context.Context, req models.AddPlaceThingRequest, tx *sql.Tx) (err error) {
	mm_atomic.AddUint64(&mmAdd.beforeAddCounter, 1)
	defer mm_atomic.AddUint64(&mmAdd.afterAddCounter, 1)

	if mmAdd.inspectFuncAdd != nil {
		mmAdd.inspectFuncAdd(ctx, req, tx)
	}

	mm_params := &IPlaceThingRepositoryMockAddParams{ctx, req, tx}

	// Record call args
	mmAdd.AddMock.mutex.Lock()
	mmAdd.AddMock.callArgs = append(mmAdd.AddMock.callArgs, mm_params)
	mmAdd.AddMock.mutex.Unlock()

	for _, e := range mmAdd.AddMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmAdd.AddMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmAdd.AddMock.defaultExpectation.Counter, 1)
		mm_want := mmAdd.AddMock.defaultExpectation.params
		mm_got := IPlaceThingRepositoryMockAddParams{ctx, req, tx}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmAdd.t.Errorf("IPlaceThingRepositoryMock.Add got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmAdd.AddMock.defaultExpectation.results
		if mm_results == nil {
			mmAdd.t.Fatal("No results are set for the IPlaceThingRepositoryMock.Add")
		}
		return (*mm_results).err
	}
	if mmAdd.funcAdd != nil {
		return mmAdd.funcAdd(ctx, req, tx)
	}
	mmAdd.t.Fatalf("Unexpected call to IPlaceThingRepositoryMock.Add. %v %v %v", ctx, req, tx)
	return
}

// AddAfterCounter returns a count of finished IPlaceThingRepositoryMock.Add invocations
func (mmAdd *IPlaceThingRepositoryMock) AddAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmAdd.afterAddCounter)
}

// AddBeforeCounter returns a count of IPlaceThingRepositoryMock.Add invocations
func (mmAdd *IPlaceThingRepositoryMock) AddBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmAdd.beforeAddCounter)
}

// Calls returns a list of arguments used in each call to IPlaceThingRepositoryMock.Add.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmAdd *mIPlaceThingRepositoryMockAdd) Calls() []*IPlaceThingRepositoryMockAddParams {
	mmAdd.mutex.RLock()

	argCopy := make([]*IPlaceThingRepositoryMockAddParams, len(mmAdd.callArgs))
	copy(argCopy, mmAdd.callArgs)

	mmAdd.mutex.RUnlock()

	return argCopy
}

// MinimockAddDone returns true if the count of the Add invocations corresponds
// the number of defined expectations
func (m *IPlaceThingRepositoryMock) MinimockAddDone() bool {
	for _, e := range m.AddMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.AddMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcAdd != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		return false
	}
	return true
}

// MinimockAddInspect logs each unmet expectation
func (m *IPlaceThingRepositoryMock) MinimockAddInspect() {
	for _, e := range m.AddMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IPlaceThingRepositoryMock.Add with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.AddMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		if m.AddMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IPlaceThingRepositoryMock.Add")
		} else {
			m.t.Errorf("Expected call to IPlaceThingRepositoryMock.Add with params: %#v", *m.AddMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcAdd != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		m.t.Error("Expected call to IPlaceThingRepositoryMock.Add")
	}
}

type mIPlaceThingRepositoryMockDeleteThing struct {
	mock               *IPlaceThingRepositoryMock
	defaultExpectation *IPlaceThingRepositoryMockDeleteThingExpectation
	expectations       []*IPlaceThingRepositoryMockDeleteThingExpectation

	callArgs []*IPlaceThingRepositoryMockDeleteThingParams
	mutex    sync.RWMutex
}

// IPlaceThingRepositoryMockDeleteThingExpectation specifies expectation struct of the IPlaceThingRepository.DeleteThing
type IPlaceThingRepositoryMockDeleteThingExpectation struct {
	mock    *IPlaceThingRepositoryMock
	params  *IPlaceThingRepositoryMockDeleteThingParams
	results *IPlaceThingRepositoryMockDeleteThingResults
	Counter uint64
}

// IPlaceThingRepositoryMockDeleteThingParams contains parameters of the IPlaceThingRepository.DeleteThing
type IPlaceThingRepositoryMockDeleteThingParams struct {
	ctx     context.Context
	thingID int
	tx      *sql.Tx
}

// IPlaceThingRepositoryMockDeleteThingResults contains results of the IPlaceThingRepository.DeleteThing
type IPlaceThingRepositoryMockDeleteThingResults struct {
	err error
}

// Expect sets up expected params for IPlaceThingRepository.DeleteThing
func (mmDeleteThing *mIPlaceThingRepositoryMockDeleteThing) Expect(ctx context.Context, thingID int, tx *sql.Tx) *mIPlaceThingRepositoryMockDeleteThing {
	if mmDeleteThing.mock.funcDeleteThing != nil {
		mmDeleteThing.mock.t.Fatalf("IPlaceThingRepositoryMock.DeleteThing mock is already set by Set")
	}

	if mmDeleteThing.defaultExpectation == nil {
		mmDeleteThing.defaultExpectation = &IPlaceThingRepositoryMockDeleteThingExpectation{}
	}

	mmDeleteThing.defaultExpectation.params = &IPlaceThingRepositoryMockDeleteThingParams{ctx, thingID, tx}
	for _, e := range mmDeleteThing.expectations {
		if minimock.Equal(e.params, mmDeleteThing.defaultExpectation.params) {
			mmDeleteThing.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmDeleteThing.defaultExpectation.params)
		}
	}

	return mmDeleteThing
}

// Inspect accepts an inspector function that has same arguments as the IPlaceThingRepository.DeleteThing
func (mmDeleteThing *mIPlaceThingRepositoryMockDeleteThing) Inspect(f func(ctx context.Context, thingID int, tx *sql.Tx)) *mIPlaceThingRepositoryMockDeleteThing {
	if mmDeleteThing.mock.inspectFuncDeleteThing != nil {
		mmDeleteThing.mock.t.Fatalf("Inspect function is already set for IPlaceThingRepositoryMock.DeleteThing")
	}

	mmDeleteThing.mock.inspectFuncDeleteThing = f

	return mmDeleteThing
}

// Return sets up results that will be returned by IPlaceThingRepository.DeleteThing
func (mmDeleteThing *mIPlaceThingRepositoryMockDeleteThing) Return(err error) *IPlaceThingRepositoryMock {
	if mmDeleteThing.mock.funcDeleteThing != nil {
		mmDeleteThing.mock.t.Fatalf("IPlaceThingRepositoryMock.DeleteThing mock is already set by Set")
	}

	if mmDeleteThing.defaultExpectation == nil {
		mmDeleteThing.defaultExpectation = &IPlaceThingRepositoryMockDeleteThingExpectation{mock: mmDeleteThing.mock}
	}
	mmDeleteThing.defaultExpectation.results = &IPlaceThingRepositoryMockDeleteThingResults{err}
	return mmDeleteThing.mock
}

// Set uses given function f to mock the IPlaceThingRepository.DeleteThing method
func (mmDeleteThing *mIPlaceThingRepositoryMockDeleteThing) Set(f func(ctx context.Context, thingID int, tx *sql.Tx) (err error)) *IPlaceThingRepositoryMock {
	if mmDeleteThing.defaultExpectation != nil {
		mmDeleteThing.mock.t.Fatalf("Default expectation is already set for the IPlaceThingRepository.DeleteThing method")
	}

	if len(mmDeleteThing.expectations) > 0 {
		mmDeleteThing.mock.t.Fatalf("Some expectations are already set for the IPlaceThingRepository.DeleteThing method")
	}

	mmDeleteThing.mock.funcDeleteThing = f
	return mmDeleteThing.mock
}

// When sets expectation for the IPlaceThingRepository.DeleteThing which will trigger the result defined by the following
// Then helper
func (mmDeleteThing *mIPlaceThingRepositoryMockDeleteThing) When(ctx context.Context, thingID int, tx *sql.Tx) *IPlaceThingRepositoryMockDeleteThingExpectation {
	if mmDeleteThing.mock.funcDeleteThing != nil {
		mmDeleteThing.mock.t.Fatalf("IPlaceThingRepositoryMock.DeleteThing mock is already set by Set")
	}

	expectation := &IPlaceThingRepositoryMockDeleteThingExpectation{
		mock:   mmDeleteThing.mock,
		params: &IPlaceThingRepositoryMockDeleteThingParams{ctx, thingID, tx},
	}
	mmDeleteThing.expectations = append(mmDeleteThing.expectations, expectation)
	return expectation
}

// Then sets up IPlaceThingRepository.DeleteThing return parameters for the expectation previously defined by the When method
func (e *IPlaceThingRepositoryMockDeleteThingExpectation) Then(err error) *IPlaceThingRepositoryMock {
	e.results = &IPlaceThingRepositoryMockDeleteThingResults{err}
	return e.mock
}

// DeleteThing implements interfaces.IPlaceThingRepository
func (mmDeleteThing *IPlaceThingRepositoryMock) DeleteThing(ctx context.Context, thingID int, tx *sql.Tx) (err error) {
	mm_atomic.AddUint64(&mmDeleteThing.beforeDeleteThingCounter, 1)
	defer mm_atomic.AddUint64(&mmDeleteThing.afterDeleteThingCounter, 1)

	if mmDeleteThing.inspectFuncDeleteThing != nil {
		mmDeleteThing.inspectFuncDeleteThing(ctx, thingID, tx)
	}

	mm_params := &IPlaceThingRepositoryMockDeleteThingParams{ctx, thingID, tx}

	// Record call args
	mmDeleteThing.DeleteThingMock.mutex.Lock()
	mmDeleteThing.DeleteThingMock.callArgs = append(mmDeleteThing.DeleteThingMock.callArgs, mm_params)
	mmDeleteThing.DeleteThingMock.mutex.Unlock()

	for _, e := range mmDeleteThing.DeleteThingMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmDeleteThing.DeleteThingMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmDeleteThing.DeleteThingMock.defaultExpectation.Counter, 1)
		mm_want := mmDeleteThing.DeleteThingMock.defaultExpectation.params
		mm_got := IPlaceThingRepositoryMockDeleteThingParams{ctx, thingID, tx}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmDeleteThing.t.Errorf("IPlaceThingRepositoryMock.DeleteThing got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmDeleteThing.DeleteThingMock.defaultExpectation.results
		if mm_results == nil {
			mmDeleteThing.t.Fatal("No results are set for the IPlaceThingRepositoryMock.DeleteThing")
		}
		return (*mm_results).err
	}
	if mmDeleteThing.funcDeleteThing != nil {
		return mmDeleteThing.funcDeleteThing(ctx, thingID, tx)
	}
	mmDeleteThing.t.Fatalf("Unexpected call to IPlaceThingRepositoryMock.DeleteThing. %v %v %v", ctx, thingID, tx)
	return
}

// DeleteThingAfterCounter returns a count of finished IPlaceThingRepositoryMock.DeleteThing invocations
func (mmDeleteThing *IPlaceThingRepositoryMock) DeleteThingAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmDeleteThing.afterDeleteThingCounter)
}

// DeleteThingBeforeCounter returns a count of IPlaceThingRepositoryMock.DeleteThing invocations
func (mmDeleteThing *IPlaceThingRepositoryMock) DeleteThingBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmDeleteThing.beforeDeleteThingCounter)
}

// Calls returns a list of arguments used in each call to IPlaceThingRepositoryMock.DeleteThing.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmDeleteThing *mIPlaceThingRepositoryMockDeleteThing) Calls() []*IPlaceThingRepositoryMockDeleteThingParams {
	mmDeleteThing.mutex.RLock()

	argCopy := make([]*IPlaceThingRepositoryMockDeleteThingParams, len(mmDeleteThing.callArgs))
	copy(argCopy, mmDeleteThing.callArgs)

	mmDeleteThing.mutex.RUnlock()

	return argCopy
}

// MinimockDeleteThingDone returns true if the count of the DeleteThing invocations corresponds
// the number of defined expectations
func (m *IPlaceThingRepositoryMock) MinimockDeleteThingDone() bool {
	for _, e := range m.DeleteThingMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.DeleteThingMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterDeleteThingCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcDeleteThing != nil && mm_atomic.LoadUint64(&m.afterDeleteThingCounter) < 1 {
		return false
	}
	return true
}

// MinimockDeleteThingInspect logs each unmet expectation
func (m *IPlaceThingRepositoryMock) MinimockDeleteThingInspect() {
	for _, e := range m.DeleteThingMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IPlaceThingRepositoryMock.DeleteThing with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.DeleteThingMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterDeleteThingCounter) < 1 {
		if m.DeleteThingMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IPlaceThingRepositoryMock.DeleteThing")
		} else {
			m.t.Errorf("Expected call to IPlaceThingRepositoryMock.DeleteThing with params: %#v", *m.DeleteThingMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcDeleteThing != nil && mm_atomic.LoadUint64(&m.afterDeleteThingCounter) < 1 {
		m.t.Error("Expected call to IPlaceThingRepositoryMock.DeleteThing")
	}
}

type mIPlaceThingRepositoryMockGetByThingID struct {
	mock               *IPlaceThingRepositoryMock
	defaultExpectation *IPlaceThingRepositoryMockGetByThingIDExpectation
	expectations       []*IPlaceThingRepositoryMockGetByThingIDExpectation

	callArgs []*IPlaceThingRepositoryMockGetByThingIDParams
	mutex    sync.RWMutex
}

// IPlaceThingRepositoryMockGetByThingIDExpectation specifies expectation struct of the IPlaceThingRepository.GetByThingID
type IPlaceThingRepositoryMockGetByThingIDExpectation struct {
	mock    *IPlaceThingRepositoryMock
	params  *IPlaceThingRepositoryMockGetByThingIDParams
	results *IPlaceThingRepositoryMockGetByThingIDResults
	Counter uint64
}

// IPlaceThingRepositoryMockGetByThingIDParams contains parameters of the IPlaceThingRepository.GetByThingID
type IPlaceThingRepositoryMockGetByThingIDParams struct {
	ctx     context.Context
	thingID int
}

// IPlaceThingRepositoryMockGetByThingIDResults contains results of the IPlaceThingRepository.GetByThingID
type IPlaceThingRepositoryMockGetByThingIDResults struct {
	pp1 *models.PlaceThing
	err error
}

// Expect sets up expected params for IPlaceThingRepository.GetByThingID
func (mmGetByThingID *mIPlaceThingRepositoryMockGetByThingID) Expect(ctx context.Context, thingID int) *mIPlaceThingRepositoryMockGetByThingID {
	if mmGetByThingID.mock.funcGetByThingID != nil {
		mmGetByThingID.mock.t.Fatalf("IPlaceThingRepositoryMock.GetByThingID mock is already set by Set")
	}

	if mmGetByThingID.defaultExpectation == nil {
		mmGetByThingID.defaultExpectation = &IPlaceThingRepositoryMockGetByThingIDExpectation{}
	}

	mmGetByThingID.defaultExpectation.params = &IPlaceThingRepositoryMockGetByThingIDParams{ctx, thingID}
	for _, e := range mmGetByThingID.expectations {
		if minimock.Equal(e.params, mmGetByThingID.defaultExpectation.params) {
			mmGetByThingID.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmGetByThingID.defaultExpectation.params)
		}
	}

	return mmGetByThingID
}

// Inspect accepts an inspector function that has same arguments as the IPlaceThingRepository.GetByThingID
func (mmGetByThingID *mIPlaceThingRepositoryMockGetByThingID) Inspect(f func(ctx context.Context, thingID int)) *mIPlaceThingRepositoryMockGetByThingID {
	if mmGetByThingID.mock.inspectFuncGetByThingID != nil {
		mmGetByThingID.mock.t.Fatalf("Inspect function is already set for IPlaceThingRepositoryMock.GetByThingID")
	}

	mmGetByThingID.mock.inspectFuncGetByThingID = f

	return mmGetByThingID
}

// Return sets up results that will be returned by IPlaceThingRepository.GetByThingID
func (mmGetByThingID *mIPlaceThingRepositoryMockGetByThingID) Return(pp1 *models.PlaceThing, err error) *IPlaceThingRepositoryMock {
	if mmGetByThingID.mock.funcGetByThingID != nil {
		mmGetByThingID.mock.t.Fatalf("IPlaceThingRepositoryMock.GetByThingID mock is already set by Set")
	}

	if mmGetByThingID.defaultExpectation == nil {
		mmGetByThingID.defaultExpectation = &IPlaceThingRepositoryMockGetByThingIDExpectation{mock: mmGetByThingID.mock}
	}
	mmGetByThingID.defaultExpectation.results = &IPlaceThingRepositoryMockGetByThingIDResults{pp1, err}
	return mmGetByThingID.mock
}

// Set uses given function f to mock the IPlaceThingRepository.GetByThingID method
func (mmGetByThingID *mIPlaceThingRepositoryMockGetByThingID) Set(f func(ctx context.Context, thingID int) (pp1 *models.PlaceThing, err error)) *IPlaceThingRepositoryMock {
	if mmGetByThingID.defaultExpectation != nil {
		mmGetByThingID.mock.t.Fatalf("Default expectation is already set for the IPlaceThingRepository.GetByThingID method")
	}

	if len(mmGetByThingID.expectations) > 0 {
		mmGetByThingID.mock.t.Fatalf("Some expectations are already set for the IPlaceThingRepository.GetByThingID method")
	}

	mmGetByThingID.mock.funcGetByThingID = f
	return mmGetByThingID.mock
}

// When sets expectation for the IPlaceThingRepository.GetByThingID which will trigger the result defined by the following
// Then helper
func (mmGetByThingID *mIPlaceThingRepositoryMockGetByThingID) When(ctx context.Context, thingID int) *IPlaceThingRepositoryMockGetByThingIDExpectation {
	if mmGetByThingID.mock.funcGetByThingID != nil {
		mmGetByThingID.mock.t.Fatalf("IPlaceThingRepositoryMock.GetByThingID mock is already set by Set")
	}

	expectation := &IPlaceThingRepositoryMockGetByThingIDExpectation{
		mock:   mmGetByThingID.mock,
		params: &IPlaceThingRepositoryMockGetByThingIDParams{ctx, thingID},
	}
	mmGetByThingID.expectations = append(mmGetByThingID.expectations, expectation)
	return expectation
}

// Then sets up IPlaceThingRepository.GetByThingID return parameters for the expectation previously defined by the When method
func (e *IPlaceThingRepositoryMockGetByThingIDExpectation) Then(pp1 *models.PlaceThing, err error) *IPlaceThingRepositoryMock {
	e.results = &IPlaceThingRepositoryMockGetByThingIDResults{pp1, err}
	return e.mock
}

// GetByThingID implements interfaces.IPlaceThingRepository
func (mmGetByThingID *IPlaceThingRepositoryMock) GetByThingID(ctx context.Context, thingID int) (pp1 *models.PlaceThing, err error) {
	mm_atomic.AddUint64(&mmGetByThingID.beforeGetByThingIDCounter, 1)
	defer mm_atomic.AddUint64(&mmGetByThingID.afterGetByThingIDCounter, 1)

	if mmGetByThingID.inspectFuncGetByThingID != nil {
		mmGetByThingID.inspectFuncGetByThingID(ctx, thingID)
	}

	mm_params := &IPlaceThingRepositoryMockGetByThingIDParams{ctx, thingID}

	// Record call args
	mmGetByThingID.GetByThingIDMock.mutex.Lock()
	mmGetByThingID.GetByThingIDMock.callArgs = append(mmGetByThingID.GetByThingIDMock.callArgs, mm_params)
	mmGetByThingID.GetByThingIDMock.mutex.Unlock()

	for _, e := range mmGetByThingID.GetByThingIDMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.pp1, e.results.err
		}
	}

	if mmGetByThingID.GetByThingIDMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmGetByThingID.GetByThingIDMock.defaultExpectation.Counter, 1)
		mm_want := mmGetByThingID.GetByThingIDMock.defaultExpectation.params
		mm_got := IPlaceThingRepositoryMockGetByThingIDParams{ctx, thingID}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmGetByThingID.t.Errorf("IPlaceThingRepositoryMock.GetByThingID got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmGetByThingID.GetByThingIDMock.defaultExpectation.results
		if mm_results == nil {
			mmGetByThingID.t.Fatal("No results are set for the IPlaceThingRepositoryMock.GetByThingID")
		}
		return (*mm_results).pp1, (*mm_results).err
	}
	if mmGetByThingID.funcGetByThingID != nil {
		return mmGetByThingID.funcGetByThingID(ctx, thingID)
	}
	mmGetByThingID.t.Fatalf("Unexpected call to IPlaceThingRepositoryMock.GetByThingID. %v %v", ctx, thingID)
	return
}

// GetByThingIDAfterCounter returns a count of finished IPlaceThingRepositoryMock.GetByThingID invocations
func (mmGetByThingID *IPlaceThingRepositoryMock) GetByThingIDAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGetByThingID.afterGetByThingIDCounter)
}

// GetByThingIDBeforeCounter returns a count of IPlaceThingRepositoryMock.GetByThingID invocations
func (mmGetByThingID *IPlaceThingRepositoryMock) GetByThingIDBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGetByThingID.beforeGetByThingIDCounter)
}

// Calls returns a list of arguments used in each call to IPlaceThingRepositoryMock.GetByThingID.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmGetByThingID *mIPlaceThingRepositoryMockGetByThingID) Calls() []*IPlaceThingRepositoryMockGetByThingIDParams {
	mmGetByThingID.mutex.RLock()

	argCopy := make([]*IPlaceThingRepositoryMockGetByThingIDParams, len(mmGetByThingID.callArgs))
	copy(argCopy, mmGetByThingID.callArgs)

	mmGetByThingID.mutex.RUnlock()

	return argCopy
}

// MinimockGetByThingIDDone returns true if the count of the GetByThingID invocations corresponds
// the number of defined expectations
func (m *IPlaceThingRepositoryMock) MinimockGetByThingIDDone() bool {
	for _, e := range m.GetByThingIDMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetByThingIDMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetByThingIDCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGetByThingID != nil && mm_atomic.LoadUint64(&m.afterGetByThingIDCounter) < 1 {
		return false
	}
	return true
}

// MinimockGetByThingIDInspect logs each unmet expectation
func (m *IPlaceThingRepositoryMock) MinimockGetByThingIDInspect() {
	for _, e := range m.GetByThingIDMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IPlaceThingRepositoryMock.GetByThingID with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetByThingIDMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetByThingIDCounter) < 1 {
		if m.GetByThingIDMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IPlaceThingRepositoryMock.GetByThingID")
		} else {
			m.t.Errorf("Expected call to IPlaceThingRepositoryMock.GetByThingID with params: %#v", *m.GetByThingIDMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGetByThingID != nil && mm_atomic.LoadUint64(&m.afterGetByThingIDCounter) < 1 {
		m.t.Error("Expected call to IPlaceThingRepositoryMock.GetByThingID")
	}
}

type mIPlaceThingRepositoryMockUpdatePlace struct {
	mock               *IPlaceThingRepositoryMock
	defaultExpectation *IPlaceThingRepositoryMockUpdatePlaceExpectation
	expectations       []*IPlaceThingRepositoryMockUpdatePlaceExpectation

	callArgs []*IPlaceThingRepositoryMockUpdatePlaceParams
	mutex    sync.RWMutex
}

// IPlaceThingRepositoryMockUpdatePlaceExpectation specifies expectation struct of the IPlaceThingRepository.UpdatePlace
type IPlaceThingRepositoryMockUpdatePlaceExpectation struct {
	mock    *IPlaceThingRepositoryMock
	params  *IPlaceThingRepositoryMockUpdatePlaceParams
	results *IPlaceThingRepositoryMockUpdatePlaceResults
	Counter uint64
}

// IPlaceThingRepositoryMockUpdatePlaceParams contains parameters of the IPlaceThingRepository.UpdatePlace
type IPlaceThingRepositoryMockUpdatePlaceParams struct {
	ctx context.Context
	req models.UpdatePlaceThingRequest
	tx  *sql.Tx
}

// IPlaceThingRepositoryMockUpdatePlaceResults contains results of the IPlaceThingRepository.UpdatePlace
type IPlaceThingRepositoryMockUpdatePlaceResults struct {
	err error
}

// Expect sets up expected params for IPlaceThingRepository.UpdatePlace
func (mmUpdatePlace *mIPlaceThingRepositoryMockUpdatePlace) Expect(ctx context.Context, req models.UpdatePlaceThingRequest, tx *sql.Tx) *mIPlaceThingRepositoryMockUpdatePlace {
	if mmUpdatePlace.mock.funcUpdatePlace != nil {
		mmUpdatePlace.mock.t.Fatalf("IPlaceThingRepositoryMock.UpdatePlace mock is already set by Set")
	}

	if mmUpdatePlace.defaultExpectation == nil {
		mmUpdatePlace.defaultExpectation = &IPlaceThingRepositoryMockUpdatePlaceExpectation{}
	}

	mmUpdatePlace.defaultExpectation.params = &IPlaceThingRepositoryMockUpdatePlaceParams{ctx, req, tx}
	for _, e := range mmUpdatePlace.expectations {
		if minimock.Equal(e.params, mmUpdatePlace.defaultExpectation.params) {
			mmUpdatePlace.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmUpdatePlace.defaultExpectation.params)
		}
	}

	return mmUpdatePlace
}

// Inspect accepts an inspector function that has same arguments as the IPlaceThingRepository.UpdatePlace
func (mmUpdatePlace *mIPlaceThingRepositoryMockUpdatePlace) Inspect(f func(ctx context.Context, req models.UpdatePlaceThingRequest, tx *sql.Tx)) *mIPlaceThingRepositoryMockUpdatePlace {
	if mmUpdatePlace.mock.inspectFuncUpdatePlace != nil {
		mmUpdatePlace.mock.t.Fatalf("Inspect function is already set for IPlaceThingRepositoryMock.UpdatePlace")
	}

	mmUpdatePlace.mock.inspectFuncUpdatePlace = f

	return mmUpdatePlace
}

// Return sets up results that will be returned by IPlaceThingRepository.UpdatePlace
func (mmUpdatePlace *mIPlaceThingRepositoryMockUpdatePlace) Return(err error) *IPlaceThingRepositoryMock {
	if mmUpdatePlace.mock.funcUpdatePlace != nil {
		mmUpdatePlace.mock.t.Fatalf("IPlaceThingRepositoryMock.UpdatePlace mock is already set by Set")
	}

	if mmUpdatePlace.defaultExpectation == nil {
		mmUpdatePlace.defaultExpectation = &IPlaceThingRepositoryMockUpdatePlaceExpectation{mock: mmUpdatePlace.mock}
	}
	mmUpdatePlace.defaultExpectation.results = &IPlaceThingRepositoryMockUpdatePlaceResults{err}
	return mmUpdatePlace.mock
}

// Set uses given function f to mock the IPlaceThingRepository.UpdatePlace method
func (mmUpdatePlace *mIPlaceThingRepositoryMockUpdatePlace) Set(f func(ctx context.Context, req models.UpdatePlaceThingRequest, tx *sql.Tx) (err error)) *IPlaceThingRepositoryMock {
	if mmUpdatePlace.defaultExpectation != nil {
		mmUpdatePlace.mock.t.Fatalf("Default expectation is already set for the IPlaceThingRepository.UpdatePlace method")
	}

	if len(mmUpdatePlace.expectations) > 0 {
		mmUpdatePlace.mock.t.Fatalf("Some expectations are already set for the IPlaceThingRepository.UpdatePlace method")
	}

	mmUpdatePlace.mock.funcUpdatePlace = f
	return mmUpdatePlace.mock
}

// When sets expectation for the IPlaceThingRepository.UpdatePlace which will trigger the result defined by the following
// Then helper
func (mmUpdatePlace *mIPlaceThingRepositoryMockUpdatePlace) When(ctx context.Context, req models.UpdatePlaceThingRequest, tx *sql.Tx) *IPlaceThingRepositoryMockUpdatePlaceExpectation {
	if mmUpdatePlace.mock.funcUpdatePlace != nil {
		mmUpdatePlace.mock.t.Fatalf("IPlaceThingRepositoryMock.UpdatePlace mock is already set by Set")
	}

	expectation := &IPlaceThingRepositoryMockUpdatePlaceExpectation{
		mock:   mmUpdatePlace.mock,
		params: &IPlaceThingRepositoryMockUpdatePlaceParams{ctx, req, tx},
	}
	mmUpdatePlace.expectations = append(mmUpdatePlace.expectations, expectation)
	return expectation
}

// Then sets up IPlaceThingRepository.UpdatePlace return parameters for the expectation previously defined by the When method
func (e *IPlaceThingRepositoryMockUpdatePlaceExpectation) Then(err error) *IPlaceThingRepositoryMock {
	e.results = &IPlaceThingRepositoryMockUpdatePlaceResults{err}
	return e.mock
}

// UpdatePlace implements interfaces.IPlaceThingRepository
func (mmUpdatePlace *IPlaceThingRepositoryMock) UpdatePlace(ctx context.Context, req models.UpdatePlaceThingRequest, tx *sql.Tx) (err error) {
	mm_atomic.AddUint64(&mmUpdatePlace.beforeUpdatePlaceCounter, 1)
	defer mm_atomic.AddUint64(&mmUpdatePlace.afterUpdatePlaceCounter, 1)

	if mmUpdatePlace.inspectFuncUpdatePlace != nil {
		mmUpdatePlace.inspectFuncUpdatePlace(ctx, req, tx)
	}

	mm_params := &IPlaceThingRepositoryMockUpdatePlaceParams{ctx, req, tx}

	// Record call args
	mmUpdatePlace.UpdatePlaceMock.mutex.Lock()
	mmUpdatePlace.UpdatePlaceMock.callArgs = append(mmUpdatePlace.UpdatePlaceMock.callArgs, mm_params)
	mmUpdatePlace.UpdatePlaceMock.mutex.Unlock()

	for _, e := range mmUpdatePlace.UpdatePlaceMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmUpdatePlace.UpdatePlaceMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmUpdatePlace.UpdatePlaceMock.defaultExpectation.Counter, 1)
		mm_want := mmUpdatePlace.UpdatePlaceMock.defaultExpectation.params
		mm_got := IPlaceThingRepositoryMockUpdatePlaceParams{ctx, req, tx}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmUpdatePlace.t.Errorf("IPlaceThingRepositoryMock.UpdatePlace got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmUpdatePlace.UpdatePlaceMock.defaultExpectation.results
		if mm_results == nil {
			mmUpdatePlace.t.Fatal("No results are set for the IPlaceThingRepositoryMock.UpdatePlace")
		}
		return (*mm_results).err
	}
	if mmUpdatePlace.funcUpdatePlace != nil {
		return mmUpdatePlace.funcUpdatePlace(ctx, req, tx)
	}
	mmUpdatePlace.t.Fatalf("Unexpected call to IPlaceThingRepositoryMock.UpdatePlace. %v %v %v", ctx, req, tx)
	return
}

// UpdatePlaceAfterCounter returns a count of finished IPlaceThingRepositoryMock.UpdatePlace invocations
func (mmUpdatePlace *IPlaceThingRepositoryMock) UpdatePlaceAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmUpdatePlace.afterUpdatePlaceCounter)
}

// UpdatePlaceBeforeCounter returns a count of IPlaceThingRepositoryMock.UpdatePlace invocations
func (mmUpdatePlace *IPlaceThingRepositoryMock) UpdatePlaceBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmUpdatePlace.beforeUpdatePlaceCounter)
}

// Calls returns a list of arguments used in each call to IPlaceThingRepositoryMock.UpdatePlace.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmUpdatePlace *mIPlaceThingRepositoryMockUpdatePlace) Calls() []*IPlaceThingRepositoryMockUpdatePlaceParams {
	mmUpdatePlace.mutex.RLock()

	argCopy := make([]*IPlaceThingRepositoryMockUpdatePlaceParams, len(mmUpdatePlace.callArgs))
	copy(argCopy, mmUpdatePlace.callArgs)

	mmUpdatePlace.mutex.RUnlock()

	return argCopy
}

// MinimockUpdatePlaceDone returns true if the count of the UpdatePlace invocations corresponds
// the number of defined expectations
func (m *IPlaceThingRepositoryMock) MinimockUpdatePlaceDone() bool {
	for _, e := range m.UpdatePlaceMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.UpdatePlaceMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterUpdatePlaceCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcUpdatePlace != nil && mm_atomic.LoadUint64(&m.afterUpdatePlaceCounter) < 1 {
		return false
	}
	return true
}

// MinimockUpdatePlaceInspect logs each unmet expectation
func (m *IPlaceThingRepositoryMock) MinimockUpdatePlaceInspect() {
	for _, e := range m.UpdatePlaceMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IPlaceThingRepositoryMock.UpdatePlace with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.UpdatePlaceMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterUpdatePlaceCounter) < 1 {
		if m.UpdatePlaceMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IPlaceThingRepositoryMock.UpdatePlace")
		} else {
			m.t.Errorf("Expected call to IPlaceThingRepositoryMock.UpdatePlace with params: %#v", *m.UpdatePlaceMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcUpdatePlace != nil && mm_atomic.LoadUint64(&m.afterUpdatePlaceCounter) < 1 {
		m.t.Error("Expected call to IPlaceThingRepositoryMock.UpdatePlace")
	}
}

// MinimockFinish checks that all mocked methods have been called the expected number of times
func (m *IPlaceThingRepositoryMock) MinimockFinish() {
	if !m.minimockDone() {
		m.MinimockAddInspect()

		m.MinimockDeleteThingInspect()

		m.MinimockGetByThingIDInspect()

		m.MinimockUpdatePlaceInspect()
		m.t.FailNow()
	}
}

// MinimockWait waits for all mocked methods to be called the expected number of times
func (m *IPlaceThingRepositoryMock) MinimockWait(timeout mm_time.Duration) {
	timeoutCh := mm_time.After(timeout)
	for {
		if m.minimockDone() {
			return
		}
		select {
		case <-timeoutCh:
			m.MinimockFinish()
			return
		case <-mm_time.After(10 * mm_time.Millisecond):
		}
	}
}

func (m *IPlaceThingRepositoryMock) minimockDone() bool {
	done := true
	return done &&
		m.MinimockAddDone() &&
		m.MinimockDeleteThingDone() &&
		m.MinimockGetByThingIDDone() &&
		m.MinimockUpdatePlaceDone()
}
