package mocks

// Code generated by http://github.com/gojuno/minimock (dev). DO NOT EDIT.

//go:generate minimock -i git.dmitriygnatenko.ru/dima/homethings/internal/interfaces.IThingImageRepository -o ./mocks/i_thing_image_repository_minimock.go -n IThingImageRepositoryMock

import (
	"context"
	"database/sql"
	"sync"
	mm_atomic "sync/atomic"
	mm_time "time"

	"git.dmitriygnatenko.ru/dima/homethings/internal/models"
	"github.com/gojuno/minimock/v3"
)

// IThingImageRepositoryMock implements interfaces.IThingImageRepository
type IThingImageRepositoryMock struct {
	t minimock.Tester

	funcAdd          func(ctx context.Context, req models.AddThingImageRequest, tx *sql.Tx) (err error)
	inspectFuncAdd   func(ctx context.Context, req models.AddThingImageRequest, tx *sql.Tx)
	afterAddCounter  uint64
	beforeAddCounter uint64
	AddMock          mIThingImageRepositoryMockAdd

	funcBeginTx          func(ctx context.Context, level sql.IsolationLevel) (tp1 *sql.Tx, err error)
	inspectFuncBeginTx   func(ctx context.Context, level sql.IsolationLevel)
	afterBeginTxCounter  uint64
	beforeBeginTxCounter uint64
	BeginTxMock          mIThingImageRepositoryMockBeginTx

	funcCommitTx          func(tx *sql.Tx) (err error)
	inspectFuncCommitTx   func(tx *sql.Tx)
	afterCommitTxCounter  uint64
	beforeCommitTxCounter uint64
	CommitTxMock          mIThingImageRepositoryMockCommitTx

	funcDelete          func(ctx context.Context, imageID int, tx *sql.Tx) (err error)
	inspectFuncDelete   func(ctx context.Context, imageID int, tx *sql.Tx)
	afterDeleteCounter  uint64
	beforeDeleteCounter uint64
	DeleteMock          mIThingImageRepositoryMockDelete

	funcGet          func(ctx context.Context, imageID int) (ip1 *models.Image, err error)
	inspectFuncGet   func(ctx context.Context, imageID int)
	afterGetCounter  uint64
	beforeGetCounter uint64
	GetMock          mIThingImageRepositoryMockGet

	funcGetByPlaceID          func(ctx context.Context, placeID int) (ia1 []models.Image, err error)
	inspectFuncGetByPlaceID   func(ctx context.Context, placeID int)
	afterGetByPlaceIDCounter  uint64
	beforeGetByPlaceIDCounter uint64
	GetByPlaceIDMock          mIThingImageRepositoryMockGetByPlaceID

	funcGetByThingID          func(ctx context.Context, thingID int) (ia1 []models.Image, err error)
	inspectFuncGetByThingID   func(ctx context.Context, thingID int)
	afterGetByThingIDCounter  uint64
	beforeGetByThingIDCounter uint64
	GetByThingIDMock          mIThingImageRepositoryMockGetByThingID
}

// NewIThingImageRepositoryMock returns a mock for interfaces.IThingImageRepository
func NewIThingImageRepositoryMock(t minimock.Tester) *IThingImageRepositoryMock {
	m := &IThingImageRepositoryMock{t: t}
	if controller, ok := t.(minimock.MockController); ok {
		controller.RegisterMocker(m)
	}

	m.AddMock = mIThingImageRepositoryMockAdd{mock: m}
	m.AddMock.callArgs = []*IThingImageRepositoryMockAddParams{}

	m.BeginTxMock = mIThingImageRepositoryMockBeginTx{mock: m}
	m.BeginTxMock.callArgs = []*IThingImageRepositoryMockBeginTxParams{}

	m.CommitTxMock = mIThingImageRepositoryMockCommitTx{mock: m}
	m.CommitTxMock.callArgs = []*IThingImageRepositoryMockCommitTxParams{}

	m.DeleteMock = mIThingImageRepositoryMockDelete{mock: m}
	m.DeleteMock.callArgs = []*IThingImageRepositoryMockDeleteParams{}

	m.GetMock = mIThingImageRepositoryMockGet{mock: m}
	m.GetMock.callArgs = []*IThingImageRepositoryMockGetParams{}

	m.GetByPlaceIDMock = mIThingImageRepositoryMockGetByPlaceID{mock: m}
	m.GetByPlaceIDMock.callArgs = []*IThingImageRepositoryMockGetByPlaceIDParams{}

	m.GetByThingIDMock = mIThingImageRepositoryMockGetByThingID{mock: m}
	m.GetByThingIDMock.callArgs = []*IThingImageRepositoryMockGetByThingIDParams{}

	return m
}

type mIThingImageRepositoryMockAdd struct {
	mock               *IThingImageRepositoryMock
	defaultExpectation *IThingImageRepositoryMockAddExpectation
	expectations       []*IThingImageRepositoryMockAddExpectation

	callArgs []*IThingImageRepositoryMockAddParams
	mutex    sync.RWMutex
}

// IThingImageRepositoryMockAddExpectation specifies expectation struct of the IThingImageRepository.Add
type IThingImageRepositoryMockAddExpectation struct {
	mock    *IThingImageRepositoryMock
	params  *IThingImageRepositoryMockAddParams
	results *IThingImageRepositoryMockAddResults
	Counter uint64
}

// IThingImageRepositoryMockAddParams contains parameters of the IThingImageRepository.Add
type IThingImageRepositoryMockAddParams struct {
	ctx context.Context
	req models.AddThingImageRequest
	tx  *sql.Tx
}

// IThingImageRepositoryMockAddResults contains results of the IThingImageRepository.Add
type IThingImageRepositoryMockAddResults struct {
	err error
}

// Expect sets up expected params for IThingImageRepository.Add
func (mmAdd *mIThingImageRepositoryMockAdd) Expect(ctx context.Context, req models.AddThingImageRequest, tx *sql.Tx) *mIThingImageRepositoryMockAdd {
	if mmAdd.mock.funcAdd != nil {
		mmAdd.mock.t.Fatalf("IThingImageRepositoryMock.Add mock is already set by Set")
	}

	if mmAdd.defaultExpectation == nil {
		mmAdd.defaultExpectation = &IThingImageRepositoryMockAddExpectation{}
	}

	mmAdd.defaultExpectation.params = &IThingImageRepositoryMockAddParams{ctx, req, tx}
	for _, e := range mmAdd.expectations {
		if minimock.Equal(e.params, mmAdd.defaultExpectation.params) {
			mmAdd.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmAdd.defaultExpectation.params)
		}
	}

	return mmAdd
}

// Inspect accepts an inspector function that has same arguments as the IThingImageRepository.Add
func (mmAdd *mIThingImageRepositoryMockAdd) Inspect(f func(ctx context.Context, req models.AddThingImageRequest, tx *sql.Tx)) *mIThingImageRepositoryMockAdd {
	if mmAdd.mock.inspectFuncAdd != nil {
		mmAdd.mock.t.Fatalf("Inspect function is already set for IThingImageRepositoryMock.Add")
	}

	mmAdd.mock.inspectFuncAdd = f

	return mmAdd
}

// Return sets up results that will be returned by IThingImageRepository.Add
func (mmAdd *mIThingImageRepositoryMockAdd) Return(err error) *IThingImageRepositoryMock {
	if mmAdd.mock.funcAdd != nil {
		mmAdd.mock.t.Fatalf("IThingImageRepositoryMock.Add mock is already set by Set")
	}

	if mmAdd.defaultExpectation == nil {
		mmAdd.defaultExpectation = &IThingImageRepositoryMockAddExpectation{mock: mmAdd.mock}
	}
	mmAdd.defaultExpectation.results = &IThingImageRepositoryMockAddResults{err}
	return mmAdd.mock
}

// Set uses given function f to mock the IThingImageRepository.Add method
func (mmAdd *mIThingImageRepositoryMockAdd) Set(f func(ctx context.Context, req models.AddThingImageRequest, tx *sql.Tx) (err error)) *IThingImageRepositoryMock {
	if mmAdd.defaultExpectation != nil {
		mmAdd.mock.t.Fatalf("Default expectation is already set for the IThingImageRepository.Add method")
	}

	if len(mmAdd.expectations) > 0 {
		mmAdd.mock.t.Fatalf("Some expectations are already set for the IThingImageRepository.Add method")
	}

	mmAdd.mock.funcAdd = f
	return mmAdd.mock
}

// When sets expectation for the IThingImageRepository.Add which will trigger the result defined by the following
// Then helper
func (mmAdd *mIThingImageRepositoryMockAdd) When(ctx context.Context, req models.AddThingImageRequest, tx *sql.Tx) *IThingImageRepositoryMockAddExpectation {
	if mmAdd.mock.funcAdd != nil {
		mmAdd.mock.t.Fatalf("IThingImageRepositoryMock.Add mock is already set by Set")
	}

	expectation := &IThingImageRepositoryMockAddExpectation{
		mock:   mmAdd.mock,
		params: &IThingImageRepositoryMockAddParams{ctx, req, tx},
	}
	mmAdd.expectations = append(mmAdd.expectations, expectation)
	return expectation
}

// Then sets up IThingImageRepository.Add return parameters for the expectation previously defined by the When method
func (e *IThingImageRepositoryMockAddExpectation) Then(err error) *IThingImageRepositoryMock {
	e.results = &IThingImageRepositoryMockAddResults{err}
	return e.mock
}

// Add implements interfaces.IThingImageRepository
func (mmAdd *IThingImageRepositoryMock) Add(ctx context.Context, req models.AddThingImageRequest, tx *sql.Tx) (err error) {
	mm_atomic.AddUint64(&mmAdd.beforeAddCounter, 1)
	defer mm_atomic.AddUint64(&mmAdd.afterAddCounter, 1)

	if mmAdd.inspectFuncAdd != nil {
		mmAdd.inspectFuncAdd(ctx, req, tx)
	}

	mm_params := &IThingImageRepositoryMockAddParams{ctx, req, tx}

	// Record call args
	mmAdd.AddMock.mutex.Lock()
	mmAdd.AddMock.callArgs = append(mmAdd.AddMock.callArgs, mm_params)
	mmAdd.AddMock.mutex.Unlock()

	for _, e := range mmAdd.AddMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmAdd.AddMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmAdd.AddMock.defaultExpectation.Counter, 1)
		mm_want := mmAdd.AddMock.defaultExpectation.params
		mm_got := IThingImageRepositoryMockAddParams{ctx, req, tx}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmAdd.t.Errorf("IThingImageRepositoryMock.Add got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmAdd.AddMock.defaultExpectation.results
		if mm_results == nil {
			mmAdd.t.Fatal("No results are set for the IThingImageRepositoryMock.Add")
		}
		return (*mm_results).err
	}
	if mmAdd.funcAdd != nil {
		return mmAdd.funcAdd(ctx, req, tx)
	}
	mmAdd.t.Fatalf("Unexpected call to IThingImageRepositoryMock.Add. %v %v %v", ctx, req, tx)
	return
}

// AddAfterCounter returns a count of finished IThingImageRepositoryMock.Add invocations
func (mmAdd *IThingImageRepositoryMock) AddAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmAdd.afterAddCounter)
}

// AddBeforeCounter returns a count of IThingImageRepositoryMock.Add invocations
func (mmAdd *IThingImageRepositoryMock) AddBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmAdd.beforeAddCounter)
}

// Calls returns a list of arguments used in each call to IThingImageRepositoryMock.Add.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmAdd *mIThingImageRepositoryMockAdd) Calls() []*IThingImageRepositoryMockAddParams {
	mmAdd.mutex.RLock()

	argCopy := make([]*IThingImageRepositoryMockAddParams, len(mmAdd.callArgs))
	copy(argCopy, mmAdd.callArgs)

	mmAdd.mutex.RUnlock()

	return argCopy
}

// MinimockAddDone returns true if the count of the Add invocations corresponds
// the number of defined expectations
func (m *IThingImageRepositoryMock) MinimockAddDone() bool {
	for _, e := range m.AddMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.AddMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcAdd != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		return false
	}
	return true
}

// MinimockAddInspect logs each unmet expectation
func (m *IThingImageRepositoryMock) MinimockAddInspect() {
	for _, e := range m.AddMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IThingImageRepositoryMock.Add with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.AddMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		if m.AddMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IThingImageRepositoryMock.Add")
		} else {
			m.t.Errorf("Expected call to IThingImageRepositoryMock.Add with params: %#v", *m.AddMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcAdd != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		m.t.Error("Expected call to IThingImageRepositoryMock.Add")
	}
}

type mIThingImageRepositoryMockBeginTx struct {
	mock               *IThingImageRepositoryMock
	defaultExpectation *IThingImageRepositoryMockBeginTxExpectation
	expectations       []*IThingImageRepositoryMockBeginTxExpectation

	callArgs []*IThingImageRepositoryMockBeginTxParams
	mutex    sync.RWMutex
}

// IThingImageRepositoryMockBeginTxExpectation specifies expectation struct of the IThingImageRepository.BeginTx
type IThingImageRepositoryMockBeginTxExpectation struct {
	mock    *IThingImageRepositoryMock
	params  *IThingImageRepositoryMockBeginTxParams
	results *IThingImageRepositoryMockBeginTxResults
	Counter uint64
}

// IThingImageRepositoryMockBeginTxParams contains parameters of the IThingImageRepository.BeginTx
type IThingImageRepositoryMockBeginTxParams struct {
	ctx   context.Context
	level sql.IsolationLevel
}

// IThingImageRepositoryMockBeginTxResults contains results of the IThingImageRepository.BeginTx
type IThingImageRepositoryMockBeginTxResults struct {
	tp1 *sql.Tx
	err error
}

// Expect sets up expected params for IThingImageRepository.BeginTx
func (mmBeginTx *mIThingImageRepositoryMockBeginTx) Expect(ctx context.Context, level sql.IsolationLevel) *mIThingImageRepositoryMockBeginTx {
	if mmBeginTx.mock.funcBeginTx != nil {
		mmBeginTx.mock.t.Fatalf("IThingImageRepositoryMock.BeginTx mock is already set by Set")
	}

	if mmBeginTx.defaultExpectation == nil {
		mmBeginTx.defaultExpectation = &IThingImageRepositoryMockBeginTxExpectation{}
	}

	mmBeginTx.defaultExpectation.params = &IThingImageRepositoryMockBeginTxParams{ctx, level}
	for _, e := range mmBeginTx.expectations {
		if minimock.Equal(e.params, mmBeginTx.defaultExpectation.params) {
			mmBeginTx.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmBeginTx.defaultExpectation.params)
		}
	}

	return mmBeginTx
}

// Inspect accepts an inspector function that has same arguments as the IThingImageRepository.BeginTx
func (mmBeginTx *mIThingImageRepositoryMockBeginTx) Inspect(f func(ctx context.Context, level sql.IsolationLevel)) *mIThingImageRepositoryMockBeginTx {
	if mmBeginTx.mock.inspectFuncBeginTx != nil {
		mmBeginTx.mock.t.Fatalf("Inspect function is already set for IThingImageRepositoryMock.BeginTx")
	}

	mmBeginTx.mock.inspectFuncBeginTx = f

	return mmBeginTx
}

// Return sets up results that will be returned by IThingImageRepository.BeginTx
func (mmBeginTx *mIThingImageRepositoryMockBeginTx) Return(tp1 *sql.Tx, err error) *IThingImageRepositoryMock {
	if mmBeginTx.mock.funcBeginTx != nil {
		mmBeginTx.mock.t.Fatalf("IThingImageRepositoryMock.BeginTx mock is already set by Set")
	}

	if mmBeginTx.defaultExpectation == nil {
		mmBeginTx.defaultExpectation = &IThingImageRepositoryMockBeginTxExpectation{mock: mmBeginTx.mock}
	}
	mmBeginTx.defaultExpectation.results = &IThingImageRepositoryMockBeginTxResults{tp1, err}
	return mmBeginTx.mock
}

// Set uses given function f to mock the IThingImageRepository.BeginTx method
func (mmBeginTx *mIThingImageRepositoryMockBeginTx) Set(f func(ctx context.Context, level sql.IsolationLevel) (tp1 *sql.Tx, err error)) *IThingImageRepositoryMock {
	if mmBeginTx.defaultExpectation != nil {
		mmBeginTx.mock.t.Fatalf("Default expectation is already set for the IThingImageRepository.BeginTx method")
	}

	if len(mmBeginTx.expectations) > 0 {
		mmBeginTx.mock.t.Fatalf("Some expectations are already set for the IThingImageRepository.BeginTx method")
	}

	mmBeginTx.mock.funcBeginTx = f
	return mmBeginTx.mock
}

// When sets expectation for the IThingImageRepository.BeginTx which will trigger the result defined by the following
// Then helper
func (mmBeginTx *mIThingImageRepositoryMockBeginTx) When(ctx context.Context, level sql.IsolationLevel) *IThingImageRepositoryMockBeginTxExpectation {
	if mmBeginTx.mock.funcBeginTx != nil {
		mmBeginTx.mock.t.Fatalf("IThingImageRepositoryMock.BeginTx mock is already set by Set")
	}

	expectation := &IThingImageRepositoryMockBeginTxExpectation{
		mock:   mmBeginTx.mock,
		params: &IThingImageRepositoryMockBeginTxParams{ctx, level},
	}
	mmBeginTx.expectations = append(mmBeginTx.expectations, expectation)
	return expectation
}

// Then sets up IThingImageRepository.BeginTx return parameters for the expectation previously defined by the When method
func (e *IThingImageRepositoryMockBeginTxExpectation) Then(tp1 *sql.Tx, err error) *IThingImageRepositoryMock {
	e.results = &IThingImageRepositoryMockBeginTxResults{tp1, err}
	return e.mock
}

// BeginTx implements interfaces.IThingImageRepository
func (mmBeginTx *IThingImageRepositoryMock) BeginTx(ctx context.Context, level sql.IsolationLevel) (tp1 *sql.Tx, err error) {
	mm_atomic.AddUint64(&mmBeginTx.beforeBeginTxCounter, 1)
	defer mm_atomic.AddUint64(&mmBeginTx.afterBeginTxCounter, 1)

	if mmBeginTx.inspectFuncBeginTx != nil {
		mmBeginTx.inspectFuncBeginTx(ctx, level)
	}

	mm_params := &IThingImageRepositoryMockBeginTxParams{ctx, level}

	// Record call args
	mmBeginTx.BeginTxMock.mutex.Lock()
	mmBeginTx.BeginTxMock.callArgs = append(mmBeginTx.BeginTxMock.callArgs, mm_params)
	mmBeginTx.BeginTxMock.mutex.Unlock()

	for _, e := range mmBeginTx.BeginTxMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.tp1, e.results.err
		}
	}

	if mmBeginTx.BeginTxMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmBeginTx.BeginTxMock.defaultExpectation.Counter, 1)
		mm_want := mmBeginTx.BeginTxMock.defaultExpectation.params
		mm_got := IThingImageRepositoryMockBeginTxParams{ctx, level}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmBeginTx.t.Errorf("IThingImageRepositoryMock.BeginTx got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmBeginTx.BeginTxMock.defaultExpectation.results
		if mm_results == nil {
			mmBeginTx.t.Fatal("No results are set for the IThingImageRepositoryMock.BeginTx")
		}
		return (*mm_results).tp1, (*mm_results).err
	}
	if mmBeginTx.funcBeginTx != nil {
		return mmBeginTx.funcBeginTx(ctx, level)
	}
	mmBeginTx.t.Fatalf("Unexpected call to IThingImageRepositoryMock.BeginTx. %v %v", ctx, level)
	return
}

// BeginTxAfterCounter returns a count of finished IThingImageRepositoryMock.BeginTx invocations
func (mmBeginTx *IThingImageRepositoryMock) BeginTxAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmBeginTx.afterBeginTxCounter)
}

// BeginTxBeforeCounter returns a count of IThingImageRepositoryMock.BeginTx invocations
func (mmBeginTx *IThingImageRepositoryMock) BeginTxBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmBeginTx.beforeBeginTxCounter)
}

// Calls returns a list of arguments used in each call to IThingImageRepositoryMock.BeginTx.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmBeginTx *mIThingImageRepositoryMockBeginTx) Calls() []*IThingImageRepositoryMockBeginTxParams {
	mmBeginTx.mutex.RLock()

	argCopy := make([]*IThingImageRepositoryMockBeginTxParams, len(mmBeginTx.callArgs))
	copy(argCopy, mmBeginTx.callArgs)

	mmBeginTx.mutex.RUnlock()

	return argCopy
}

// MinimockBeginTxDone returns true if the count of the BeginTx invocations corresponds
// the number of defined expectations
func (m *IThingImageRepositoryMock) MinimockBeginTxDone() bool {
	for _, e := range m.BeginTxMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.BeginTxMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterBeginTxCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcBeginTx != nil && mm_atomic.LoadUint64(&m.afterBeginTxCounter) < 1 {
		return false
	}
	return true
}

// MinimockBeginTxInspect logs each unmet expectation
func (m *IThingImageRepositoryMock) MinimockBeginTxInspect() {
	for _, e := range m.BeginTxMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IThingImageRepositoryMock.BeginTx with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.BeginTxMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterBeginTxCounter) < 1 {
		if m.BeginTxMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IThingImageRepositoryMock.BeginTx")
		} else {
			m.t.Errorf("Expected call to IThingImageRepositoryMock.BeginTx with params: %#v", *m.BeginTxMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcBeginTx != nil && mm_atomic.LoadUint64(&m.afterBeginTxCounter) < 1 {
		m.t.Error("Expected call to IThingImageRepositoryMock.BeginTx")
	}
}

type mIThingImageRepositoryMockCommitTx struct {
	mock               *IThingImageRepositoryMock
	defaultExpectation *IThingImageRepositoryMockCommitTxExpectation
	expectations       []*IThingImageRepositoryMockCommitTxExpectation

	callArgs []*IThingImageRepositoryMockCommitTxParams
	mutex    sync.RWMutex
}

// IThingImageRepositoryMockCommitTxExpectation specifies expectation struct of the IThingImageRepository.CommitTx
type IThingImageRepositoryMockCommitTxExpectation struct {
	mock    *IThingImageRepositoryMock
	params  *IThingImageRepositoryMockCommitTxParams
	results *IThingImageRepositoryMockCommitTxResults
	Counter uint64
}

// IThingImageRepositoryMockCommitTxParams contains parameters of the IThingImageRepository.CommitTx
type IThingImageRepositoryMockCommitTxParams struct {
	tx *sql.Tx
}

// IThingImageRepositoryMockCommitTxResults contains results of the IThingImageRepository.CommitTx
type IThingImageRepositoryMockCommitTxResults struct {
	err error
}

// Expect sets up expected params for IThingImageRepository.CommitTx
func (mmCommitTx *mIThingImageRepositoryMockCommitTx) Expect(tx *sql.Tx) *mIThingImageRepositoryMockCommitTx {
	if mmCommitTx.mock.funcCommitTx != nil {
		mmCommitTx.mock.t.Fatalf("IThingImageRepositoryMock.CommitTx mock is already set by Set")
	}

	if mmCommitTx.defaultExpectation == nil {
		mmCommitTx.defaultExpectation = &IThingImageRepositoryMockCommitTxExpectation{}
	}

	mmCommitTx.defaultExpectation.params = &IThingImageRepositoryMockCommitTxParams{tx}
	for _, e := range mmCommitTx.expectations {
		if minimock.Equal(e.params, mmCommitTx.defaultExpectation.params) {
			mmCommitTx.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmCommitTx.defaultExpectation.params)
		}
	}

	return mmCommitTx
}

// Inspect accepts an inspector function that has same arguments as the IThingImageRepository.CommitTx
func (mmCommitTx *mIThingImageRepositoryMockCommitTx) Inspect(f func(tx *sql.Tx)) *mIThingImageRepositoryMockCommitTx {
	if mmCommitTx.mock.inspectFuncCommitTx != nil {
		mmCommitTx.mock.t.Fatalf("Inspect function is already set for IThingImageRepositoryMock.CommitTx")
	}

	mmCommitTx.mock.inspectFuncCommitTx = f

	return mmCommitTx
}

// Return sets up results that will be returned by IThingImageRepository.CommitTx
func (mmCommitTx *mIThingImageRepositoryMockCommitTx) Return(err error) *IThingImageRepositoryMock {
	if mmCommitTx.mock.funcCommitTx != nil {
		mmCommitTx.mock.t.Fatalf("IThingImageRepositoryMock.CommitTx mock is already set by Set")
	}

	if mmCommitTx.defaultExpectation == nil {
		mmCommitTx.defaultExpectation = &IThingImageRepositoryMockCommitTxExpectation{mock: mmCommitTx.mock}
	}
	mmCommitTx.defaultExpectation.results = &IThingImageRepositoryMockCommitTxResults{err}
	return mmCommitTx.mock
}

// Set uses given function f to mock the IThingImageRepository.CommitTx method
func (mmCommitTx *mIThingImageRepositoryMockCommitTx) Set(f func(tx *sql.Tx) (err error)) *IThingImageRepositoryMock {
	if mmCommitTx.defaultExpectation != nil {
		mmCommitTx.mock.t.Fatalf("Default expectation is already set for the IThingImageRepository.CommitTx method")
	}

	if len(mmCommitTx.expectations) > 0 {
		mmCommitTx.mock.t.Fatalf("Some expectations are already set for the IThingImageRepository.CommitTx method")
	}

	mmCommitTx.mock.funcCommitTx = f
	return mmCommitTx.mock
}

// When sets expectation for the IThingImageRepository.CommitTx which will trigger the result defined by the following
// Then helper
func (mmCommitTx *mIThingImageRepositoryMockCommitTx) When(tx *sql.Tx) *IThingImageRepositoryMockCommitTxExpectation {
	if mmCommitTx.mock.funcCommitTx != nil {
		mmCommitTx.mock.t.Fatalf("IThingImageRepositoryMock.CommitTx mock is already set by Set")
	}

	expectation := &IThingImageRepositoryMockCommitTxExpectation{
		mock:   mmCommitTx.mock,
		params: &IThingImageRepositoryMockCommitTxParams{tx},
	}
	mmCommitTx.expectations = append(mmCommitTx.expectations, expectation)
	return expectation
}

// Then sets up IThingImageRepository.CommitTx return parameters for the expectation previously defined by the When method
func (e *IThingImageRepositoryMockCommitTxExpectation) Then(err error) *IThingImageRepositoryMock {
	e.results = &IThingImageRepositoryMockCommitTxResults{err}
	return e.mock
}

// CommitTx implements interfaces.IThingImageRepository
func (mmCommitTx *IThingImageRepositoryMock) CommitTx(tx *sql.Tx) (err error) {
	mm_atomic.AddUint64(&mmCommitTx.beforeCommitTxCounter, 1)
	defer mm_atomic.AddUint64(&mmCommitTx.afterCommitTxCounter, 1)

	if mmCommitTx.inspectFuncCommitTx != nil {
		mmCommitTx.inspectFuncCommitTx(tx)
	}

	mm_params := &IThingImageRepositoryMockCommitTxParams{tx}

	// Record call args
	mmCommitTx.CommitTxMock.mutex.Lock()
	mmCommitTx.CommitTxMock.callArgs = append(mmCommitTx.CommitTxMock.callArgs, mm_params)
	mmCommitTx.CommitTxMock.mutex.Unlock()

	for _, e := range mmCommitTx.CommitTxMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmCommitTx.CommitTxMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmCommitTx.CommitTxMock.defaultExpectation.Counter, 1)
		mm_want := mmCommitTx.CommitTxMock.defaultExpectation.params
		mm_got := IThingImageRepositoryMockCommitTxParams{tx}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmCommitTx.t.Errorf("IThingImageRepositoryMock.CommitTx got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmCommitTx.CommitTxMock.defaultExpectation.results
		if mm_results == nil {
			mmCommitTx.t.Fatal("No results are set for the IThingImageRepositoryMock.CommitTx")
		}
		return (*mm_results).err
	}
	if mmCommitTx.funcCommitTx != nil {
		return mmCommitTx.funcCommitTx(tx)
	}
	mmCommitTx.t.Fatalf("Unexpected call to IThingImageRepositoryMock.CommitTx. %v", tx)
	return
}

// CommitTxAfterCounter returns a count of finished IThingImageRepositoryMock.CommitTx invocations
func (mmCommitTx *IThingImageRepositoryMock) CommitTxAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmCommitTx.afterCommitTxCounter)
}

// CommitTxBeforeCounter returns a count of IThingImageRepositoryMock.CommitTx invocations
func (mmCommitTx *IThingImageRepositoryMock) CommitTxBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmCommitTx.beforeCommitTxCounter)
}

// Calls returns a list of arguments used in each call to IThingImageRepositoryMock.CommitTx.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmCommitTx *mIThingImageRepositoryMockCommitTx) Calls() []*IThingImageRepositoryMockCommitTxParams {
	mmCommitTx.mutex.RLock()

	argCopy := make([]*IThingImageRepositoryMockCommitTxParams, len(mmCommitTx.callArgs))
	copy(argCopy, mmCommitTx.callArgs)

	mmCommitTx.mutex.RUnlock()

	return argCopy
}

// MinimockCommitTxDone returns true if the count of the CommitTx invocations corresponds
// the number of defined expectations
func (m *IThingImageRepositoryMock) MinimockCommitTxDone() bool {
	for _, e := range m.CommitTxMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.CommitTxMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterCommitTxCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcCommitTx != nil && mm_atomic.LoadUint64(&m.afterCommitTxCounter) < 1 {
		return false
	}
	return true
}

// MinimockCommitTxInspect logs each unmet expectation
func (m *IThingImageRepositoryMock) MinimockCommitTxInspect() {
	for _, e := range m.CommitTxMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IThingImageRepositoryMock.CommitTx with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.CommitTxMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterCommitTxCounter) < 1 {
		if m.CommitTxMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IThingImageRepositoryMock.CommitTx")
		} else {
			m.t.Errorf("Expected call to IThingImageRepositoryMock.CommitTx with params: %#v", *m.CommitTxMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcCommitTx != nil && mm_atomic.LoadUint64(&m.afterCommitTxCounter) < 1 {
		m.t.Error("Expected call to IThingImageRepositoryMock.CommitTx")
	}
}

type mIThingImageRepositoryMockDelete struct {
	mock               *IThingImageRepositoryMock
	defaultExpectation *IThingImageRepositoryMockDeleteExpectation
	expectations       []*IThingImageRepositoryMockDeleteExpectation

	callArgs []*IThingImageRepositoryMockDeleteParams
	mutex    sync.RWMutex
}

// IThingImageRepositoryMockDeleteExpectation specifies expectation struct of the IThingImageRepository.Delete
type IThingImageRepositoryMockDeleteExpectation struct {
	mock    *IThingImageRepositoryMock
	params  *IThingImageRepositoryMockDeleteParams
	results *IThingImageRepositoryMockDeleteResults
	Counter uint64
}

// IThingImageRepositoryMockDeleteParams contains parameters of the IThingImageRepository.Delete
type IThingImageRepositoryMockDeleteParams struct {
	ctx     context.Context
	imageID int
	tx      *sql.Tx
}

// IThingImageRepositoryMockDeleteResults contains results of the IThingImageRepository.Delete
type IThingImageRepositoryMockDeleteResults struct {
	err error
}

// Expect sets up expected params for IThingImageRepository.Delete
func (mmDelete *mIThingImageRepositoryMockDelete) Expect(ctx context.Context, imageID int, tx *sql.Tx) *mIThingImageRepositoryMockDelete {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("IThingImageRepositoryMock.Delete mock is already set by Set")
	}

	if mmDelete.defaultExpectation == nil {
		mmDelete.defaultExpectation = &IThingImageRepositoryMockDeleteExpectation{}
	}

	mmDelete.defaultExpectation.params = &IThingImageRepositoryMockDeleteParams{ctx, imageID, tx}
	for _, e := range mmDelete.expectations {
		if minimock.Equal(e.params, mmDelete.defaultExpectation.params) {
			mmDelete.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmDelete.defaultExpectation.params)
		}
	}

	return mmDelete
}

// Inspect accepts an inspector function that has same arguments as the IThingImageRepository.Delete
func (mmDelete *mIThingImageRepositoryMockDelete) Inspect(f func(ctx context.Context, imageID int, tx *sql.Tx)) *mIThingImageRepositoryMockDelete {
	if mmDelete.mock.inspectFuncDelete != nil {
		mmDelete.mock.t.Fatalf("Inspect function is already set for IThingImageRepositoryMock.Delete")
	}

	mmDelete.mock.inspectFuncDelete = f

	return mmDelete
}

// Return sets up results that will be returned by IThingImageRepository.Delete
func (mmDelete *mIThingImageRepositoryMockDelete) Return(err error) *IThingImageRepositoryMock {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("IThingImageRepositoryMock.Delete mock is already set by Set")
	}

	if mmDelete.defaultExpectation == nil {
		mmDelete.defaultExpectation = &IThingImageRepositoryMockDeleteExpectation{mock: mmDelete.mock}
	}
	mmDelete.defaultExpectation.results = &IThingImageRepositoryMockDeleteResults{err}
	return mmDelete.mock
}

// Set uses given function f to mock the IThingImageRepository.Delete method
func (mmDelete *mIThingImageRepositoryMockDelete) Set(f func(ctx context.Context, imageID int, tx *sql.Tx) (err error)) *IThingImageRepositoryMock {
	if mmDelete.defaultExpectation != nil {
		mmDelete.mock.t.Fatalf("Default expectation is already set for the IThingImageRepository.Delete method")
	}

	if len(mmDelete.expectations) > 0 {
		mmDelete.mock.t.Fatalf("Some expectations are already set for the IThingImageRepository.Delete method")
	}

	mmDelete.mock.funcDelete = f
	return mmDelete.mock
}

// When sets expectation for the IThingImageRepository.Delete which will trigger the result defined by the following
// Then helper
func (mmDelete *mIThingImageRepositoryMockDelete) When(ctx context.Context, imageID int, tx *sql.Tx) *IThingImageRepositoryMockDeleteExpectation {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("IThingImageRepositoryMock.Delete mock is already set by Set")
	}

	expectation := &IThingImageRepositoryMockDeleteExpectation{
		mock:   mmDelete.mock,
		params: &IThingImageRepositoryMockDeleteParams{ctx, imageID, tx},
	}
	mmDelete.expectations = append(mmDelete.expectations, expectation)
	return expectation
}

// Then sets up IThingImageRepository.Delete return parameters for the expectation previously defined by the When method
func (e *IThingImageRepositoryMockDeleteExpectation) Then(err error) *IThingImageRepositoryMock {
	e.results = &IThingImageRepositoryMockDeleteResults{err}
	return e.mock
}

// Delete implements interfaces.IThingImageRepository
func (mmDelete *IThingImageRepositoryMock) Delete(ctx context.Context, imageID int, tx *sql.Tx) (err error) {
	mm_atomic.AddUint64(&mmDelete.beforeDeleteCounter, 1)
	defer mm_atomic.AddUint64(&mmDelete.afterDeleteCounter, 1)

	if mmDelete.inspectFuncDelete != nil {
		mmDelete.inspectFuncDelete(ctx, imageID, tx)
	}

	mm_params := &IThingImageRepositoryMockDeleteParams{ctx, imageID, tx}

	// Record call args
	mmDelete.DeleteMock.mutex.Lock()
	mmDelete.DeleteMock.callArgs = append(mmDelete.DeleteMock.callArgs, mm_params)
	mmDelete.DeleteMock.mutex.Unlock()

	for _, e := range mmDelete.DeleteMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmDelete.DeleteMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmDelete.DeleteMock.defaultExpectation.Counter, 1)
		mm_want := mmDelete.DeleteMock.defaultExpectation.params
		mm_got := IThingImageRepositoryMockDeleteParams{ctx, imageID, tx}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmDelete.t.Errorf("IThingImageRepositoryMock.Delete got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmDelete.DeleteMock.defaultExpectation.results
		if mm_results == nil {
			mmDelete.t.Fatal("No results are set for the IThingImageRepositoryMock.Delete")
		}
		return (*mm_results).err
	}
	if mmDelete.funcDelete != nil {
		return mmDelete.funcDelete(ctx, imageID, tx)
	}
	mmDelete.t.Fatalf("Unexpected call to IThingImageRepositoryMock.Delete. %v %v %v", ctx, imageID, tx)
	return
}

// DeleteAfterCounter returns a count of finished IThingImageRepositoryMock.Delete invocations
func (mmDelete *IThingImageRepositoryMock) DeleteAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmDelete.afterDeleteCounter)
}

// DeleteBeforeCounter returns a count of IThingImageRepositoryMock.Delete invocations
func (mmDelete *IThingImageRepositoryMock) DeleteBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmDelete.beforeDeleteCounter)
}

// Calls returns a list of arguments used in each call to IThingImageRepositoryMock.Delete.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmDelete *mIThingImageRepositoryMockDelete) Calls() []*IThingImageRepositoryMockDeleteParams {
	mmDelete.mutex.RLock()

	argCopy := make([]*IThingImageRepositoryMockDeleteParams, len(mmDelete.callArgs))
	copy(argCopy, mmDelete.callArgs)

	mmDelete.mutex.RUnlock()

	return argCopy
}

// MinimockDeleteDone returns true if the count of the Delete invocations corresponds
// the number of defined expectations
func (m *IThingImageRepositoryMock) MinimockDeleteDone() bool {
	for _, e := range m.DeleteMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.DeleteMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcDelete != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		return false
	}
	return true
}

// MinimockDeleteInspect logs each unmet expectation
func (m *IThingImageRepositoryMock) MinimockDeleteInspect() {
	for _, e := range m.DeleteMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IThingImageRepositoryMock.Delete with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.DeleteMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		if m.DeleteMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IThingImageRepositoryMock.Delete")
		} else {
			m.t.Errorf("Expected call to IThingImageRepositoryMock.Delete with params: %#v", *m.DeleteMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcDelete != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		m.t.Error("Expected call to IThingImageRepositoryMock.Delete")
	}
}

type mIThingImageRepositoryMockGet struct {
	mock               *IThingImageRepositoryMock
	defaultExpectation *IThingImageRepositoryMockGetExpectation
	expectations       []*IThingImageRepositoryMockGetExpectation

	callArgs []*IThingImageRepositoryMockGetParams
	mutex    sync.RWMutex
}

// IThingImageRepositoryMockGetExpectation specifies expectation struct of the IThingImageRepository.Get
type IThingImageRepositoryMockGetExpectation struct {
	mock    *IThingImageRepositoryMock
	params  *IThingImageRepositoryMockGetParams
	results *IThingImageRepositoryMockGetResults
	Counter uint64
}

// IThingImageRepositoryMockGetParams contains parameters of the IThingImageRepository.Get
type IThingImageRepositoryMockGetParams struct {
	ctx     context.Context
	imageID int
}

// IThingImageRepositoryMockGetResults contains results of the IThingImageRepository.Get
type IThingImageRepositoryMockGetResults struct {
	ip1 *models.Image
	err error
}

// Expect sets up expected params for IThingImageRepository.Get
func (mmGet *mIThingImageRepositoryMockGet) Expect(ctx context.Context, imageID int) *mIThingImageRepositoryMockGet {
	if mmGet.mock.funcGet != nil {
		mmGet.mock.t.Fatalf("IThingImageRepositoryMock.Get mock is already set by Set")
	}

	if mmGet.defaultExpectation == nil {
		mmGet.defaultExpectation = &IThingImageRepositoryMockGetExpectation{}
	}

	mmGet.defaultExpectation.params = &IThingImageRepositoryMockGetParams{ctx, imageID}
	for _, e := range mmGet.expectations {
		if minimock.Equal(e.params, mmGet.defaultExpectation.params) {
			mmGet.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmGet.defaultExpectation.params)
		}
	}

	return mmGet
}

// Inspect accepts an inspector function that has same arguments as the IThingImageRepository.Get
func (mmGet *mIThingImageRepositoryMockGet) Inspect(f func(ctx context.Context, imageID int)) *mIThingImageRepositoryMockGet {
	if mmGet.mock.inspectFuncGet != nil {
		mmGet.mock.t.Fatalf("Inspect function is already set for IThingImageRepositoryMock.Get")
	}

	mmGet.mock.inspectFuncGet = f

	return mmGet
}

// Return sets up results that will be returned by IThingImageRepository.Get
func (mmGet *mIThingImageRepositoryMockGet) Return(ip1 *models.Image, err error) *IThingImageRepositoryMock {
	if mmGet.mock.funcGet != nil {
		mmGet.mock.t.Fatalf("IThingImageRepositoryMock.Get mock is already set by Set")
	}

	if mmGet.defaultExpectation == nil {
		mmGet.defaultExpectation = &IThingImageRepositoryMockGetExpectation{mock: mmGet.mock}
	}
	mmGet.defaultExpectation.results = &IThingImageRepositoryMockGetResults{ip1, err}
	return mmGet.mock
}

// Set uses given function f to mock the IThingImageRepository.Get method
func (mmGet *mIThingImageRepositoryMockGet) Set(f func(ctx context.Context, imageID int) (ip1 *models.Image, err error)) *IThingImageRepositoryMock {
	if mmGet.defaultExpectation != nil {
		mmGet.mock.t.Fatalf("Default expectation is already set for the IThingImageRepository.Get method")
	}

	if len(mmGet.expectations) > 0 {
		mmGet.mock.t.Fatalf("Some expectations are already set for the IThingImageRepository.Get method")
	}

	mmGet.mock.funcGet = f
	return mmGet.mock
}

// When sets expectation for the IThingImageRepository.Get which will trigger the result defined by the following
// Then helper
func (mmGet *mIThingImageRepositoryMockGet) When(ctx context.Context, imageID int) *IThingImageRepositoryMockGetExpectation {
	if mmGet.mock.funcGet != nil {
		mmGet.mock.t.Fatalf("IThingImageRepositoryMock.Get mock is already set by Set")
	}

	expectation := &IThingImageRepositoryMockGetExpectation{
		mock:   mmGet.mock,
		params: &IThingImageRepositoryMockGetParams{ctx, imageID},
	}
	mmGet.expectations = append(mmGet.expectations, expectation)
	return expectation
}

// Then sets up IThingImageRepository.Get return parameters for the expectation previously defined by the When method
func (e *IThingImageRepositoryMockGetExpectation) Then(ip1 *models.Image, err error) *IThingImageRepositoryMock {
	e.results = &IThingImageRepositoryMockGetResults{ip1, err}
	return e.mock
}

// Get implements interfaces.IThingImageRepository
func (mmGet *IThingImageRepositoryMock) Get(ctx context.Context, imageID int) (ip1 *models.Image, err error) {
	mm_atomic.AddUint64(&mmGet.beforeGetCounter, 1)
	defer mm_atomic.AddUint64(&mmGet.afterGetCounter, 1)

	if mmGet.inspectFuncGet != nil {
		mmGet.inspectFuncGet(ctx, imageID)
	}

	mm_params := &IThingImageRepositoryMockGetParams{ctx, imageID}

	// Record call args
	mmGet.GetMock.mutex.Lock()
	mmGet.GetMock.callArgs = append(mmGet.GetMock.callArgs, mm_params)
	mmGet.GetMock.mutex.Unlock()

	for _, e := range mmGet.GetMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.ip1, e.results.err
		}
	}

	if mmGet.GetMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmGet.GetMock.defaultExpectation.Counter, 1)
		mm_want := mmGet.GetMock.defaultExpectation.params
		mm_got := IThingImageRepositoryMockGetParams{ctx, imageID}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmGet.t.Errorf("IThingImageRepositoryMock.Get got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmGet.GetMock.defaultExpectation.results
		if mm_results == nil {
			mmGet.t.Fatal("No results are set for the IThingImageRepositoryMock.Get")
		}
		return (*mm_results).ip1, (*mm_results).err
	}
	if mmGet.funcGet != nil {
		return mmGet.funcGet(ctx, imageID)
	}
	mmGet.t.Fatalf("Unexpected call to IThingImageRepositoryMock.Get. %v %v", ctx, imageID)
	return
}

// GetAfterCounter returns a count of finished IThingImageRepositoryMock.Get invocations
func (mmGet *IThingImageRepositoryMock) GetAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGet.afterGetCounter)
}

// GetBeforeCounter returns a count of IThingImageRepositoryMock.Get invocations
func (mmGet *IThingImageRepositoryMock) GetBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGet.beforeGetCounter)
}

// Calls returns a list of arguments used in each call to IThingImageRepositoryMock.Get.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmGet *mIThingImageRepositoryMockGet) Calls() []*IThingImageRepositoryMockGetParams {
	mmGet.mutex.RLock()

	argCopy := make([]*IThingImageRepositoryMockGetParams, len(mmGet.callArgs))
	copy(argCopy, mmGet.callArgs)

	mmGet.mutex.RUnlock()

	return argCopy
}

// MinimockGetDone returns true if the count of the Get invocations corresponds
// the number of defined expectations
func (m *IThingImageRepositoryMock) MinimockGetDone() bool {
	for _, e := range m.GetMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGet != nil && mm_atomic.LoadUint64(&m.afterGetCounter) < 1 {
		return false
	}
	return true
}

// MinimockGetInspect logs each unmet expectation
func (m *IThingImageRepositoryMock) MinimockGetInspect() {
	for _, e := range m.GetMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IThingImageRepositoryMock.Get with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetCounter) < 1 {
		if m.GetMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IThingImageRepositoryMock.Get")
		} else {
			m.t.Errorf("Expected call to IThingImageRepositoryMock.Get with params: %#v", *m.GetMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGet != nil && mm_atomic.LoadUint64(&m.afterGetCounter) < 1 {
		m.t.Error("Expected call to IThingImageRepositoryMock.Get")
	}
}

type mIThingImageRepositoryMockGetByPlaceID struct {
	mock               *IThingImageRepositoryMock
	defaultExpectation *IThingImageRepositoryMockGetByPlaceIDExpectation
	expectations       []*IThingImageRepositoryMockGetByPlaceIDExpectation

	callArgs []*IThingImageRepositoryMockGetByPlaceIDParams
	mutex    sync.RWMutex
}

// IThingImageRepositoryMockGetByPlaceIDExpectation specifies expectation struct of the IThingImageRepository.GetByPlaceID
type IThingImageRepositoryMockGetByPlaceIDExpectation struct {
	mock    *IThingImageRepositoryMock
	params  *IThingImageRepositoryMockGetByPlaceIDParams
	results *IThingImageRepositoryMockGetByPlaceIDResults
	Counter uint64
}

// IThingImageRepositoryMockGetByPlaceIDParams contains parameters of the IThingImageRepository.GetByPlaceID
type IThingImageRepositoryMockGetByPlaceIDParams struct {
	ctx     context.Context
	placeID int
}

// IThingImageRepositoryMockGetByPlaceIDResults contains results of the IThingImageRepository.GetByPlaceID
type IThingImageRepositoryMockGetByPlaceIDResults struct {
	ia1 []models.Image
	err error
}

// Expect sets up expected params for IThingImageRepository.GetByPlaceID
func (mmGetByPlaceID *mIThingImageRepositoryMockGetByPlaceID) Expect(ctx context.Context, placeID int) *mIThingImageRepositoryMockGetByPlaceID {
	if mmGetByPlaceID.mock.funcGetByPlaceID != nil {
		mmGetByPlaceID.mock.t.Fatalf("IThingImageRepositoryMock.GetByPlaceID mock is already set by Set")
	}

	if mmGetByPlaceID.defaultExpectation == nil {
		mmGetByPlaceID.defaultExpectation = &IThingImageRepositoryMockGetByPlaceIDExpectation{}
	}

	mmGetByPlaceID.defaultExpectation.params = &IThingImageRepositoryMockGetByPlaceIDParams{ctx, placeID}
	for _, e := range mmGetByPlaceID.expectations {
		if minimock.Equal(e.params, mmGetByPlaceID.defaultExpectation.params) {
			mmGetByPlaceID.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmGetByPlaceID.defaultExpectation.params)
		}
	}

	return mmGetByPlaceID
}

// Inspect accepts an inspector function that has same arguments as the IThingImageRepository.GetByPlaceID
func (mmGetByPlaceID *mIThingImageRepositoryMockGetByPlaceID) Inspect(f func(ctx context.Context, placeID int)) *mIThingImageRepositoryMockGetByPlaceID {
	if mmGetByPlaceID.mock.inspectFuncGetByPlaceID != nil {
		mmGetByPlaceID.mock.t.Fatalf("Inspect function is already set for IThingImageRepositoryMock.GetByPlaceID")
	}

	mmGetByPlaceID.mock.inspectFuncGetByPlaceID = f

	return mmGetByPlaceID
}

// Return sets up results that will be returned by IThingImageRepository.GetByPlaceID
func (mmGetByPlaceID *mIThingImageRepositoryMockGetByPlaceID) Return(ia1 []models.Image, err error) *IThingImageRepositoryMock {
	if mmGetByPlaceID.mock.funcGetByPlaceID != nil {
		mmGetByPlaceID.mock.t.Fatalf("IThingImageRepositoryMock.GetByPlaceID mock is already set by Set")
	}

	if mmGetByPlaceID.defaultExpectation == nil {
		mmGetByPlaceID.defaultExpectation = &IThingImageRepositoryMockGetByPlaceIDExpectation{mock: mmGetByPlaceID.mock}
	}
	mmGetByPlaceID.defaultExpectation.results = &IThingImageRepositoryMockGetByPlaceIDResults{ia1, err}
	return mmGetByPlaceID.mock
}

// Set uses given function f to mock the IThingImageRepository.GetByPlaceID method
func (mmGetByPlaceID *mIThingImageRepositoryMockGetByPlaceID) Set(f func(ctx context.Context, placeID int) (ia1 []models.Image, err error)) *IThingImageRepositoryMock {
	if mmGetByPlaceID.defaultExpectation != nil {
		mmGetByPlaceID.mock.t.Fatalf("Default expectation is already set for the IThingImageRepository.GetByPlaceID method")
	}

	if len(mmGetByPlaceID.expectations) > 0 {
		mmGetByPlaceID.mock.t.Fatalf("Some expectations are already set for the IThingImageRepository.GetByPlaceID method")
	}

	mmGetByPlaceID.mock.funcGetByPlaceID = f
	return mmGetByPlaceID.mock
}

// When sets expectation for the IThingImageRepository.GetByPlaceID which will trigger the result defined by the following
// Then helper
func (mmGetByPlaceID *mIThingImageRepositoryMockGetByPlaceID) When(ctx context.Context, placeID int) *IThingImageRepositoryMockGetByPlaceIDExpectation {
	if mmGetByPlaceID.mock.funcGetByPlaceID != nil {
		mmGetByPlaceID.mock.t.Fatalf("IThingImageRepositoryMock.GetByPlaceID mock is already set by Set")
	}

	expectation := &IThingImageRepositoryMockGetByPlaceIDExpectation{
		mock:   mmGetByPlaceID.mock,
		params: &IThingImageRepositoryMockGetByPlaceIDParams{ctx, placeID},
	}
	mmGetByPlaceID.expectations = append(mmGetByPlaceID.expectations, expectation)
	return expectation
}

// Then sets up IThingImageRepository.GetByPlaceID return parameters for the expectation previously defined by the When method
func (e *IThingImageRepositoryMockGetByPlaceIDExpectation) Then(ia1 []models.Image, err error) *IThingImageRepositoryMock {
	e.results = &IThingImageRepositoryMockGetByPlaceIDResults{ia1, err}
	return e.mock
}

// GetByPlaceID implements interfaces.IThingImageRepository
func (mmGetByPlaceID *IThingImageRepositoryMock) GetByPlaceID(ctx context.Context, placeID int) (ia1 []models.Image, err error) {
	mm_atomic.AddUint64(&mmGetByPlaceID.beforeGetByPlaceIDCounter, 1)
	defer mm_atomic.AddUint64(&mmGetByPlaceID.afterGetByPlaceIDCounter, 1)

	if mmGetByPlaceID.inspectFuncGetByPlaceID != nil {
		mmGetByPlaceID.inspectFuncGetByPlaceID(ctx, placeID)
	}

	mm_params := &IThingImageRepositoryMockGetByPlaceIDParams{ctx, placeID}

	// Record call args
	mmGetByPlaceID.GetByPlaceIDMock.mutex.Lock()
	mmGetByPlaceID.GetByPlaceIDMock.callArgs = append(mmGetByPlaceID.GetByPlaceIDMock.callArgs, mm_params)
	mmGetByPlaceID.GetByPlaceIDMock.mutex.Unlock()

	for _, e := range mmGetByPlaceID.GetByPlaceIDMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.ia1, e.results.err
		}
	}

	if mmGetByPlaceID.GetByPlaceIDMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmGetByPlaceID.GetByPlaceIDMock.defaultExpectation.Counter, 1)
		mm_want := mmGetByPlaceID.GetByPlaceIDMock.defaultExpectation.params
		mm_got := IThingImageRepositoryMockGetByPlaceIDParams{ctx, placeID}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmGetByPlaceID.t.Errorf("IThingImageRepositoryMock.GetByPlaceID got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmGetByPlaceID.GetByPlaceIDMock.defaultExpectation.results
		if mm_results == nil {
			mmGetByPlaceID.t.Fatal("No results are set for the IThingImageRepositoryMock.GetByPlaceID")
		}
		return (*mm_results).ia1, (*mm_results).err
	}
	if mmGetByPlaceID.funcGetByPlaceID != nil {
		return mmGetByPlaceID.funcGetByPlaceID(ctx, placeID)
	}
	mmGetByPlaceID.t.Fatalf("Unexpected call to IThingImageRepositoryMock.GetByPlaceID. %v %v", ctx, placeID)
	return
}

// GetByPlaceIDAfterCounter returns a count of finished IThingImageRepositoryMock.GetByPlaceID invocations
func (mmGetByPlaceID *IThingImageRepositoryMock) GetByPlaceIDAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGetByPlaceID.afterGetByPlaceIDCounter)
}

// GetByPlaceIDBeforeCounter returns a count of IThingImageRepositoryMock.GetByPlaceID invocations
func (mmGetByPlaceID *IThingImageRepositoryMock) GetByPlaceIDBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGetByPlaceID.beforeGetByPlaceIDCounter)
}

// Calls returns a list of arguments used in each call to IThingImageRepositoryMock.GetByPlaceID.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmGetByPlaceID *mIThingImageRepositoryMockGetByPlaceID) Calls() []*IThingImageRepositoryMockGetByPlaceIDParams {
	mmGetByPlaceID.mutex.RLock()

	argCopy := make([]*IThingImageRepositoryMockGetByPlaceIDParams, len(mmGetByPlaceID.callArgs))
	copy(argCopy, mmGetByPlaceID.callArgs)

	mmGetByPlaceID.mutex.RUnlock()

	return argCopy
}

// MinimockGetByPlaceIDDone returns true if the count of the GetByPlaceID invocations corresponds
// the number of defined expectations
func (m *IThingImageRepositoryMock) MinimockGetByPlaceIDDone() bool {
	for _, e := range m.GetByPlaceIDMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetByPlaceIDMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetByPlaceIDCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGetByPlaceID != nil && mm_atomic.LoadUint64(&m.afterGetByPlaceIDCounter) < 1 {
		return false
	}
	return true
}

// MinimockGetByPlaceIDInspect logs each unmet expectation
func (m *IThingImageRepositoryMock) MinimockGetByPlaceIDInspect() {
	for _, e := range m.GetByPlaceIDMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IThingImageRepositoryMock.GetByPlaceID with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetByPlaceIDMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetByPlaceIDCounter) < 1 {
		if m.GetByPlaceIDMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IThingImageRepositoryMock.GetByPlaceID")
		} else {
			m.t.Errorf("Expected call to IThingImageRepositoryMock.GetByPlaceID with params: %#v", *m.GetByPlaceIDMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGetByPlaceID != nil && mm_atomic.LoadUint64(&m.afterGetByPlaceIDCounter) < 1 {
		m.t.Error("Expected call to IThingImageRepositoryMock.GetByPlaceID")
	}
}

type mIThingImageRepositoryMockGetByThingID struct {
	mock               *IThingImageRepositoryMock
	defaultExpectation *IThingImageRepositoryMockGetByThingIDExpectation
	expectations       []*IThingImageRepositoryMockGetByThingIDExpectation

	callArgs []*IThingImageRepositoryMockGetByThingIDParams
	mutex    sync.RWMutex
}

// IThingImageRepositoryMockGetByThingIDExpectation specifies expectation struct of the IThingImageRepository.GetByThingID
type IThingImageRepositoryMockGetByThingIDExpectation struct {
	mock    *IThingImageRepositoryMock
	params  *IThingImageRepositoryMockGetByThingIDParams
	results *IThingImageRepositoryMockGetByThingIDResults
	Counter uint64
}

// IThingImageRepositoryMockGetByThingIDParams contains parameters of the IThingImageRepository.GetByThingID
type IThingImageRepositoryMockGetByThingIDParams struct {
	ctx     context.Context
	thingID int
}

// IThingImageRepositoryMockGetByThingIDResults contains results of the IThingImageRepository.GetByThingID
type IThingImageRepositoryMockGetByThingIDResults struct {
	ia1 []models.Image
	err error
}

// Expect sets up expected params for IThingImageRepository.GetByThingID
func (mmGetByThingID *mIThingImageRepositoryMockGetByThingID) Expect(ctx context.Context, thingID int) *mIThingImageRepositoryMockGetByThingID {
	if mmGetByThingID.mock.funcGetByThingID != nil {
		mmGetByThingID.mock.t.Fatalf("IThingImageRepositoryMock.GetByThingID mock is already set by Set")
	}

	if mmGetByThingID.defaultExpectation == nil {
		mmGetByThingID.defaultExpectation = &IThingImageRepositoryMockGetByThingIDExpectation{}
	}

	mmGetByThingID.defaultExpectation.params = &IThingImageRepositoryMockGetByThingIDParams{ctx, thingID}
	for _, e := range mmGetByThingID.expectations {
		if minimock.Equal(e.params, mmGetByThingID.defaultExpectation.params) {
			mmGetByThingID.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmGetByThingID.defaultExpectation.params)
		}
	}

	return mmGetByThingID
}

// Inspect accepts an inspector function that has same arguments as the IThingImageRepository.GetByThingID
func (mmGetByThingID *mIThingImageRepositoryMockGetByThingID) Inspect(f func(ctx context.Context, thingID int)) *mIThingImageRepositoryMockGetByThingID {
	if mmGetByThingID.mock.inspectFuncGetByThingID != nil {
		mmGetByThingID.mock.t.Fatalf("Inspect function is already set for IThingImageRepositoryMock.GetByThingID")
	}

	mmGetByThingID.mock.inspectFuncGetByThingID = f

	return mmGetByThingID
}

// Return sets up results that will be returned by IThingImageRepository.GetByThingID
func (mmGetByThingID *mIThingImageRepositoryMockGetByThingID) Return(ia1 []models.Image, err error) *IThingImageRepositoryMock {
	if mmGetByThingID.mock.funcGetByThingID != nil {
		mmGetByThingID.mock.t.Fatalf("IThingImageRepositoryMock.GetByThingID mock is already set by Set")
	}

	if mmGetByThingID.defaultExpectation == nil {
		mmGetByThingID.defaultExpectation = &IThingImageRepositoryMockGetByThingIDExpectation{mock: mmGetByThingID.mock}
	}
	mmGetByThingID.defaultExpectation.results = &IThingImageRepositoryMockGetByThingIDResults{ia1, err}
	return mmGetByThingID.mock
}

// Set uses given function f to mock the IThingImageRepository.GetByThingID method
func (mmGetByThingID *mIThingImageRepositoryMockGetByThingID) Set(f func(ctx context.Context, thingID int) (ia1 []models.Image, err error)) *IThingImageRepositoryMock {
	if mmGetByThingID.defaultExpectation != nil {
		mmGetByThingID.mock.t.Fatalf("Default expectation is already set for the IThingImageRepository.GetByThingID method")
	}

	if len(mmGetByThingID.expectations) > 0 {
		mmGetByThingID.mock.t.Fatalf("Some expectations are already set for the IThingImageRepository.GetByThingID method")
	}

	mmGetByThingID.mock.funcGetByThingID = f
	return mmGetByThingID.mock
}

// When sets expectation for the IThingImageRepository.GetByThingID which will trigger the result defined by the following
// Then helper
func (mmGetByThingID *mIThingImageRepositoryMockGetByThingID) When(ctx context.Context, thingID int) *IThingImageRepositoryMockGetByThingIDExpectation {
	if mmGetByThingID.mock.funcGetByThingID != nil {
		mmGetByThingID.mock.t.Fatalf("IThingImageRepositoryMock.GetByThingID mock is already set by Set")
	}

	expectation := &IThingImageRepositoryMockGetByThingIDExpectation{
		mock:   mmGetByThingID.mock,
		params: &IThingImageRepositoryMockGetByThingIDParams{ctx, thingID},
	}
	mmGetByThingID.expectations = append(mmGetByThingID.expectations, expectation)
	return expectation
}

// Then sets up IThingImageRepository.GetByThingID return parameters for the expectation previously defined by the When method
func (e *IThingImageRepositoryMockGetByThingIDExpectation) Then(ia1 []models.Image, err error) *IThingImageRepositoryMock {
	e.results = &IThingImageRepositoryMockGetByThingIDResults{ia1, err}
	return e.mock
}

// GetByThingID implements interfaces.IThingImageRepository
func (mmGetByThingID *IThingImageRepositoryMock) GetByThingID(ctx context.Context, thingID int) (ia1 []models.Image, err error) {
	mm_atomic.AddUint64(&mmGetByThingID.beforeGetByThingIDCounter, 1)
	defer mm_atomic.AddUint64(&mmGetByThingID.afterGetByThingIDCounter, 1)

	if mmGetByThingID.inspectFuncGetByThingID != nil {
		mmGetByThingID.inspectFuncGetByThingID(ctx, thingID)
	}

	mm_params := &IThingImageRepositoryMockGetByThingIDParams{ctx, thingID}

	// Record call args
	mmGetByThingID.GetByThingIDMock.mutex.Lock()
	mmGetByThingID.GetByThingIDMock.callArgs = append(mmGetByThingID.GetByThingIDMock.callArgs, mm_params)
	mmGetByThingID.GetByThingIDMock.mutex.Unlock()

	for _, e := range mmGetByThingID.GetByThingIDMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.ia1, e.results.err
		}
	}

	if mmGetByThingID.GetByThingIDMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmGetByThingID.GetByThingIDMock.defaultExpectation.Counter, 1)
		mm_want := mmGetByThingID.GetByThingIDMock.defaultExpectation.params
		mm_got := IThingImageRepositoryMockGetByThingIDParams{ctx, thingID}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmGetByThingID.t.Errorf("IThingImageRepositoryMock.GetByThingID got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmGetByThingID.GetByThingIDMock.defaultExpectation.results
		if mm_results == nil {
			mmGetByThingID.t.Fatal("No results are set for the IThingImageRepositoryMock.GetByThingID")
		}
		return (*mm_results).ia1, (*mm_results).err
	}
	if mmGetByThingID.funcGetByThingID != nil {
		return mmGetByThingID.funcGetByThingID(ctx, thingID)
	}
	mmGetByThingID.t.Fatalf("Unexpected call to IThingImageRepositoryMock.GetByThingID. %v %v", ctx, thingID)
	return
}

// GetByThingIDAfterCounter returns a count of finished IThingImageRepositoryMock.GetByThingID invocations
func (mmGetByThingID *IThingImageRepositoryMock) GetByThingIDAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGetByThingID.afterGetByThingIDCounter)
}

// GetByThingIDBeforeCounter returns a count of IThingImageRepositoryMock.GetByThingID invocations
func (mmGetByThingID *IThingImageRepositoryMock) GetByThingIDBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGetByThingID.beforeGetByThingIDCounter)
}

// Calls returns a list of arguments used in each call to IThingImageRepositoryMock.GetByThingID.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmGetByThingID *mIThingImageRepositoryMockGetByThingID) Calls() []*IThingImageRepositoryMockGetByThingIDParams {
	mmGetByThingID.mutex.RLock()

	argCopy := make([]*IThingImageRepositoryMockGetByThingIDParams, len(mmGetByThingID.callArgs))
	copy(argCopy, mmGetByThingID.callArgs)

	mmGetByThingID.mutex.RUnlock()

	return argCopy
}

// MinimockGetByThingIDDone returns true if the count of the GetByThingID invocations corresponds
// the number of defined expectations
func (m *IThingImageRepositoryMock) MinimockGetByThingIDDone() bool {
	for _, e := range m.GetByThingIDMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetByThingIDMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetByThingIDCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGetByThingID != nil && mm_atomic.LoadUint64(&m.afterGetByThingIDCounter) < 1 {
		return false
	}
	return true
}

// MinimockGetByThingIDInspect logs each unmet expectation
func (m *IThingImageRepositoryMock) MinimockGetByThingIDInspect() {
	for _, e := range m.GetByThingIDMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IThingImageRepositoryMock.GetByThingID with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetByThingIDMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetByThingIDCounter) < 1 {
		if m.GetByThingIDMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IThingImageRepositoryMock.GetByThingID")
		} else {
			m.t.Errorf("Expected call to IThingImageRepositoryMock.GetByThingID with params: %#v", *m.GetByThingIDMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGetByThingID != nil && mm_atomic.LoadUint64(&m.afterGetByThingIDCounter) < 1 {
		m.t.Error("Expected call to IThingImageRepositoryMock.GetByThingID")
	}
}

// MinimockFinish checks that all mocked methods have been called the expected number of times
func (m *IThingImageRepositoryMock) MinimockFinish() {
	if !m.minimockDone() {
		m.MinimockAddInspect()

		m.MinimockBeginTxInspect()

		m.MinimockCommitTxInspect()

		m.MinimockDeleteInspect()

		m.MinimockGetInspect()

		m.MinimockGetByPlaceIDInspect()

		m.MinimockGetByThingIDInspect()
		m.t.FailNow()
	}
}

// MinimockWait waits for all mocked methods to be called the expected number of times
func (m *IThingImageRepositoryMock) MinimockWait(timeout mm_time.Duration) {
	timeoutCh := mm_time.After(timeout)
	for {
		if m.minimockDone() {
			return
		}
		select {
		case <-timeoutCh:
			m.MinimockFinish()
			return
		case <-mm_time.After(10 * mm_time.Millisecond):
		}
	}
}

func (m *IThingImageRepositoryMock) minimockDone() bool {
	done := true
	return done &&
		m.MinimockAddDone() &&
		m.MinimockBeginTxDone() &&
		m.MinimockCommitTxDone() &&
		m.MinimockDeleteDone() &&
		m.MinimockGetDone() &&
		m.MinimockGetByPlaceIDDone() &&
		m.MinimockGetByThingIDDone()
}
