package mocks

// Code generated by http://github.com/gojuno/minimock (dev). DO NOT EDIT.

//go:generate minimock -i git.dmitriygnatenko.ru/dima/homethings/internal/interfaces.IThingRepository -o ./mocks/i_thing_repository_minimock.go -n IThingRepositoryMock

import (
	"context"
	"database/sql"
	"sync"
	mm_atomic "sync/atomic"
	mm_time "time"

	"git.dmitriygnatenko.ru/dima/homethings/internal/models"
	"github.com/gojuno/minimock/v3"
)

// IThingRepositoryMock implements interfaces.IThingRepository
type IThingRepositoryMock struct {
	t minimock.Tester

	funcAdd          func(ctx context.Context, req models.AddThingRequest, tx *sql.Tx) (i1 int, err error)
	inspectFuncAdd   func(ctx context.Context, req models.AddThingRequest, tx *sql.Tx)
	afterAddCounter  uint64
	beforeAddCounter uint64
	AddMock          mIThingRepositoryMockAdd

	funcBeginTx          func(ctx context.Context, level sql.IsolationLevel) (tp1 *sql.Tx, err error)
	inspectFuncBeginTx   func(ctx context.Context, level sql.IsolationLevel)
	afterBeginTxCounter  uint64
	beforeBeginTxCounter uint64
	BeginTxMock          mIThingRepositoryMockBeginTx

	funcCommitTx          func(tx *sql.Tx) (err error)
	inspectFuncCommitTx   func(tx *sql.Tx)
	afterCommitTxCounter  uint64
	beforeCommitTxCounter uint64
	CommitTxMock          mIThingRepositoryMockCommitTx

	funcDelete          func(ctx context.Context, thingID int, tx *sql.Tx) (err error)
	inspectFuncDelete   func(ctx context.Context, thingID int, tx *sql.Tx)
	afterDeleteCounter  uint64
	beforeDeleteCounter uint64
	DeleteMock          mIThingRepositoryMockDelete

	funcGet          func(ctx context.Context, thingID int) (tp1 *models.Thing, err error)
	inspectFuncGet   func(ctx context.Context, thingID int)
	afterGetCounter  uint64
	beforeGetCounter uint64
	GetMock          mIThingRepositoryMockGet

	funcGetAllByPlaceID          func(ctx context.Context, placeID int) (ta1 []models.Thing, err error)
	inspectFuncGetAllByPlaceID   func(ctx context.Context, placeID int)
	afterGetAllByPlaceIDCounter  uint64
	beforeGetAllByPlaceIDCounter uint64
	GetAllByPlaceIDMock          mIThingRepositoryMockGetAllByPlaceID

	funcGetByPlaceID          func(ctx context.Context, placeID int) (ta1 []models.Thing, err error)
	inspectFuncGetByPlaceID   func(ctx context.Context, placeID int)
	afterGetByPlaceIDCounter  uint64
	beforeGetByPlaceIDCounter uint64
	GetByPlaceIDMock          mIThingRepositoryMockGetByPlaceID

	funcSearch          func(ctx context.Context, search string) (ta1 []models.Thing, err error)
	inspectFuncSearch   func(ctx context.Context, search string)
	afterSearchCounter  uint64
	beforeSearchCounter uint64
	SearchMock          mIThingRepositoryMockSearch

	funcUpdate          func(ctx context.Context, req models.UpdateThingRequest, tx *sql.Tx) (err error)
	inspectFuncUpdate   func(ctx context.Context, req models.UpdateThingRequest, tx *sql.Tx)
	afterUpdateCounter  uint64
	beforeUpdateCounter uint64
	UpdateMock          mIThingRepositoryMockUpdate
}

// NewIThingRepositoryMock returns a mock for interfaces.IThingRepository
func NewIThingRepositoryMock(t minimock.Tester) *IThingRepositoryMock {
	m := &IThingRepositoryMock{t: t}
	if controller, ok := t.(minimock.MockController); ok {
		controller.RegisterMocker(m)
	}

	m.AddMock = mIThingRepositoryMockAdd{mock: m}
	m.AddMock.callArgs = []*IThingRepositoryMockAddParams{}

	m.BeginTxMock = mIThingRepositoryMockBeginTx{mock: m}
	m.BeginTxMock.callArgs = []*IThingRepositoryMockBeginTxParams{}

	m.CommitTxMock = mIThingRepositoryMockCommitTx{mock: m}
	m.CommitTxMock.callArgs = []*IThingRepositoryMockCommitTxParams{}

	m.DeleteMock = mIThingRepositoryMockDelete{mock: m}
	m.DeleteMock.callArgs = []*IThingRepositoryMockDeleteParams{}

	m.GetMock = mIThingRepositoryMockGet{mock: m}
	m.GetMock.callArgs = []*IThingRepositoryMockGetParams{}

	m.GetAllByPlaceIDMock = mIThingRepositoryMockGetAllByPlaceID{mock: m}
	m.GetAllByPlaceIDMock.callArgs = []*IThingRepositoryMockGetAllByPlaceIDParams{}

	m.GetByPlaceIDMock = mIThingRepositoryMockGetByPlaceID{mock: m}
	m.GetByPlaceIDMock.callArgs = []*IThingRepositoryMockGetByPlaceIDParams{}

	m.SearchMock = mIThingRepositoryMockSearch{mock: m}
	m.SearchMock.callArgs = []*IThingRepositoryMockSearchParams{}

	m.UpdateMock = mIThingRepositoryMockUpdate{mock: m}
	m.UpdateMock.callArgs = []*IThingRepositoryMockUpdateParams{}

	return m
}

type mIThingRepositoryMockAdd struct {
	mock               *IThingRepositoryMock
	defaultExpectation *IThingRepositoryMockAddExpectation
	expectations       []*IThingRepositoryMockAddExpectation

	callArgs []*IThingRepositoryMockAddParams
	mutex    sync.RWMutex
}

// IThingRepositoryMockAddExpectation specifies expectation struct of the IThingRepository.Add
type IThingRepositoryMockAddExpectation struct {
	mock    *IThingRepositoryMock
	params  *IThingRepositoryMockAddParams
	results *IThingRepositoryMockAddResults
	Counter uint64
}

// IThingRepositoryMockAddParams contains parameters of the IThingRepository.Add
type IThingRepositoryMockAddParams struct {
	ctx context.Context
	req models.AddThingRequest
	tx  *sql.Tx
}

// IThingRepositoryMockAddResults contains results of the IThingRepository.Add
type IThingRepositoryMockAddResults struct {
	i1  int
	err error
}

// Expect sets up expected params for IThingRepository.Add
func (mmAdd *mIThingRepositoryMockAdd) Expect(ctx context.Context, req models.AddThingRequest, tx *sql.Tx) *mIThingRepositoryMockAdd {
	if mmAdd.mock.funcAdd != nil {
		mmAdd.mock.t.Fatalf("IThingRepositoryMock.Add mock is already set by Set")
	}

	if mmAdd.defaultExpectation == nil {
		mmAdd.defaultExpectation = &IThingRepositoryMockAddExpectation{}
	}

	mmAdd.defaultExpectation.params = &IThingRepositoryMockAddParams{ctx, req, tx}
	for _, e := range mmAdd.expectations {
		if minimock.Equal(e.params, mmAdd.defaultExpectation.params) {
			mmAdd.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmAdd.defaultExpectation.params)
		}
	}

	return mmAdd
}

// Inspect accepts an inspector function that has same arguments as the IThingRepository.Add
func (mmAdd *mIThingRepositoryMockAdd) Inspect(f func(ctx context.Context, req models.AddThingRequest, tx *sql.Tx)) *mIThingRepositoryMockAdd {
	if mmAdd.mock.inspectFuncAdd != nil {
		mmAdd.mock.t.Fatalf("Inspect function is already set for IThingRepositoryMock.Add")
	}

	mmAdd.mock.inspectFuncAdd = f

	return mmAdd
}

// Return sets up results that will be returned by IThingRepository.Add
func (mmAdd *mIThingRepositoryMockAdd) Return(i1 int, err error) *IThingRepositoryMock {
	if mmAdd.mock.funcAdd != nil {
		mmAdd.mock.t.Fatalf("IThingRepositoryMock.Add mock is already set by Set")
	}

	if mmAdd.defaultExpectation == nil {
		mmAdd.defaultExpectation = &IThingRepositoryMockAddExpectation{mock: mmAdd.mock}
	}
	mmAdd.defaultExpectation.results = &IThingRepositoryMockAddResults{i1, err}
	return mmAdd.mock
}

// Set uses given function f to mock the IThingRepository.Add method
func (mmAdd *mIThingRepositoryMockAdd) Set(f func(ctx context.Context, req models.AddThingRequest, tx *sql.Tx) (i1 int, err error)) *IThingRepositoryMock {
	if mmAdd.defaultExpectation != nil {
		mmAdd.mock.t.Fatalf("Default expectation is already set for the IThingRepository.Add method")
	}

	if len(mmAdd.expectations) > 0 {
		mmAdd.mock.t.Fatalf("Some expectations are already set for the IThingRepository.Add method")
	}

	mmAdd.mock.funcAdd = f
	return mmAdd.mock
}

// When sets expectation for the IThingRepository.Add which will trigger the result defined by the following
// Then helper
func (mmAdd *mIThingRepositoryMockAdd) When(ctx context.Context, req models.AddThingRequest, tx *sql.Tx) *IThingRepositoryMockAddExpectation {
	if mmAdd.mock.funcAdd != nil {
		mmAdd.mock.t.Fatalf("IThingRepositoryMock.Add mock is already set by Set")
	}

	expectation := &IThingRepositoryMockAddExpectation{
		mock:   mmAdd.mock,
		params: &IThingRepositoryMockAddParams{ctx, req, tx},
	}
	mmAdd.expectations = append(mmAdd.expectations, expectation)
	return expectation
}

// Then sets up IThingRepository.Add return parameters for the expectation previously defined by the When method
func (e *IThingRepositoryMockAddExpectation) Then(i1 int, err error) *IThingRepositoryMock {
	e.results = &IThingRepositoryMockAddResults{i1, err}
	return e.mock
}

// Add implements interfaces.IThingRepository
func (mmAdd *IThingRepositoryMock) Add(ctx context.Context, req models.AddThingRequest, tx *sql.Tx) (i1 int, err error) {
	mm_atomic.AddUint64(&mmAdd.beforeAddCounter, 1)
	defer mm_atomic.AddUint64(&mmAdd.afterAddCounter, 1)

	if mmAdd.inspectFuncAdd != nil {
		mmAdd.inspectFuncAdd(ctx, req, tx)
	}

	mm_params := &IThingRepositoryMockAddParams{ctx, req, tx}

	// Record call args
	mmAdd.AddMock.mutex.Lock()
	mmAdd.AddMock.callArgs = append(mmAdd.AddMock.callArgs, mm_params)
	mmAdd.AddMock.mutex.Unlock()

	for _, e := range mmAdd.AddMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.i1, e.results.err
		}
	}

	if mmAdd.AddMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmAdd.AddMock.defaultExpectation.Counter, 1)
		mm_want := mmAdd.AddMock.defaultExpectation.params
		mm_got := IThingRepositoryMockAddParams{ctx, req, tx}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmAdd.t.Errorf("IThingRepositoryMock.Add got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmAdd.AddMock.defaultExpectation.results
		if mm_results == nil {
			mmAdd.t.Fatal("No results are set for the IThingRepositoryMock.Add")
		}
		return (*mm_results).i1, (*mm_results).err
	}
	if mmAdd.funcAdd != nil {
		return mmAdd.funcAdd(ctx, req, tx)
	}
	mmAdd.t.Fatalf("Unexpected call to IThingRepositoryMock.Add. %v %v %v", ctx, req, tx)
	return
}

// AddAfterCounter returns a count of finished IThingRepositoryMock.Add invocations
func (mmAdd *IThingRepositoryMock) AddAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmAdd.afterAddCounter)
}

// AddBeforeCounter returns a count of IThingRepositoryMock.Add invocations
func (mmAdd *IThingRepositoryMock) AddBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmAdd.beforeAddCounter)
}

// Calls returns a list of arguments used in each call to IThingRepositoryMock.Add.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmAdd *mIThingRepositoryMockAdd) Calls() []*IThingRepositoryMockAddParams {
	mmAdd.mutex.RLock()

	argCopy := make([]*IThingRepositoryMockAddParams, len(mmAdd.callArgs))
	copy(argCopy, mmAdd.callArgs)

	mmAdd.mutex.RUnlock()

	return argCopy
}

// MinimockAddDone returns true if the count of the Add invocations corresponds
// the number of defined expectations
func (m *IThingRepositoryMock) MinimockAddDone() bool {
	for _, e := range m.AddMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.AddMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcAdd != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		return false
	}
	return true
}

// MinimockAddInspect logs each unmet expectation
func (m *IThingRepositoryMock) MinimockAddInspect() {
	for _, e := range m.AddMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IThingRepositoryMock.Add with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.AddMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		if m.AddMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IThingRepositoryMock.Add")
		} else {
			m.t.Errorf("Expected call to IThingRepositoryMock.Add with params: %#v", *m.AddMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcAdd != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		m.t.Error("Expected call to IThingRepositoryMock.Add")
	}
}

type mIThingRepositoryMockBeginTx struct {
	mock               *IThingRepositoryMock
	defaultExpectation *IThingRepositoryMockBeginTxExpectation
	expectations       []*IThingRepositoryMockBeginTxExpectation

	callArgs []*IThingRepositoryMockBeginTxParams
	mutex    sync.RWMutex
}

// IThingRepositoryMockBeginTxExpectation specifies expectation struct of the IThingRepository.BeginTx
type IThingRepositoryMockBeginTxExpectation struct {
	mock    *IThingRepositoryMock
	params  *IThingRepositoryMockBeginTxParams
	results *IThingRepositoryMockBeginTxResults
	Counter uint64
}

// IThingRepositoryMockBeginTxParams contains parameters of the IThingRepository.BeginTx
type IThingRepositoryMockBeginTxParams struct {
	ctx   context.Context
	level sql.IsolationLevel
}

// IThingRepositoryMockBeginTxResults contains results of the IThingRepository.BeginTx
type IThingRepositoryMockBeginTxResults struct {
	tp1 *sql.Tx
	err error
}

// Expect sets up expected params for IThingRepository.BeginTx
func (mmBeginTx *mIThingRepositoryMockBeginTx) Expect(ctx context.Context, level sql.IsolationLevel) *mIThingRepositoryMockBeginTx {
	if mmBeginTx.mock.funcBeginTx != nil {
		mmBeginTx.mock.t.Fatalf("IThingRepositoryMock.BeginTx mock is already set by Set")
	}

	if mmBeginTx.defaultExpectation == nil {
		mmBeginTx.defaultExpectation = &IThingRepositoryMockBeginTxExpectation{}
	}

	mmBeginTx.defaultExpectation.params = &IThingRepositoryMockBeginTxParams{ctx, level}
	for _, e := range mmBeginTx.expectations {
		if minimock.Equal(e.params, mmBeginTx.defaultExpectation.params) {
			mmBeginTx.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmBeginTx.defaultExpectation.params)
		}
	}

	return mmBeginTx
}

// Inspect accepts an inspector function that has same arguments as the IThingRepository.BeginTx
func (mmBeginTx *mIThingRepositoryMockBeginTx) Inspect(f func(ctx context.Context, level sql.IsolationLevel)) *mIThingRepositoryMockBeginTx {
	if mmBeginTx.mock.inspectFuncBeginTx != nil {
		mmBeginTx.mock.t.Fatalf("Inspect function is already set for IThingRepositoryMock.BeginTx")
	}

	mmBeginTx.mock.inspectFuncBeginTx = f

	return mmBeginTx
}

// Return sets up results that will be returned by IThingRepository.BeginTx
func (mmBeginTx *mIThingRepositoryMockBeginTx) Return(tp1 *sql.Tx, err error) *IThingRepositoryMock {
	if mmBeginTx.mock.funcBeginTx != nil {
		mmBeginTx.mock.t.Fatalf("IThingRepositoryMock.BeginTx mock is already set by Set")
	}

	if mmBeginTx.defaultExpectation == nil {
		mmBeginTx.defaultExpectation = &IThingRepositoryMockBeginTxExpectation{mock: mmBeginTx.mock}
	}
	mmBeginTx.defaultExpectation.results = &IThingRepositoryMockBeginTxResults{tp1, err}
	return mmBeginTx.mock
}

// Set uses given function f to mock the IThingRepository.BeginTx method
func (mmBeginTx *mIThingRepositoryMockBeginTx) Set(f func(ctx context.Context, level sql.IsolationLevel) (tp1 *sql.Tx, err error)) *IThingRepositoryMock {
	if mmBeginTx.defaultExpectation != nil {
		mmBeginTx.mock.t.Fatalf("Default expectation is already set for the IThingRepository.BeginTx method")
	}

	if len(mmBeginTx.expectations) > 0 {
		mmBeginTx.mock.t.Fatalf("Some expectations are already set for the IThingRepository.BeginTx method")
	}

	mmBeginTx.mock.funcBeginTx = f
	return mmBeginTx.mock
}

// When sets expectation for the IThingRepository.BeginTx which will trigger the result defined by the following
// Then helper
func (mmBeginTx *mIThingRepositoryMockBeginTx) When(ctx context.Context, level sql.IsolationLevel) *IThingRepositoryMockBeginTxExpectation {
	if mmBeginTx.mock.funcBeginTx != nil {
		mmBeginTx.mock.t.Fatalf("IThingRepositoryMock.BeginTx mock is already set by Set")
	}

	expectation := &IThingRepositoryMockBeginTxExpectation{
		mock:   mmBeginTx.mock,
		params: &IThingRepositoryMockBeginTxParams{ctx, level},
	}
	mmBeginTx.expectations = append(mmBeginTx.expectations, expectation)
	return expectation
}

// Then sets up IThingRepository.BeginTx return parameters for the expectation previously defined by the When method
func (e *IThingRepositoryMockBeginTxExpectation) Then(tp1 *sql.Tx, err error) *IThingRepositoryMock {
	e.results = &IThingRepositoryMockBeginTxResults{tp1, err}
	return e.mock
}

// BeginTx implements interfaces.IThingRepository
func (mmBeginTx *IThingRepositoryMock) BeginTx(ctx context.Context, level sql.IsolationLevel) (tp1 *sql.Tx, err error) {
	mm_atomic.AddUint64(&mmBeginTx.beforeBeginTxCounter, 1)
	defer mm_atomic.AddUint64(&mmBeginTx.afterBeginTxCounter, 1)

	if mmBeginTx.inspectFuncBeginTx != nil {
		mmBeginTx.inspectFuncBeginTx(ctx, level)
	}

	mm_params := &IThingRepositoryMockBeginTxParams{ctx, level}

	// Record call args
	mmBeginTx.BeginTxMock.mutex.Lock()
	mmBeginTx.BeginTxMock.callArgs = append(mmBeginTx.BeginTxMock.callArgs, mm_params)
	mmBeginTx.BeginTxMock.mutex.Unlock()

	for _, e := range mmBeginTx.BeginTxMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.tp1, e.results.err
		}
	}

	if mmBeginTx.BeginTxMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmBeginTx.BeginTxMock.defaultExpectation.Counter, 1)
		mm_want := mmBeginTx.BeginTxMock.defaultExpectation.params
		mm_got := IThingRepositoryMockBeginTxParams{ctx, level}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmBeginTx.t.Errorf("IThingRepositoryMock.BeginTx got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmBeginTx.BeginTxMock.defaultExpectation.results
		if mm_results == nil {
			mmBeginTx.t.Fatal("No results are set for the IThingRepositoryMock.BeginTx")
		}
		return (*mm_results).tp1, (*mm_results).err
	}
	if mmBeginTx.funcBeginTx != nil {
		return mmBeginTx.funcBeginTx(ctx, level)
	}
	mmBeginTx.t.Fatalf("Unexpected call to IThingRepositoryMock.BeginTx. %v %v", ctx, level)
	return
}

// BeginTxAfterCounter returns a count of finished IThingRepositoryMock.BeginTx invocations
func (mmBeginTx *IThingRepositoryMock) BeginTxAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmBeginTx.afterBeginTxCounter)
}

// BeginTxBeforeCounter returns a count of IThingRepositoryMock.BeginTx invocations
func (mmBeginTx *IThingRepositoryMock) BeginTxBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmBeginTx.beforeBeginTxCounter)
}

// Calls returns a list of arguments used in each call to IThingRepositoryMock.BeginTx.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmBeginTx *mIThingRepositoryMockBeginTx) Calls() []*IThingRepositoryMockBeginTxParams {
	mmBeginTx.mutex.RLock()

	argCopy := make([]*IThingRepositoryMockBeginTxParams, len(mmBeginTx.callArgs))
	copy(argCopy, mmBeginTx.callArgs)

	mmBeginTx.mutex.RUnlock()

	return argCopy
}

// MinimockBeginTxDone returns true if the count of the BeginTx invocations corresponds
// the number of defined expectations
func (m *IThingRepositoryMock) MinimockBeginTxDone() bool {
	for _, e := range m.BeginTxMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.BeginTxMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterBeginTxCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcBeginTx != nil && mm_atomic.LoadUint64(&m.afterBeginTxCounter) < 1 {
		return false
	}
	return true
}

// MinimockBeginTxInspect logs each unmet expectation
func (m *IThingRepositoryMock) MinimockBeginTxInspect() {
	for _, e := range m.BeginTxMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IThingRepositoryMock.BeginTx with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.BeginTxMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterBeginTxCounter) < 1 {
		if m.BeginTxMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IThingRepositoryMock.BeginTx")
		} else {
			m.t.Errorf("Expected call to IThingRepositoryMock.BeginTx with params: %#v", *m.BeginTxMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcBeginTx != nil && mm_atomic.LoadUint64(&m.afterBeginTxCounter) < 1 {
		m.t.Error("Expected call to IThingRepositoryMock.BeginTx")
	}
}

type mIThingRepositoryMockCommitTx struct {
	mock               *IThingRepositoryMock
	defaultExpectation *IThingRepositoryMockCommitTxExpectation
	expectations       []*IThingRepositoryMockCommitTxExpectation

	callArgs []*IThingRepositoryMockCommitTxParams
	mutex    sync.RWMutex
}

// IThingRepositoryMockCommitTxExpectation specifies expectation struct of the IThingRepository.CommitTx
type IThingRepositoryMockCommitTxExpectation struct {
	mock    *IThingRepositoryMock
	params  *IThingRepositoryMockCommitTxParams
	results *IThingRepositoryMockCommitTxResults
	Counter uint64
}

// IThingRepositoryMockCommitTxParams contains parameters of the IThingRepository.CommitTx
type IThingRepositoryMockCommitTxParams struct {
	tx *sql.Tx
}

// IThingRepositoryMockCommitTxResults contains results of the IThingRepository.CommitTx
type IThingRepositoryMockCommitTxResults struct {
	err error
}

// Expect sets up expected params for IThingRepository.CommitTx
func (mmCommitTx *mIThingRepositoryMockCommitTx) Expect(tx *sql.Tx) *mIThingRepositoryMockCommitTx {
	if mmCommitTx.mock.funcCommitTx != nil {
		mmCommitTx.mock.t.Fatalf("IThingRepositoryMock.CommitTx mock is already set by Set")
	}

	if mmCommitTx.defaultExpectation == nil {
		mmCommitTx.defaultExpectation = &IThingRepositoryMockCommitTxExpectation{}
	}

	mmCommitTx.defaultExpectation.params = &IThingRepositoryMockCommitTxParams{tx}
	for _, e := range mmCommitTx.expectations {
		if minimock.Equal(e.params, mmCommitTx.defaultExpectation.params) {
			mmCommitTx.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmCommitTx.defaultExpectation.params)
		}
	}

	return mmCommitTx
}

// Inspect accepts an inspector function that has same arguments as the IThingRepository.CommitTx
func (mmCommitTx *mIThingRepositoryMockCommitTx) Inspect(f func(tx *sql.Tx)) *mIThingRepositoryMockCommitTx {
	if mmCommitTx.mock.inspectFuncCommitTx != nil {
		mmCommitTx.mock.t.Fatalf("Inspect function is already set for IThingRepositoryMock.CommitTx")
	}

	mmCommitTx.mock.inspectFuncCommitTx = f

	return mmCommitTx
}

// Return sets up results that will be returned by IThingRepository.CommitTx
func (mmCommitTx *mIThingRepositoryMockCommitTx) Return(err error) *IThingRepositoryMock {
	if mmCommitTx.mock.funcCommitTx != nil {
		mmCommitTx.mock.t.Fatalf("IThingRepositoryMock.CommitTx mock is already set by Set")
	}

	if mmCommitTx.defaultExpectation == nil {
		mmCommitTx.defaultExpectation = &IThingRepositoryMockCommitTxExpectation{mock: mmCommitTx.mock}
	}
	mmCommitTx.defaultExpectation.results = &IThingRepositoryMockCommitTxResults{err}
	return mmCommitTx.mock
}

// Set uses given function f to mock the IThingRepository.CommitTx method
func (mmCommitTx *mIThingRepositoryMockCommitTx) Set(f func(tx *sql.Tx) (err error)) *IThingRepositoryMock {
	if mmCommitTx.defaultExpectation != nil {
		mmCommitTx.mock.t.Fatalf("Default expectation is already set for the IThingRepository.CommitTx method")
	}

	if len(mmCommitTx.expectations) > 0 {
		mmCommitTx.mock.t.Fatalf("Some expectations are already set for the IThingRepository.CommitTx method")
	}

	mmCommitTx.mock.funcCommitTx = f
	return mmCommitTx.mock
}

// When sets expectation for the IThingRepository.CommitTx which will trigger the result defined by the following
// Then helper
func (mmCommitTx *mIThingRepositoryMockCommitTx) When(tx *sql.Tx) *IThingRepositoryMockCommitTxExpectation {
	if mmCommitTx.mock.funcCommitTx != nil {
		mmCommitTx.mock.t.Fatalf("IThingRepositoryMock.CommitTx mock is already set by Set")
	}

	expectation := &IThingRepositoryMockCommitTxExpectation{
		mock:   mmCommitTx.mock,
		params: &IThingRepositoryMockCommitTxParams{tx},
	}
	mmCommitTx.expectations = append(mmCommitTx.expectations, expectation)
	return expectation
}

// Then sets up IThingRepository.CommitTx return parameters for the expectation previously defined by the When method
func (e *IThingRepositoryMockCommitTxExpectation) Then(err error) *IThingRepositoryMock {
	e.results = &IThingRepositoryMockCommitTxResults{err}
	return e.mock
}

// CommitTx implements interfaces.IThingRepository
func (mmCommitTx *IThingRepositoryMock) CommitTx(tx *sql.Tx) (err error) {
	mm_atomic.AddUint64(&mmCommitTx.beforeCommitTxCounter, 1)
	defer mm_atomic.AddUint64(&mmCommitTx.afterCommitTxCounter, 1)

	if mmCommitTx.inspectFuncCommitTx != nil {
		mmCommitTx.inspectFuncCommitTx(tx)
	}

	mm_params := &IThingRepositoryMockCommitTxParams{tx}

	// Record call args
	mmCommitTx.CommitTxMock.mutex.Lock()
	mmCommitTx.CommitTxMock.callArgs = append(mmCommitTx.CommitTxMock.callArgs, mm_params)
	mmCommitTx.CommitTxMock.mutex.Unlock()

	for _, e := range mmCommitTx.CommitTxMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmCommitTx.CommitTxMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmCommitTx.CommitTxMock.defaultExpectation.Counter, 1)
		mm_want := mmCommitTx.CommitTxMock.defaultExpectation.params
		mm_got := IThingRepositoryMockCommitTxParams{tx}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmCommitTx.t.Errorf("IThingRepositoryMock.CommitTx got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmCommitTx.CommitTxMock.defaultExpectation.results
		if mm_results == nil {
			mmCommitTx.t.Fatal("No results are set for the IThingRepositoryMock.CommitTx")
		}
		return (*mm_results).err
	}
	if mmCommitTx.funcCommitTx != nil {
		return mmCommitTx.funcCommitTx(tx)
	}
	mmCommitTx.t.Fatalf("Unexpected call to IThingRepositoryMock.CommitTx. %v", tx)
	return
}

// CommitTxAfterCounter returns a count of finished IThingRepositoryMock.CommitTx invocations
func (mmCommitTx *IThingRepositoryMock) CommitTxAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmCommitTx.afterCommitTxCounter)
}

// CommitTxBeforeCounter returns a count of IThingRepositoryMock.CommitTx invocations
func (mmCommitTx *IThingRepositoryMock) CommitTxBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmCommitTx.beforeCommitTxCounter)
}

// Calls returns a list of arguments used in each call to IThingRepositoryMock.CommitTx.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmCommitTx *mIThingRepositoryMockCommitTx) Calls() []*IThingRepositoryMockCommitTxParams {
	mmCommitTx.mutex.RLock()

	argCopy := make([]*IThingRepositoryMockCommitTxParams, len(mmCommitTx.callArgs))
	copy(argCopy, mmCommitTx.callArgs)

	mmCommitTx.mutex.RUnlock()

	return argCopy
}

// MinimockCommitTxDone returns true if the count of the CommitTx invocations corresponds
// the number of defined expectations
func (m *IThingRepositoryMock) MinimockCommitTxDone() bool {
	for _, e := range m.CommitTxMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.CommitTxMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterCommitTxCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcCommitTx != nil && mm_atomic.LoadUint64(&m.afterCommitTxCounter) < 1 {
		return false
	}
	return true
}

// MinimockCommitTxInspect logs each unmet expectation
func (m *IThingRepositoryMock) MinimockCommitTxInspect() {
	for _, e := range m.CommitTxMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IThingRepositoryMock.CommitTx with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.CommitTxMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterCommitTxCounter) < 1 {
		if m.CommitTxMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IThingRepositoryMock.CommitTx")
		} else {
			m.t.Errorf("Expected call to IThingRepositoryMock.CommitTx with params: %#v", *m.CommitTxMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcCommitTx != nil && mm_atomic.LoadUint64(&m.afterCommitTxCounter) < 1 {
		m.t.Error("Expected call to IThingRepositoryMock.CommitTx")
	}
}

type mIThingRepositoryMockDelete struct {
	mock               *IThingRepositoryMock
	defaultExpectation *IThingRepositoryMockDeleteExpectation
	expectations       []*IThingRepositoryMockDeleteExpectation

	callArgs []*IThingRepositoryMockDeleteParams
	mutex    sync.RWMutex
}

// IThingRepositoryMockDeleteExpectation specifies expectation struct of the IThingRepository.Delete
type IThingRepositoryMockDeleteExpectation struct {
	mock    *IThingRepositoryMock
	params  *IThingRepositoryMockDeleteParams
	results *IThingRepositoryMockDeleteResults
	Counter uint64
}

// IThingRepositoryMockDeleteParams contains parameters of the IThingRepository.Delete
type IThingRepositoryMockDeleteParams struct {
	ctx     context.Context
	thingID int
	tx      *sql.Tx
}

// IThingRepositoryMockDeleteResults contains results of the IThingRepository.Delete
type IThingRepositoryMockDeleteResults struct {
	err error
}

// Expect sets up expected params for IThingRepository.Delete
func (mmDelete *mIThingRepositoryMockDelete) Expect(ctx context.Context, thingID int, tx *sql.Tx) *mIThingRepositoryMockDelete {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("IThingRepositoryMock.Delete mock is already set by Set")
	}

	if mmDelete.defaultExpectation == nil {
		mmDelete.defaultExpectation = &IThingRepositoryMockDeleteExpectation{}
	}

	mmDelete.defaultExpectation.params = &IThingRepositoryMockDeleteParams{ctx, thingID, tx}
	for _, e := range mmDelete.expectations {
		if minimock.Equal(e.params, mmDelete.defaultExpectation.params) {
			mmDelete.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmDelete.defaultExpectation.params)
		}
	}

	return mmDelete
}

// Inspect accepts an inspector function that has same arguments as the IThingRepository.Delete
func (mmDelete *mIThingRepositoryMockDelete) Inspect(f func(ctx context.Context, thingID int, tx *sql.Tx)) *mIThingRepositoryMockDelete {
	if mmDelete.mock.inspectFuncDelete != nil {
		mmDelete.mock.t.Fatalf("Inspect function is already set for IThingRepositoryMock.Delete")
	}

	mmDelete.mock.inspectFuncDelete = f

	return mmDelete
}

// Return sets up results that will be returned by IThingRepository.Delete
func (mmDelete *mIThingRepositoryMockDelete) Return(err error) *IThingRepositoryMock {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("IThingRepositoryMock.Delete mock is already set by Set")
	}

	if mmDelete.defaultExpectation == nil {
		mmDelete.defaultExpectation = &IThingRepositoryMockDeleteExpectation{mock: mmDelete.mock}
	}
	mmDelete.defaultExpectation.results = &IThingRepositoryMockDeleteResults{err}
	return mmDelete.mock
}

// Set uses given function f to mock the IThingRepository.Delete method
func (mmDelete *mIThingRepositoryMockDelete) Set(f func(ctx context.Context, thingID int, tx *sql.Tx) (err error)) *IThingRepositoryMock {
	if mmDelete.defaultExpectation != nil {
		mmDelete.mock.t.Fatalf("Default expectation is already set for the IThingRepository.Delete method")
	}

	if len(mmDelete.expectations) > 0 {
		mmDelete.mock.t.Fatalf("Some expectations are already set for the IThingRepository.Delete method")
	}

	mmDelete.mock.funcDelete = f
	return mmDelete.mock
}

// When sets expectation for the IThingRepository.Delete which will trigger the result defined by the following
// Then helper
func (mmDelete *mIThingRepositoryMockDelete) When(ctx context.Context, thingID int, tx *sql.Tx) *IThingRepositoryMockDeleteExpectation {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("IThingRepositoryMock.Delete mock is already set by Set")
	}

	expectation := &IThingRepositoryMockDeleteExpectation{
		mock:   mmDelete.mock,
		params: &IThingRepositoryMockDeleteParams{ctx, thingID, tx},
	}
	mmDelete.expectations = append(mmDelete.expectations, expectation)
	return expectation
}

// Then sets up IThingRepository.Delete return parameters for the expectation previously defined by the When method
func (e *IThingRepositoryMockDeleteExpectation) Then(err error) *IThingRepositoryMock {
	e.results = &IThingRepositoryMockDeleteResults{err}
	return e.mock
}

// Delete implements interfaces.IThingRepository
func (mmDelete *IThingRepositoryMock) Delete(ctx context.Context, thingID int, tx *sql.Tx) (err error) {
	mm_atomic.AddUint64(&mmDelete.beforeDeleteCounter, 1)
	defer mm_atomic.AddUint64(&mmDelete.afterDeleteCounter, 1)

	if mmDelete.inspectFuncDelete != nil {
		mmDelete.inspectFuncDelete(ctx, thingID, tx)
	}

	mm_params := &IThingRepositoryMockDeleteParams{ctx, thingID, tx}

	// Record call args
	mmDelete.DeleteMock.mutex.Lock()
	mmDelete.DeleteMock.callArgs = append(mmDelete.DeleteMock.callArgs, mm_params)
	mmDelete.DeleteMock.mutex.Unlock()

	for _, e := range mmDelete.DeleteMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmDelete.DeleteMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmDelete.DeleteMock.defaultExpectation.Counter, 1)
		mm_want := mmDelete.DeleteMock.defaultExpectation.params
		mm_got := IThingRepositoryMockDeleteParams{ctx, thingID, tx}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmDelete.t.Errorf("IThingRepositoryMock.Delete got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmDelete.DeleteMock.defaultExpectation.results
		if mm_results == nil {
			mmDelete.t.Fatal("No results are set for the IThingRepositoryMock.Delete")
		}
		return (*mm_results).err
	}
	if mmDelete.funcDelete != nil {
		return mmDelete.funcDelete(ctx, thingID, tx)
	}
	mmDelete.t.Fatalf("Unexpected call to IThingRepositoryMock.Delete. %v %v %v", ctx, thingID, tx)
	return
}

// DeleteAfterCounter returns a count of finished IThingRepositoryMock.Delete invocations
func (mmDelete *IThingRepositoryMock) DeleteAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmDelete.afterDeleteCounter)
}

// DeleteBeforeCounter returns a count of IThingRepositoryMock.Delete invocations
func (mmDelete *IThingRepositoryMock) DeleteBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmDelete.beforeDeleteCounter)
}

// Calls returns a list of arguments used in each call to IThingRepositoryMock.Delete.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmDelete *mIThingRepositoryMockDelete) Calls() []*IThingRepositoryMockDeleteParams {
	mmDelete.mutex.RLock()

	argCopy := make([]*IThingRepositoryMockDeleteParams, len(mmDelete.callArgs))
	copy(argCopy, mmDelete.callArgs)

	mmDelete.mutex.RUnlock()

	return argCopy
}

// MinimockDeleteDone returns true if the count of the Delete invocations corresponds
// the number of defined expectations
func (m *IThingRepositoryMock) MinimockDeleteDone() bool {
	for _, e := range m.DeleteMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.DeleteMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcDelete != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		return false
	}
	return true
}

// MinimockDeleteInspect logs each unmet expectation
func (m *IThingRepositoryMock) MinimockDeleteInspect() {
	for _, e := range m.DeleteMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IThingRepositoryMock.Delete with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.DeleteMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		if m.DeleteMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IThingRepositoryMock.Delete")
		} else {
			m.t.Errorf("Expected call to IThingRepositoryMock.Delete with params: %#v", *m.DeleteMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcDelete != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		m.t.Error("Expected call to IThingRepositoryMock.Delete")
	}
}

type mIThingRepositoryMockGet struct {
	mock               *IThingRepositoryMock
	defaultExpectation *IThingRepositoryMockGetExpectation
	expectations       []*IThingRepositoryMockGetExpectation

	callArgs []*IThingRepositoryMockGetParams
	mutex    sync.RWMutex
}

// IThingRepositoryMockGetExpectation specifies expectation struct of the IThingRepository.Get
type IThingRepositoryMockGetExpectation struct {
	mock    *IThingRepositoryMock
	params  *IThingRepositoryMockGetParams
	results *IThingRepositoryMockGetResults
	Counter uint64
}

// IThingRepositoryMockGetParams contains parameters of the IThingRepository.Get
type IThingRepositoryMockGetParams struct {
	ctx     context.Context
	thingID int
}

// IThingRepositoryMockGetResults contains results of the IThingRepository.Get
type IThingRepositoryMockGetResults struct {
	tp1 *models.Thing
	err error
}

// Expect sets up expected params for IThingRepository.Get
func (mmGet *mIThingRepositoryMockGet) Expect(ctx context.Context, thingID int) *mIThingRepositoryMockGet {
	if mmGet.mock.funcGet != nil {
		mmGet.mock.t.Fatalf("IThingRepositoryMock.Get mock is already set by Set")
	}

	if mmGet.defaultExpectation == nil {
		mmGet.defaultExpectation = &IThingRepositoryMockGetExpectation{}
	}

	mmGet.defaultExpectation.params = &IThingRepositoryMockGetParams{ctx, thingID}
	for _, e := range mmGet.expectations {
		if minimock.Equal(e.params, mmGet.defaultExpectation.params) {
			mmGet.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmGet.defaultExpectation.params)
		}
	}

	return mmGet
}

// Inspect accepts an inspector function that has same arguments as the IThingRepository.Get
func (mmGet *mIThingRepositoryMockGet) Inspect(f func(ctx context.Context, thingID int)) *mIThingRepositoryMockGet {
	if mmGet.mock.inspectFuncGet != nil {
		mmGet.mock.t.Fatalf("Inspect function is already set for IThingRepositoryMock.Get")
	}

	mmGet.mock.inspectFuncGet = f

	return mmGet
}

// Return sets up results that will be returned by IThingRepository.Get
func (mmGet *mIThingRepositoryMockGet) Return(tp1 *models.Thing, err error) *IThingRepositoryMock {
	if mmGet.mock.funcGet != nil {
		mmGet.mock.t.Fatalf("IThingRepositoryMock.Get mock is already set by Set")
	}

	if mmGet.defaultExpectation == nil {
		mmGet.defaultExpectation = &IThingRepositoryMockGetExpectation{mock: mmGet.mock}
	}
	mmGet.defaultExpectation.results = &IThingRepositoryMockGetResults{tp1, err}
	return mmGet.mock
}

// Set uses given function f to mock the IThingRepository.Get method
func (mmGet *mIThingRepositoryMockGet) Set(f func(ctx context.Context, thingID int) (tp1 *models.Thing, err error)) *IThingRepositoryMock {
	if mmGet.defaultExpectation != nil {
		mmGet.mock.t.Fatalf("Default expectation is already set for the IThingRepository.Get method")
	}

	if len(mmGet.expectations) > 0 {
		mmGet.mock.t.Fatalf("Some expectations are already set for the IThingRepository.Get method")
	}

	mmGet.mock.funcGet = f
	return mmGet.mock
}

// When sets expectation for the IThingRepository.Get which will trigger the result defined by the following
// Then helper
func (mmGet *mIThingRepositoryMockGet) When(ctx context.Context, thingID int) *IThingRepositoryMockGetExpectation {
	if mmGet.mock.funcGet != nil {
		mmGet.mock.t.Fatalf("IThingRepositoryMock.Get mock is already set by Set")
	}

	expectation := &IThingRepositoryMockGetExpectation{
		mock:   mmGet.mock,
		params: &IThingRepositoryMockGetParams{ctx, thingID},
	}
	mmGet.expectations = append(mmGet.expectations, expectation)
	return expectation
}

// Then sets up IThingRepository.Get return parameters for the expectation previously defined by the When method
func (e *IThingRepositoryMockGetExpectation) Then(tp1 *models.Thing, err error) *IThingRepositoryMock {
	e.results = &IThingRepositoryMockGetResults{tp1, err}
	return e.mock
}

// Get implements interfaces.IThingRepository
func (mmGet *IThingRepositoryMock) Get(ctx context.Context, thingID int) (tp1 *models.Thing, err error) {
	mm_atomic.AddUint64(&mmGet.beforeGetCounter, 1)
	defer mm_atomic.AddUint64(&mmGet.afterGetCounter, 1)

	if mmGet.inspectFuncGet != nil {
		mmGet.inspectFuncGet(ctx, thingID)
	}

	mm_params := &IThingRepositoryMockGetParams{ctx, thingID}

	// Record call args
	mmGet.GetMock.mutex.Lock()
	mmGet.GetMock.callArgs = append(mmGet.GetMock.callArgs, mm_params)
	mmGet.GetMock.mutex.Unlock()

	for _, e := range mmGet.GetMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.tp1, e.results.err
		}
	}

	if mmGet.GetMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmGet.GetMock.defaultExpectation.Counter, 1)
		mm_want := mmGet.GetMock.defaultExpectation.params
		mm_got := IThingRepositoryMockGetParams{ctx, thingID}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmGet.t.Errorf("IThingRepositoryMock.Get got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmGet.GetMock.defaultExpectation.results
		if mm_results == nil {
			mmGet.t.Fatal("No results are set for the IThingRepositoryMock.Get")
		}
		return (*mm_results).tp1, (*mm_results).err
	}
	if mmGet.funcGet != nil {
		return mmGet.funcGet(ctx, thingID)
	}
	mmGet.t.Fatalf("Unexpected call to IThingRepositoryMock.Get. %v %v", ctx, thingID)
	return
}

// GetAfterCounter returns a count of finished IThingRepositoryMock.Get invocations
func (mmGet *IThingRepositoryMock) GetAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGet.afterGetCounter)
}

// GetBeforeCounter returns a count of IThingRepositoryMock.Get invocations
func (mmGet *IThingRepositoryMock) GetBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGet.beforeGetCounter)
}

// Calls returns a list of arguments used in each call to IThingRepositoryMock.Get.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmGet *mIThingRepositoryMockGet) Calls() []*IThingRepositoryMockGetParams {
	mmGet.mutex.RLock()

	argCopy := make([]*IThingRepositoryMockGetParams, len(mmGet.callArgs))
	copy(argCopy, mmGet.callArgs)

	mmGet.mutex.RUnlock()

	return argCopy
}

// MinimockGetDone returns true if the count of the Get invocations corresponds
// the number of defined expectations
func (m *IThingRepositoryMock) MinimockGetDone() bool {
	for _, e := range m.GetMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGet != nil && mm_atomic.LoadUint64(&m.afterGetCounter) < 1 {
		return false
	}
	return true
}

// MinimockGetInspect logs each unmet expectation
func (m *IThingRepositoryMock) MinimockGetInspect() {
	for _, e := range m.GetMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IThingRepositoryMock.Get with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetCounter) < 1 {
		if m.GetMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IThingRepositoryMock.Get")
		} else {
			m.t.Errorf("Expected call to IThingRepositoryMock.Get with params: %#v", *m.GetMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGet != nil && mm_atomic.LoadUint64(&m.afterGetCounter) < 1 {
		m.t.Error("Expected call to IThingRepositoryMock.Get")
	}
}

type mIThingRepositoryMockGetAllByPlaceID struct {
	mock               *IThingRepositoryMock
	defaultExpectation *IThingRepositoryMockGetAllByPlaceIDExpectation
	expectations       []*IThingRepositoryMockGetAllByPlaceIDExpectation

	callArgs []*IThingRepositoryMockGetAllByPlaceIDParams
	mutex    sync.RWMutex
}

// IThingRepositoryMockGetAllByPlaceIDExpectation specifies expectation struct of the IThingRepository.GetAllByPlaceID
type IThingRepositoryMockGetAllByPlaceIDExpectation struct {
	mock    *IThingRepositoryMock
	params  *IThingRepositoryMockGetAllByPlaceIDParams
	results *IThingRepositoryMockGetAllByPlaceIDResults
	Counter uint64
}

// IThingRepositoryMockGetAllByPlaceIDParams contains parameters of the IThingRepository.GetAllByPlaceID
type IThingRepositoryMockGetAllByPlaceIDParams struct {
	ctx     context.Context
	placeID int
}

// IThingRepositoryMockGetAllByPlaceIDResults contains results of the IThingRepository.GetAllByPlaceID
type IThingRepositoryMockGetAllByPlaceIDResults struct {
	ta1 []models.Thing
	err error
}

// Expect sets up expected params for IThingRepository.GetAllByPlaceID
func (mmGetAllByPlaceID *mIThingRepositoryMockGetAllByPlaceID) Expect(ctx context.Context, placeID int) *mIThingRepositoryMockGetAllByPlaceID {
	if mmGetAllByPlaceID.mock.funcGetAllByPlaceID != nil {
		mmGetAllByPlaceID.mock.t.Fatalf("IThingRepositoryMock.GetAllByPlaceID mock is already set by Set")
	}

	if mmGetAllByPlaceID.defaultExpectation == nil {
		mmGetAllByPlaceID.defaultExpectation = &IThingRepositoryMockGetAllByPlaceIDExpectation{}
	}

	mmGetAllByPlaceID.defaultExpectation.params = &IThingRepositoryMockGetAllByPlaceIDParams{ctx, placeID}
	for _, e := range mmGetAllByPlaceID.expectations {
		if minimock.Equal(e.params, mmGetAllByPlaceID.defaultExpectation.params) {
			mmGetAllByPlaceID.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmGetAllByPlaceID.defaultExpectation.params)
		}
	}

	return mmGetAllByPlaceID
}

// Inspect accepts an inspector function that has same arguments as the IThingRepository.GetAllByPlaceID
func (mmGetAllByPlaceID *mIThingRepositoryMockGetAllByPlaceID) Inspect(f func(ctx context.Context, placeID int)) *mIThingRepositoryMockGetAllByPlaceID {
	if mmGetAllByPlaceID.mock.inspectFuncGetAllByPlaceID != nil {
		mmGetAllByPlaceID.mock.t.Fatalf("Inspect function is already set for IThingRepositoryMock.GetAllByPlaceID")
	}

	mmGetAllByPlaceID.mock.inspectFuncGetAllByPlaceID = f

	return mmGetAllByPlaceID
}

// Return sets up results that will be returned by IThingRepository.GetAllByPlaceID
func (mmGetAllByPlaceID *mIThingRepositoryMockGetAllByPlaceID) Return(ta1 []models.Thing, err error) *IThingRepositoryMock {
	if mmGetAllByPlaceID.mock.funcGetAllByPlaceID != nil {
		mmGetAllByPlaceID.mock.t.Fatalf("IThingRepositoryMock.GetAllByPlaceID mock is already set by Set")
	}

	if mmGetAllByPlaceID.defaultExpectation == nil {
		mmGetAllByPlaceID.defaultExpectation = &IThingRepositoryMockGetAllByPlaceIDExpectation{mock: mmGetAllByPlaceID.mock}
	}
	mmGetAllByPlaceID.defaultExpectation.results = &IThingRepositoryMockGetAllByPlaceIDResults{ta1, err}
	return mmGetAllByPlaceID.mock
}

// Set uses given function f to mock the IThingRepository.GetAllByPlaceID method
func (mmGetAllByPlaceID *mIThingRepositoryMockGetAllByPlaceID) Set(f func(ctx context.Context, placeID int) (ta1 []models.Thing, err error)) *IThingRepositoryMock {
	if mmGetAllByPlaceID.defaultExpectation != nil {
		mmGetAllByPlaceID.mock.t.Fatalf("Default expectation is already set for the IThingRepository.GetAllByPlaceID method")
	}

	if len(mmGetAllByPlaceID.expectations) > 0 {
		mmGetAllByPlaceID.mock.t.Fatalf("Some expectations are already set for the IThingRepository.GetAllByPlaceID method")
	}

	mmGetAllByPlaceID.mock.funcGetAllByPlaceID = f
	return mmGetAllByPlaceID.mock
}

// When sets expectation for the IThingRepository.GetAllByPlaceID which will trigger the result defined by the following
// Then helper
func (mmGetAllByPlaceID *mIThingRepositoryMockGetAllByPlaceID) When(ctx context.Context, placeID int) *IThingRepositoryMockGetAllByPlaceIDExpectation {
	if mmGetAllByPlaceID.mock.funcGetAllByPlaceID != nil {
		mmGetAllByPlaceID.mock.t.Fatalf("IThingRepositoryMock.GetAllByPlaceID mock is already set by Set")
	}

	expectation := &IThingRepositoryMockGetAllByPlaceIDExpectation{
		mock:   mmGetAllByPlaceID.mock,
		params: &IThingRepositoryMockGetAllByPlaceIDParams{ctx, placeID},
	}
	mmGetAllByPlaceID.expectations = append(mmGetAllByPlaceID.expectations, expectation)
	return expectation
}

// Then sets up IThingRepository.GetAllByPlaceID return parameters for the expectation previously defined by the When method
func (e *IThingRepositoryMockGetAllByPlaceIDExpectation) Then(ta1 []models.Thing, err error) *IThingRepositoryMock {
	e.results = &IThingRepositoryMockGetAllByPlaceIDResults{ta1, err}
	return e.mock
}

// GetAllByPlaceID implements interfaces.IThingRepository
func (mmGetAllByPlaceID *IThingRepositoryMock) GetAllByPlaceID(ctx context.Context, placeID int) (ta1 []models.Thing, err error) {
	mm_atomic.AddUint64(&mmGetAllByPlaceID.beforeGetAllByPlaceIDCounter, 1)
	defer mm_atomic.AddUint64(&mmGetAllByPlaceID.afterGetAllByPlaceIDCounter, 1)

	if mmGetAllByPlaceID.inspectFuncGetAllByPlaceID != nil {
		mmGetAllByPlaceID.inspectFuncGetAllByPlaceID(ctx, placeID)
	}

	mm_params := &IThingRepositoryMockGetAllByPlaceIDParams{ctx, placeID}

	// Record call args
	mmGetAllByPlaceID.GetAllByPlaceIDMock.mutex.Lock()
	mmGetAllByPlaceID.GetAllByPlaceIDMock.callArgs = append(mmGetAllByPlaceID.GetAllByPlaceIDMock.callArgs, mm_params)
	mmGetAllByPlaceID.GetAllByPlaceIDMock.mutex.Unlock()

	for _, e := range mmGetAllByPlaceID.GetAllByPlaceIDMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.ta1, e.results.err
		}
	}

	if mmGetAllByPlaceID.GetAllByPlaceIDMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmGetAllByPlaceID.GetAllByPlaceIDMock.defaultExpectation.Counter, 1)
		mm_want := mmGetAllByPlaceID.GetAllByPlaceIDMock.defaultExpectation.params
		mm_got := IThingRepositoryMockGetAllByPlaceIDParams{ctx, placeID}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmGetAllByPlaceID.t.Errorf("IThingRepositoryMock.GetAllByPlaceID got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmGetAllByPlaceID.GetAllByPlaceIDMock.defaultExpectation.results
		if mm_results == nil {
			mmGetAllByPlaceID.t.Fatal("No results are set for the IThingRepositoryMock.GetAllByPlaceID")
		}
		return (*mm_results).ta1, (*mm_results).err
	}
	if mmGetAllByPlaceID.funcGetAllByPlaceID != nil {
		return mmGetAllByPlaceID.funcGetAllByPlaceID(ctx, placeID)
	}
	mmGetAllByPlaceID.t.Fatalf("Unexpected call to IThingRepositoryMock.GetAllByPlaceID. %v %v", ctx, placeID)
	return
}

// GetAllByPlaceIDAfterCounter returns a count of finished IThingRepositoryMock.GetAllByPlaceID invocations
func (mmGetAllByPlaceID *IThingRepositoryMock) GetAllByPlaceIDAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGetAllByPlaceID.afterGetAllByPlaceIDCounter)
}

// GetAllByPlaceIDBeforeCounter returns a count of IThingRepositoryMock.GetAllByPlaceID invocations
func (mmGetAllByPlaceID *IThingRepositoryMock) GetAllByPlaceIDBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGetAllByPlaceID.beforeGetAllByPlaceIDCounter)
}

// Calls returns a list of arguments used in each call to IThingRepositoryMock.GetAllByPlaceID.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmGetAllByPlaceID *mIThingRepositoryMockGetAllByPlaceID) Calls() []*IThingRepositoryMockGetAllByPlaceIDParams {
	mmGetAllByPlaceID.mutex.RLock()

	argCopy := make([]*IThingRepositoryMockGetAllByPlaceIDParams, len(mmGetAllByPlaceID.callArgs))
	copy(argCopy, mmGetAllByPlaceID.callArgs)

	mmGetAllByPlaceID.mutex.RUnlock()

	return argCopy
}

// MinimockGetAllByPlaceIDDone returns true if the count of the GetAllByPlaceID invocations corresponds
// the number of defined expectations
func (m *IThingRepositoryMock) MinimockGetAllByPlaceIDDone() bool {
	for _, e := range m.GetAllByPlaceIDMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetAllByPlaceIDMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetAllByPlaceIDCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGetAllByPlaceID != nil && mm_atomic.LoadUint64(&m.afterGetAllByPlaceIDCounter) < 1 {
		return false
	}
	return true
}

// MinimockGetAllByPlaceIDInspect logs each unmet expectation
func (m *IThingRepositoryMock) MinimockGetAllByPlaceIDInspect() {
	for _, e := range m.GetAllByPlaceIDMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IThingRepositoryMock.GetAllByPlaceID with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetAllByPlaceIDMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetAllByPlaceIDCounter) < 1 {
		if m.GetAllByPlaceIDMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IThingRepositoryMock.GetAllByPlaceID")
		} else {
			m.t.Errorf("Expected call to IThingRepositoryMock.GetAllByPlaceID with params: %#v", *m.GetAllByPlaceIDMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGetAllByPlaceID != nil && mm_atomic.LoadUint64(&m.afterGetAllByPlaceIDCounter) < 1 {
		m.t.Error("Expected call to IThingRepositoryMock.GetAllByPlaceID")
	}
}

type mIThingRepositoryMockGetByPlaceID struct {
	mock               *IThingRepositoryMock
	defaultExpectation *IThingRepositoryMockGetByPlaceIDExpectation
	expectations       []*IThingRepositoryMockGetByPlaceIDExpectation

	callArgs []*IThingRepositoryMockGetByPlaceIDParams
	mutex    sync.RWMutex
}

// IThingRepositoryMockGetByPlaceIDExpectation specifies expectation struct of the IThingRepository.GetByPlaceID
type IThingRepositoryMockGetByPlaceIDExpectation struct {
	mock    *IThingRepositoryMock
	params  *IThingRepositoryMockGetByPlaceIDParams
	results *IThingRepositoryMockGetByPlaceIDResults
	Counter uint64
}

// IThingRepositoryMockGetByPlaceIDParams contains parameters of the IThingRepository.GetByPlaceID
type IThingRepositoryMockGetByPlaceIDParams struct {
	ctx     context.Context
	placeID int
}

// IThingRepositoryMockGetByPlaceIDResults contains results of the IThingRepository.GetByPlaceID
type IThingRepositoryMockGetByPlaceIDResults struct {
	ta1 []models.Thing
	err error
}

// Expect sets up expected params for IThingRepository.GetByPlaceID
func (mmGetByPlaceID *mIThingRepositoryMockGetByPlaceID) Expect(ctx context.Context, placeID int) *mIThingRepositoryMockGetByPlaceID {
	if mmGetByPlaceID.mock.funcGetByPlaceID != nil {
		mmGetByPlaceID.mock.t.Fatalf("IThingRepositoryMock.GetByPlaceID mock is already set by Set")
	}

	if mmGetByPlaceID.defaultExpectation == nil {
		mmGetByPlaceID.defaultExpectation = &IThingRepositoryMockGetByPlaceIDExpectation{}
	}

	mmGetByPlaceID.defaultExpectation.params = &IThingRepositoryMockGetByPlaceIDParams{ctx, placeID}
	for _, e := range mmGetByPlaceID.expectations {
		if minimock.Equal(e.params, mmGetByPlaceID.defaultExpectation.params) {
			mmGetByPlaceID.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmGetByPlaceID.defaultExpectation.params)
		}
	}

	return mmGetByPlaceID
}

// Inspect accepts an inspector function that has same arguments as the IThingRepository.GetByPlaceID
func (mmGetByPlaceID *mIThingRepositoryMockGetByPlaceID) Inspect(f func(ctx context.Context, placeID int)) *mIThingRepositoryMockGetByPlaceID {
	if mmGetByPlaceID.mock.inspectFuncGetByPlaceID != nil {
		mmGetByPlaceID.mock.t.Fatalf("Inspect function is already set for IThingRepositoryMock.GetByPlaceID")
	}

	mmGetByPlaceID.mock.inspectFuncGetByPlaceID = f

	return mmGetByPlaceID
}

// Return sets up results that will be returned by IThingRepository.GetByPlaceID
func (mmGetByPlaceID *mIThingRepositoryMockGetByPlaceID) Return(ta1 []models.Thing, err error) *IThingRepositoryMock {
	if mmGetByPlaceID.mock.funcGetByPlaceID != nil {
		mmGetByPlaceID.mock.t.Fatalf("IThingRepositoryMock.GetByPlaceID mock is already set by Set")
	}

	if mmGetByPlaceID.defaultExpectation == nil {
		mmGetByPlaceID.defaultExpectation = &IThingRepositoryMockGetByPlaceIDExpectation{mock: mmGetByPlaceID.mock}
	}
	mmGetByPlaceID.defaultExpectation.results = &IThingRepositoryMockGetByPlaceIDResults{ta1, err}
	return mmGetByPlaceID.mock
}

// Set uses given function f to mock the IThingRepository.GetByPlaceID method
func (mmGetByPlaceID *mIThingRepositoryMockGetByPlaceID) Set(f func(ctx context.Context, placeID int) (ta1 []models.Thing, err error)) *IThingRepositoryMock {
	if mmGetByPlaceID.defaultExpectation != nil {
		mmGetByPlaceID.mock.t.Fatalf("Default expectation is already set for the IThingRepository.GetByPlaceID method")
	}

	if len(mmGetByPlaceID.expectations) > 0 {
		mmGetByPlaceID.mock.t.Fatalf("Some expectations are already set for the IThingRepository.GetByPlaceID method")
	}

	mmGetByPlaceID.mock.funcGetByPlaceID = f
	return mmGetByPlaceID.mock
}

// When sets expectation for the IThingRepository.GetByPlaceID which will trigger the result defined by the following
// Then helper
func (mmGetByPlaceID *mIThingRepositoryMockGetByPlaceID) When(ctx context.Context, placeID int) *IThingRepositoryMockGetByPlaceIDExpectation {
	if mmGetByPlaceID.mock.funcGetByPlaceID != nil {
		mmGetByPlaceID.mock.t.Fatalf("IThingRepositoryMock.GetByPlaceID mock is already set by Set")
	}

	expectation := &IThingRepositoryMockGetByPlaceIDExpectation{
		mock:   mmGetByPlaceID.mock,
		params: &IThingRepositoryMockGetByPlaceIDParams{ctx, placeID},
	}
	mmGetByPlaceID.expectations = append(mmGetByPlaceID.expectations, expectation)
	return expectation
}

// Then sets up IThingRepository.GetByPlaceID return parameters for the expectation previously defined by the When method
func (e *IThingRepositoryMockGetByPlaceIDExpectation) Then(ta1 []models.Thing, err error) *IThingRepositoryMock {
	e.results = &IThingRepositoryMockGetByPlaceIDResults{ta1, err}
	return e.mock
}

// GetByPlaceID implements interfaces.IThingRepository
func (mmGetByPlaceID *IThingRepositoryMock) GetByPlaceID(ctx context.Context, placeID int) (ta1 []models.Thing, err error) {
	mm_atomic.AddUint64(&mmGetByPlaceID.beforeGetByPlaceIDCounter, 1)
	defer mm_atomic.AddUint64(&mmGetByPlaceID.afterGetByPlaceIDCounter, 1)

	if mmGetByPlaceID.inspectFuncGetByPlaceID != nil {
		mmGetByPlaceID.inspectFuncGetByPlaceID(ctx, placeID)
	}

	mm_params := &IThingRepositoryMockGetByPlaceIDParams{ctx, placeID}

	// Record call args
	mmGetByPlaceID.GetByPlaceIDMock.mutex.Lock()
	mmGetByPlaceID.GetByPlaceIDMock.callArgs = append(mmGetByPlaceID.GetByPlaceIDMock.callArgs, mm_params)
	mmGetByPlaceID.GetByPlaceIDMock.mutex.Unlock()

	for _, e := range mmGetByPlaceID.GetByPlaceIDMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.ta1, e.results.err
		}
	}

	if mmGetByPlaceID.GetByPlaceIDMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmGetByPlaceID.GetByPlaceIDMock.defaultExpectation.Counter, 1)
		mm_want := mmGetByPlaceID.GetByPlaceIDMock.defaultExpectation.params
		mm_got := IThingRepositoryMockGetByPlaceIDParams{ctx, placeID}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmGetByPlaceID.t.Errorf("IThingRepositoryMock.GetByPlaceID got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmGetByPlaceID.GetByPlaceIDMock.defaultExpectation.results
		if mm_results == nil {
			mmGetByPlaceID.t.Fatal("No results are set for the IThingRepositoryMock.GetByPlaceID")
		}
		return (*mm_results).ta1, (*mm_results).err
	}
	if mmGetByPlaceID.funcGetByPlaceID != nil {
		return mmGetByPlaceID.funcGetByPlaceID(ctx, placeID)
	}
	mmGetByPlaceID.t.Fatalf("Unexpected call to IThingRepositoryMock.GetByPlaceID. %v %v", ctx, placeID)
	return
}

// GetByPlaceIDAfterCounter returns a count of finished IThingRepositoryMock.GetByPlaceID invocations
func (mmGetByPlaceID *IThingRepositoryMock) GetByPlaceIDAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGetByPlaceID.afterGetByPlaceIDCounter)
}

// GetByPlaceIDBeforeCounter returns a count of IThingRepositoryMock.GetByPlaceID invocations
func (mmGetByPlaceID *IThingRepositoryMock) GetByPlaceIDBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmGetByPlaceID.beforeGetByPlaceIDCounter)
}

// Calls returns a list of arguments used in each call to IThingRepositoryMock.GetByPlaceID.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmGetByPlaceID *mIThingRepositoryMockGetByPlaceID) Calls() []*IThingRepositoryMockGetByPlaceIDParams {
	mmGetByPlaceID.mutex.RLock()

	argCopy := make([]*IThingRepositoryMockGetByPlaceIDParams, len(mmGetByPlaceID.callArgs))
	copy(argCopy, mmGetByPlaceID.callArgs)

	mmGetByPlaceID.mutex.RUnlock()

	return argCopy
}

// MinimockGetByPlaceIDDone returns true if the count of the GetByPlaceID invocations corresponds
// the number of defined expectations
func (m *IThingRepositoryMock) MinimockGetByPlaceIDDone() bool {
	for _, e := range m.GetByPlaceIDMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetByPlaceIDMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetByPlaceIDCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGetByPlaceID != nil && mm_atomic.LoadUint64(&m.afterGetByPlaceIDCounter) < 1 {
		return false
	}
	return true
}

// MinimockGetByPlaceIDInspect logs each unmet expectation
func (m *IThingRepositoryMock) MinimockGetByPlaceIDInspect() {
	for _, e := range m.GetByPlaceIDMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IThingRepositoryMock.GetByPlaceID with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.GetByPlaceIDMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterGetByPlaceIDCounter) < 1 {
		if m.GetByPlaceIDMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IThingRepositoryMock.GetByPlaceID")
		} else {
			m.t.Errorf("Expected call to IThingRepositoryMock.GetByPlaceID with params: %#v", *m.GetByPlaceIDMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcGetByPlaceID != nil && mm_atomic.LoadUint64(&m.afterGetByPlaceIDCounter) < 1 {
		m.t.Error("Expected call to IThingRepositoryMock.GetByPlaceID")
	}
}

type mIThingRepositoryMockSearch struct {
	mock               *IThingRepositoryMock
	defaultExpectation *IThingRepositoryMockSearchExpectation
	expectations       []*IThingRepositoryMockSearchExpectation

	callArgs []*IThingRepositoryMockSearchParams
	mutex    sync.RWMutex
}

// IThingRepositoryMockSearchExpectation specifies expectation struct of the IThingRepository.Search
type IThingRepositoryMockSearchExpectation struct {
	mock    *IThingRepositoryMock
	params  *IThingRepositoryMockSearchParams
	results *IThingRepositoryMockSearchResults
	Counter uint64
}

// IThingRepositoryMockSearchParams contains parameters of the IThingRepository.Search
type IThingRepositoryMockSearchParams struct {
	ctx    context.Context
	search string
}

// IThingRepositoryMockSearchResults contains results of the IThingRepository.Search
type IThingRepositoryMockSearchResults struct {
	ta1 []models.Thing
	err error
}

// Expect sets up expected params for IThingRepository.Search
func (mmSearch *mIThingRepositoryMockSearch) Expect(ctx context.Context, search string) *mIThingRepositoryMockSearch {
	if mmSearch.mock.funcSearch != nil {
		mmSearch.mock.t.Fatalf("IThingRepositoryMock.Search mock is already set by Set")
	}

	if mmSearch.defaultExpectation == nil {
		mmSearch.defaultExpectation = &IThingRepositoryMockSearchExpectation{}
	}

	mmSearch.defaultExpectation.params = &IThingRepositoryMockSearchParams{ctx, search}
	for _, e := range mmSearch.expectations {
		if minimock.Equal(e.params, mmSearch.defaultExpectation.params) {
			mmSearch.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmSearch.defaultExpectation.params)
		}
	}

	return mmSearch
}

// Inspect accepts an inspector function that has same arguments as the IThingRepository.Search
func (mmSearch *mIThingRepositoryMockSearch) Inspect(f func(ctx context.Context, search string)) *mIThingRepositoryMockSearch {
	if mmSearch.mock.inspectFuncSearch != nil {
		mmSearch.mock.t.Fatalf("Inspect function is already set for IThingRepositoryMock.Search")
	}

	mmSearch.mock.inspectFuncSearch = f

	return mmSearch
}

// Return sets up results that will be returned by IThingRepository.Search
func (mmSearch *mIThingRepositoryMockSearch) Return(ta1 []models.Thing, err error) *IThingRepositoryMock {
	if mmSearch.mock.funcSearch != nil {
		mmSearch.mock.t.Fatalf("IThingRepositoryMock.Search mock is already set by Set")
	}

	if mmSearch.defaultExpectation == nil {
		mmSearch.defaultExpectation = &IThingRepositoryMockSearchExpectation{mock: mmSearch.mock}
	}
	mmSearch.defaultExpectation.results = &IThingRepositoryMockSearchResults{ta1, err}
	return mmSearch.mock
}

// Set uses given function f to mock the IThingRepository.Search method
func (mmSearch *mIThingRepositoryMockSearch) Set(f func(ctx context.Context, search string) (ta1 []models.Thing, err error)) *IThingRepositoryMock {
	if mmSearch.defaultExpectation != nil {
		mmSearch.mock.t.Fatalf("Default expectation is already set for the IThingRepository.Search method")
	}

	if len(mmSearch.expectations) > 0 {
		mmSearch.mock.t.Fatalf("Some expectations are already set for the IThingRepository.Search method")
	}

	mmSearch.mock.funcSearch = f
	return mmSearch.mock
}

// When sets expectation for the IThingRepository.Search which will trigger the result defined by the following
// Then helper
func (mmSearch *mIThingRepositoryMockSearch) When(ctx context.Context, search string) *IThingRepositoryMockSearchExpectation {
	if mmSearch.mock.funcSearch != nil {
		mmSearch.mock.t.Fatalf("IThingRepositoryMock.Search mock is already set by Set")
	}

	expectation := &IThingRepositoryMockSearchExpectation{
		mock:   mmSearch.mock,
		params: &IThingRepositoryMockSearchParams{ctx, search},
	}
	mmSearch.expectations = append(mmSearch.expectations, expectation)
	return expectation
}

// Then sets up IThingRepository.Search return parameters for the expectation previously defined by the When method
func (e *IThingRepositoryMockSearchExpectation) Then(ta1 []models.Thing, err error) *IThingRepositoryMock {
	e.results = &IThingRepositoryMockSearchResults{ta1, err}
	return e.mock
}

// Search implements interfaces.IThingRepository
func (mmSearch *IThingRepositoryMock) Search(ctx context.Context, search string) (ta1 []models.Thing, err error) {
	mm_atomic.AddUint64(&mmSearch.beforeSearchCounter, 1)
	defer mm_atomic.AddUint64(&mmSearch.afterSearchCounter, 1)

	if mmSearch.inspectFuncSearch != nil {
		mmSearch.inspectFuncSearch(ctx, search)
	}

	mm_params := &IThingRepositoryMockSearchParams{ctx, search}

	// Record call args
	mmSearch.SearchMock.mutex.Lock()
	mmSearch.SearchMock.callArgs = append(mmSearch.SearchMock.callArgs, mm_params)
	mmSearch.SearchMock.mutex.Unlock()

	for _, e := range mmSearch.SearchMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.ta1, e.results.err
		}
	}

	if mmSearch.SearchMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmSearch.SearchMock.defaultExpectation.Counter, 1)
		mm_want := mmSearch.SearchMock.defaultExpectation.params
		mm_got := IThingRepositoryMockSearchParams{ctx, search}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmSearch.t.Errorf("IThingRepositoryMock.Search got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmSearch.SearchMock.defaultExpectation.results
		if mm_results == nil {
			mmSearch.t.Fatal("No results are set for the IThingRepositoryMock.Search")
		}
		return (*mm_results).ta1, (*mm_results).err
	}
	if mmSearch.funcSearch != nil {
		return mmSearch.funcSearch(ctx, search)
	}
	mmSearch.t.Fatalf("Unexpected call to IThingRepositoryMock.Search. %v %v", ctx, search)
	return
}

// SearchAfterCounter returns a count of finished IThingRepositoryMock.Search invocations
func (mmSearch *IThingRepositoryMock) SearchAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmSearch.afterSearchCounter)
}

// SearchBeforeCounter returns a count of IThingRepositoryMock.Search invocations
func (mmSearch *IThingRepositoryMock) SearchBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmSearch.beforeSearchCounter)
}

// Calls returns a list of arguments used in each call to IThingRepositoryMock.Search.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmSearch *mIThingRepositoryMockSearch) Calls() []*IThingRepositoryMockSearchParams {
	mmSearch.mutex.RLock()

	argCopy := make([]*IThingRepositoryMockSearchParams, len(mmSearch.callArgs))
	copy(argCopy, mmSearch.callArgs)

	mmSearch.mutex.RUnlock()

	return argCopy
}

// MinimockSearchDone returns true if the count of the Search invocations corresponds
// the number of defined expectations
func (m *IThingRepositoryMock) MinimockSearchDone() bool {
	for _, e := range m.SearchMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.SearchMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterSearchCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcSearch != nil && mm_atomic.LoadUint64(&m.afterSearchCounter) < 1 {
		return false
	}
	return true
}

// MinimockSearchInspect logs each unmet expectation
func (m *IThingRepositoryMock) MinimockSearchInspect() {
	for _, e := range m.SearchMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IThingRepositoryMock.Search with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.SearchMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterSearchCounter) < 1 {
		if m.SearchMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IThingRepositoryMock.Search")
		} else {
			m.t.Errorf("Expected call to IThingRepositoryMock.Search with params: %#v", *m.SearchMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcSearch != nil && mm_atomic.LoadUint64(&m.afterSearchCounter) < 1 {
		m.t.Error("Expected call to IThingRepositoryMock.Search")
	}
}

type mIThingRepositoryMockUpdate struct {
	mock               *IThingRepositoryMock
	defaultExpectation *IThingRepositoryMockUpdateExpectation
	expectations       []*IThingRepositoryMockUpdateExpectation

	callArgs []*IThingRepositoryMockUpdateParams
	mutex    sync.RWMutex
}

// IThingRepositoryMockUpdateExpectation specifies expectation struct of the IThingRepository.Update
type IThingRepositoryMockUpdateExpectation struct {
	mock    *IThingRepositoryMock
	params  *IThingRepositoryMockUpdateParams
	results *IThingRepositoryMockUpdateResults
	Counter uint64
}

// IThingRepositoryMockUpdateParams contains parameters of the IThingRepository.Update
type IThingRepositoryMockUpdateParams struct {
	ctx context.Context
	req models.UpdateThingRequest
	tx  *sql.Tx
}

// IThingRepositoryMockUpdateResults contains results of the IThingRepository.Update
type IThingRepositoryMockUpdateResults struct {
	err error
}

// Expect sets up expected params for IThingRepository.Update
func (mmUpdate *mIThingRepositoryMockUpdate) Expect(ctx context.Context, req models.UpdateThingRequest, tx *sql.Tx) *mIThingRepositoryMockUpdate {
	if mmUpdate.mock.funcUpdate != nil {
		mmUpdate.mock.t.Fatalf("IThingRepositoryMock.Update mock is already set by Set")
	}

	if mmUpdate.defaultExpectation == nil {
		mmUpdate.defaultExpectation = &IThingRepositoryMockUpdateExpectation{}
	}

	mmUpdate.defaultExpectation.params = &IThingRepositoryMockUpdateParams{ctx, req, tx}
	for _, e := range mmUpdate.expectations {
		if minimock.Equal(e.params, mmUpdate.defaultExpectation.params) {
			mmUpdate.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmUpdate.defaultExpectation.params)
		}
	}

	return mmUpdate
}

// Inspect accepts an inspector function that has same arguments as the IThingRepository.Update
func (mmUpdate *mIThingRepositoryMockUpdate) Inspect(f func(ctx context.Context, req models.UpdateThingRequest, tx *sql.Tx)) *mIThingRepositoryMockUpdate {
	if mmUpdate.mock.inspectFuncUpdate != nil {
		mmUpdate.mock.t.Fatalf("Inspect function is already set for IThingRepositoryMock.Update")
	}

	mmUpdate.mock.inspectFuncUpdate = f

	return mmUpdate
}

// Return sets up results that will be returned by IThingRepository.Update
func (mmUpdate *mIThingRepositoryMockUpdate) Return(err error) *IThingRepositoryMock {
	if mmUpdate.mock.funcUpdate != nil {
		mmUpdate.mock.t.Fatalf("IThingRepositoryMock.Update mock is already set by Set")
	}

	if mmUpdate.defaultExpectation == nil {
		mmUpdate.defaultExpectation = &IThingRepositoryMockUpdateExpectation{mock: mmUpdate.mock}
	}
	mmUpdate.defaultExpectation.results = &IThingRepositoryMockUpdateResults{err}
	return mmUpdate.mock
}

// Set uses given function f to mock the IThingRepository.Update method
func (mmUpdate *mIThingRepositoryMockUpdate) Set(f func(ctx context.Context, req models.UpdateThingRequest, tx *sql.Tx) (err error)) *IThingRepositoryMock {
	if mmUpdate.defaultExpectation != nil {
		mmUpdate.mock.t.Fatalf("Default expectation is already set for the IThingRepository.Update method")
	}

	if len(mmUpdate.expectations) > 0 {
		mmUpdate.mock.t.Fatalf("Some expectations are already set for the IThingRepository.Update method")
	}

	mmUpdate.mock.funcUpdate = f
	return mmUpdate.mock
}

// When sets expectation for the IThingRepository.Update which will trigger the result defined by the following
// Then helper
func (mmUpdate *mIThingRepositoryMockUpdate) When(ctx context.Context, req models.UpdateThingRequest, tx *sql.Tx) *IThingRepositoryMockUpdateExpectation {
	if mmUpdate.mock.funcUpdate != nil {
		mmUpdate.mock.t.Fatalf("IThingRepositoryMock.Update mock is already set by Set")
	}

	expectation := &IThingRepositoryMockUpdateExpectation{
		mock:   mmUpdate.mock,
		params: &IThingRepositoryMockUpdateParams{ctx, req, tx},
	}
	mmUpdate.expectations = append(mmUpdate.expectations, expectation)
	return expectation
}

// Then sets up IThingRepository.Update return parameters for the expectation previously defined by the When method
func (e *IThingRepositoryMockUpdateExpectation) Then(err error) *IThingRepositoryMock {
	e.results = &IThingRepositoryMockUpdateResults{err}
	return e.mock
}

// Update implements interfaces.IThingRepository
func (mmUpdate *IThingRepositoryMock) Update(ctx context.Context, req models.UpdateThingRequest, tx *sql.Tx) (err error) {
	mm_atomic.AddUint64(&mmUpdate.beforeUpdateCounter, 1)
	defer mm_atomic.AddUint64(&mmUpdate.afterUpdateCounter, 1)

	if mmUpdate.inspectFuncUpdate != nil {
		mmUpdate.inspectFuncUpdate(ctx, req, tx)
	}

	mm_params := &IThingRepositoryMockUpdateParams{ctx, req, tx}

	// Record call args
	mmUpdate.UpdateMock.mutex.Lock()
	mmUpdate.UpdateMock.callArgs = append(mmUpdate.UpdateMock.callArgs, mm_params)
	mmUpdate.UpdateMock.mutex.Unlock()

	for _, e := range mmUpdate.UpdateMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmUpdate.UpdateMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmUpdate.UpdateMock.defaultExpectation.Counter, 1)
		mm_want := mmUpdate.UpdateMock.defaultExpectation.params
		mm_got := IThingRepositoryMockUpdateParams{ctx, req, tx}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmUpdate.t.Errorf("IThingRepositoryMock.Update got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmUpdate.UpdateMock.defaultExpectation.results
		if mm_results == nil {
			mmUpdate.t.Fatal("No results are set for the IThingRepositoryMock.Update")
		}
		return (*mm_results).err
	}
	if mmUpdate.funcUpdate != nil {
		return mmUpdate.funcUpdate(ctx, req, tx)
	}
	mmUpdate.t.Fatalf("Unexpected call to IThingRepositoryMock.Update. %v %v %v", ctx, req, tx)
	return
}

// UpdateAfterCounter returns a count of finished IThingRepositoryMock.Update invocations
func (mmUpdate *IThingRepositoryMock) UpdateAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmUpdate.afterUpdateCounter)
}

// UpdateBeforeCounter returns a count of IThingRepositoryMock.Update invocations
func (mmUpdate *IThingRepositoryMock) UpdateBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmUpdate.beforeUpdateCounter)
}

// Calls returns a list of arguments used in each call to IThingRepositoryMock.Update.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmUpdate *mIThingRepositoryMockUpdate) Calls() []*IThingRepositoryMockUpdateParams {
	mmUpdate.mutex.RLock()

	argCopy := make([]*IThingRepositoryMockUpdateParams, len(mmUpdate.callArgs))
	copy(argCopy, mmUpdate.callArgs)

	mmUpdate.mutex.RUnlock()

	return argCopy
}

// MinimockUpdateDone returns true if the count of the Update invocations corresponds
// the number of defined expectations
func (m *IThingRepositoryMock) MinimockUpdateDone() bool {
	for _, e := range m.UpdateMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.UpdateMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterUpdateCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcUpdate != nil && mm_atomic.LoadUint64(&m.afterUpdateCounter) < 1 {
		return false
	}
	return true
}

// MinimockUpdateInspect logs each unmet expectation
func (m *IThingRepositoryMock) MinimockUpdateInspect() {
	for _, e := range m.UpdateMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IThingRepositoryMock.Update with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.UpdateMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterUpdateCounter) < 1 {
		if m.UpdateMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IThingRepositoryMock.Update")
		} else {
			m.t.Errorf("Expected call to IThingRepositoryMock.Update with params: %#v", *m.UpdateMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcUpdate != nil && mm_atomic.LoadUint64(&m.afterUpdateCounter) < 1 {
		m.t.Error("Expected call to IThingRepositoryMock.Update")
	}
}

// MinimockFinish checks that all mocked methods have been called the expected number of times
func (m *IThingRepositoryMock) MinimockFinish() {
	if !m.minimockDone() {
		m.MinimockAddInspect()

		m.MinimockBeginTxInspect()

		m.MinimockCommitTxInspect()

		m.MinimockDeleteInspect()

		m.MinimockGetInspect()

		m.MinimockGetAllByPlaceIDInspect()

		m.MinimockGetByPlaceIDInspect()

		m.MinimockSearchInspect()

		m.MinimockUpdateInspect()
		m.t.FailNow()
	}
}

// MinimockWait waits for all mocked methods to be called the expected number of times
func (m *IThingRepositoryMock) MinimockWait(timeout mm_time.Duration) {
	timeoutCh := mm_time.After(timeout)
	for {
		if m.minimockDone() {
			return
		}
		select {
		case <-timeoutCh:
			m.MinimockFinish()
			return
		case <-mm_time.After(10 * mm_time.Millisecond):
		}
	}
}

func (m *IThingRepositoryMock) minimockDone() bool {
	done := true
	return done &&
		m.MinimockAddDone() &&
		m.MinimockBeginTxDone() &&
		m.MinimockCommitTxDone() &&
		m.MinimockDeleteDone() &&
		m.MinimockGetDone() &&
		m.MinimockGetAllByPlaceIDDone() &&
		m.MinimockGetByPlaceIDDone() &&
		m.MinimockSearchDone() &&
		m.MinimockUpdateDone()
}
